# generated by datamodel-codegen:
#   filename:  appenginedomainmapping_v1alpha1.json
#   timestamp: 2024-03-15T04:51:10+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Optional[Spec] = None
    status: Optional[Status] = None


class ResourceRecord(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None,
        description="Relative name of the object affected by this record. Only applicable for CNAME records. Example: 'www'.",
    )
    rrdata: Optional[str] = Field(
        None,
        description='Data for this record. Values vary by record type, as defined in RFC 1035 (section 5) and RFC 1034 (section 3.6.1).',
    )
    type: Optional[str] = Field(
        None,
        description='Resource record type. Example: \'AAAA\'. Possible values: ["A", "AAAA", "CNAME"].',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    overrideStrategy: Optional[str] = Field(
        None,
        description='Whether the domain creation should override any existing mappings for this domain.\nBy default, overrides are rejected. Default value: "STRICT" Possible values: ["STRICT", "OVERRIDE"].',
    )
    project: Optional[str] = Field(None, description='Immutable.')
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The domainName of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    sslSettings: Optional[SslSettings] = Field(
        None,
        description='SSL configuration for this domain. If unconfigured, this domain will not serve with SSL.',
    )


class SslSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certificateId: Optional[str] = Field(
        None,
        description="ID of the AuthorizedCertificate resource configuring SSL for the application. Clearing this field will\nremove SSL support.\nBy default, a managed certificate is automatically created for every domain mapping. To omit SSL support\nor to configure SSL manually, specify 'SslManagementType.MANUAL' on a 'CREATE' or 'UPDATE' request. You must be\nauthorized to administer the 'AuthorizedCertificate' resource to manually map it to a DomainMapping resource.\nExample: 12345.",
    )
    pendingManagedCertificateId: Optional[str] = Field(
        None,
        description="ID of the managed 'AuthorizedCertificate' resource currently being provisioned, if applicable. Until the new\nmanaged certificate has been successfully provisioned, the previous SSL state will be preserved. Once the\nprovisioning process completes, the 'certificateId' field will reflect the new managed certificate and this\nfield will be left empty. To remove SSL support while there is still a pending managed certificate, clear the\n'certificateId' field with an update request.",
    )
    sslManagementType: str = Field(
        ...,
        description='SSL management type for this domain. If \'AUTOMATIC\', a managed certificate is automatically provisioned.\nIf \'MANUAL\', \'certificateId\' must be manually specified in order to configure SSL for this domain. Possible values: ["AUTOMATIC", "MANUAL"].',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    name: Optional[str] = Field(
        None,
        description='Full path to the DomainMapping resource in the API. Example: apps/myapp/domainMapping/example.com.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    resourceRecords: Optional[List[ResourceRecord]] = Field(
        None,
        description="The resource records required to configure this domain mapping. These records must be added to the domain's DNS\nconfiguration in order to serve the application via this domain mapping.",
    )
