# generated by datamodel-codegen:
#   filename:  appenginestandardappversion_v1alpha1.json
#   timestamp: 2024-03-15T04:51:12+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AutomaticScaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maxConcurrentRequests: Optional[int] = Field(
        None,
        description='Number of concurrent requests an automatic scaling instance can accept before the scheduler spawns a new instance.\n\nDefaults to a runtime-specific value.',
    )
    maxIdleInstances: Optional[int] = Field(
        None,
        description='Maximum number of idle instances that should be maintained for this version.',
    )
    maxPendingLatency: Optional[str] = Field(
        None,
        description='Maximum amount of time that a request should wait in the pending queue before starting a new instance to handle it.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    minIdleInstances: Optional[int] = Field(
        None,
        description='Minimum number of idle instances that should be maintained for this version. Only applicable for the default version of a service.',
    )
    minPendingLatency: Optional[str] = Field(
        None,
        description='Minimum amount of time a request should wait in the pending queue before starting a new instance to handle it.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    standardSchedulerSettings: Optional[StandardSchedulerSettings] = Field(
        None, description='Scheduler settings for standard environment.'
    )


class BasicScaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    idleTimeout: Optional[str] = Field(
        None,
        description='Duration of time after the last request that an instance must wait before the instance is shut down.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s". Defaults to 900s.',
    )
    maxInstances: int = Field(
        ...,
        description='Maximum number of instances to create for this version. Must be in the range [1.0, 200.0].',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Deployment(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    files: Optional[List[File]] = Field(
        None,
        description='Manifest of the files stored in Google Cloud Storage that are included as part of this version.\nAll files must be readable using the credentials supplied with this call.',
    )
    zip: Optional[Zip] = Field(None, description='Zip File.')


class Entrypoint(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    shell: str = Field(
        ...,
        description='The format should be a shell command that can be fed to bash -c.',
    )


class File(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: str
    sha1Sum: Optional[str] = Field(None, description='SHA1 checksum of the file.')
    sourceUrl: str = Field(..., description='Source URL.')


class Handler(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    authFailAction: Optional[str] = Field(
        None,
        description='Actions to take when the user is not logged in. Possible values: ["AUTH_FAIL_ACTION_REDIRECT", "AUTH_FAIL_ACTION_UNAUTHORIZED"].',
    )
    login: Optional[str] = Field(
        None,
        description='Methods to restrict access to a URL based on login status. Possible values: ["LOGIN_OPTIONAL", "LOGIN_ADMIN", "LOGIN_REQUIRED"].',
    )
    redirectHttpResponseCode: Optional[str] = Field(
        None,
        description='30x code to use when performing redirects for the secure field. Possible values: ["REDIRECT_HTTP_RESPONSE_CODE_301", "REDIRECT_HTTP_RESPONSE_CODE_302", "REDIRECT_HTTP_RESPONSE_CODE_303", "REDIRECT_HTTP_RESPONSE_CODE_307"].',
    )
    script: Optional[Script] = Field(
        None,
        description='Executes a script to handle the requests that match this URL pattern.\nOnly the auto value is supported for Node.js in the App Engine standard environment, for example "script:" "auto".',
    )
    securityLevel: Optional[str] = Field(
        None,
        description='Security (HTTPS) enforcement for this URL. Possible values: ["SECURE_DEFAULT", "SECURE_NEVER", "SECURE_OPTIONAL", "SECURE_ALWAYS"].',
    )
    staticFiles: Optional[StaticFiles] = Field(
        None,
        description='Files served directly to the user for a given URL, such as images, CSS stylesheets, or JavaScript source files. Static file handlers describe which files in the application directory are static files, and which URLs serve them.',
    )
    urlRegex: Optional[str] = Field(
        None,
        description='URL prefix. Uses regular expression syntax, which means regexp special characters must be escaped, but should not contain groupings.\nAll URLs that begin with this prefix are handled by this handler, using the portion of the URL after the prefix as part of the file path.',
    )


class Library(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None, description='Name of the library. Example "django".'
    )
    version: Optional[str] = Field(
        None, description='Version of the library to select, or "latest".'
    )


class ManualScaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    instances: int = Field(
        ...,
        description='Number of instances to assign to the service at the start.\n\n**Note:** When managing the number of instances at runtime through the App Engine Admin API or the (now deprecated) Python 2\nModules API set_num_instances() you must use \'lifecycle.ignore_changes = ["manual_scaling"[0].instances]\' to prevent drift detection.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Script(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    scriptPath: str = Field(
        ..., description='Path to the script from the application root directory.'
    )


class ServiceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of an `AppEngineService` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of an `AppEngineService` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    appEngineApis: Optional[bool] = Field(
        None,
        description='Allows App Engine second generation runtimes to access the legacy bundled services.',
    )
    automaticScaling: Optional[AutomaticScaling] = Field(
        None,
        description='Automatic scaling is based on request rate, response latencies, and other application metrics.',
    )
    basicScaling: Optional[BasicScaling] = Field(
        None,
        description='Basic scaling creates instances when your application receives requests. Each instance will be shut down when the application becomes idle. Basic scaling is ideal for work that is intermittent or driven by user activity.',
    )
    deleteServiceOnDestroy: Optional[bool] = Field(
        None,
        description="If set to 'true', the service will be deleted if it is the last version.",
    )
    deployment: Deployment = Field(
        ..., description='Code and application artifacts that make up this version.'
    )
    entrypoint: Entrypoint = Field(
        ..., description='The entrypoint for the application.'
    )
    envVariables: Optional[Dict[str, str]] = Field(
        None, description='Environment variables available to the application.'
    )
    handlers: Optional[List[Handler]] = Field(
        None,
        description='An ordered list of URL-matching patterns that should be applied to incoming requests.\nThe first matching URL handles the request and other request handlers are not attempted.',
    )
    inboundServices: Optional[List[str]] = Field(
        None,
        description='A list of the types of messages that this application is able to receive. Possible values: ["INBOUND_SERVICE_MAIL", "INBOUND_SERVICE_MAIL_BOUNCE", "INBOUND_SERVICE_XMPP_ERROR", "INBOUND_SERVICE_XMPP_MESSAGE", "INBOUND_SERVICE_XMPP_SUBSCRIBE", "INBOUND_SERVICE_XMPP_PRESENCE", "INBOUND_SERVICE_CHANNEL_PRESENCE", "INBOUND_SERVICE_WARMUP"].',
    )
    instanceClass: Optional[str] = Field(
        None,
        description='Instance class that is used to run this version. Valid values are\nAutomaticScaling: F1, F2, F4, F4_1G\nBasicScaling or ManualScaling: B1, B2, B4, B4_1G, B8\nDefaults to F1 for AutomaticScaling and B2 for ManualScaling and BasicScaling. If no scaling is specified, AutomaticScaling is chosen.',
    )
    libraries: Optional[List[Library]] = Field(
        None,
        description='Configuration for third-party Python runtime libraries that are required by the application.',
    )
    manualScaling: Optional[ManualScaling] = Field(
        None,
        description='A service with manual scaling runs continuously, allowing you to perform complex initialization and rely on the state of its memory over time.',
    )
    noopOnDestroy: Optional[bool] = Field(
        None,
        description="If set to 'true', the application version will not be deleted.",
    )
    project: Optional[str] = Field(None, description='Immutable.')
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The versionId of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    runtime: str = Field(..., description='Desired runtime. Example python27.')
    runtimeApiVersion: Optional[str] = Field(
        None,
        description="The version of the API in the given runtime environment.\nPlease see the app.yaml reference for valid values at 'https://cloud.google.com/appengine/docs/standard/<language>/config/appref'\\\nSubstitute '<language>' with 'python', 'java', 'php', 'ruby', 'go' or 'nodejs'.",
    )
    serviceAccount: Optional[str] = Field(
        None,
        description='The identity that the deployed version will run as. Admin API will use the App Engine Appspot service account as default if this field is neither provided in app.yaml file nor through CLI flag.',
    )
    serviceRef: Union[ServiceRef, ServiceRef1]
    threadsafe: Optional[bool] = Field(
        None,
        description='Whether multiple requests can be dispatched to this version at once.',
    )
    vpcAccessConnector: Optional[VpcAccessConnector] = Field(
        None, description='Enables VPC connectivity for standard apps.'
    )


class StandardSchedulerSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maxInstances: Optional[int] = Field(
        None,
        description='Maximum number of instances to run for this version. Set to zero to disable maxInstances configuration.',
    )
    minInstances: Optional[int] = Field(
        None,
        description='Minimum number of instances to run for this version. Set to zero to disable minInstances configuration.',
    )
    targetCpuUtilization: Optional[float] = Field(
        None,
        description='Target CPU utilization ratio to maintain when scaling. Should be a value in the range [0.50, 0.95], zero, or a negative value.',
    )
    targetThroughputUtilization: Optional[float] = Field(
        None,
        description='Target throughput utilization ratio to maintain when scaling. Should be a value in the range [0.50, 0.95], zero, or a negative value.',
    )


class StaticFiles(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    applicationReadable: Optional[bool] = Field(
        None,
        description='Whether files should also be uploaded as code data. By default, files declared in static file handlers are uploaded as\nstatic data and are only served to end users; they cannot be read by the application. If enabled, uploads are charged\nagainst both your code and static data storage resource quotas.',
    )
    expiration: Optional[str] = Field(
        None,
        description='Time a static file served by this handler should be cached by web proxies and browsers.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example "3.5s".',
    )
    httpHeaders: Optional[Dict[str, str]] = Field(
        None,
        description='HTTP headers to use for all responses from these URLs.\nAn object containing a list of "key:value" value pairs.".',
    )
    mimeType: Optional[str] = Field(
        None,
        description="MIME type used to serve all files served by this handler.\nDefaults to file-specific MIME types, which are derived from each file's filename extension.",
    )
    path: Optional[str] = Field(
        None,
        description='Path to the static files matched by the URL pattern, from the application root directory. The path can refer to text matched in groupings in the URL pattern.',
    )
    requireMatchingFile: Optional[bool] = Field(
        None,
        description='Whether this handler should match the request if the file referenced by the handler does not exist.',
    )
    uploadPathRegex: Optional[str] = Field(
        None,
        description='Regular expression that matches the file paths for all files that should be referenced by this handler.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    name: Optional[str] = Field(
        None, description='Full path to the Version resource in the API. Example, "v1".'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )


class VpcAccessConnector(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    egressSetting: Optional[str] = Field(
        None,
        description='The egress setting for the connector, controlling what traffic is diverted through it.',
    )
    name: str = Field(
        ...,
        description='Full Serverless VPC Access Connector name e.g. /projects/my-project/locations/us-central1/connectors/c1.',
    )


class Zip(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    filesCount: Optional[int] = Field(None, description='files count.')
    sourceUrl: str = Field(..., description='Source URL.')
