# generated by datamodel-codegen:
#   filename:  artifactregistryrepository_v1beta1.json
#   timestamp: 2024-03-15T04:51:12+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class CleanupPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    action: Optional[str] = Field(
        None, description='Policy action. Possible values: ["DELETE", "KEEP"].'
    )
    condition: Optional[Condition] = Field(
        None, description='Policy condition for matching versions.'
    )
    id: str
    mostRecentVersions: Optional[MostRecentVersions] = Field(
        None,
        description='Policy condition for retaining a minimum number of versions. May only be\nspecified with a Keep action.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    newerThan: Optional[str] = Field(
        None, description='Match versions newer than a duration.'
    )
    olderThan: Optional[str] = Field(
        None, description='Match versions older than a duration.'
    )
    packageNamePrefixes: Optional[List[str]] = Field(
        None,
        description='Match versions by package prefix. Applied on any prefix match.',
    )
    tagPrefixes: Optional[List[str]] = Field(
        None, description='Match versions by tag prefix. Applied on any prefix match.'
    )
    tagState: Optional[str] = Field(
        None,
        description='Match versions by tag status. Default value: "ANY" Possible values: ["TAGGED", "UNTAGGED", "ANY"].',
    )
    versionNamePrefixes: Optional[List[str]] = Field(
        None,
        description='Match versions by version name prefix. Applied on any prefix match.',
    )


class Condition1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class DockerConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    immutableTags: Optional[bool] = Field(
        None,
        description='The repository which enabled this flag prevents all tags from being modified, moved or deleted. This does not prevent tags from being created.',
    )


class DockerRepository(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicRepository: Optional[str] = Field(
        None,
        description='Immutable. Address of the remote repository. Default value: "DOCKER_HUB" Possible values: ["DOCKER_HUB"].',
    )


class KmsKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class MavenConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowSnapshotOverwrites: Optional[bool] = Field(
        None,
        description='Immutable. The repository with this flag will allow publishing the same\nsnapshot versions.',
    )
    versionPolicy: Optional[str] = Field(
        None,
        description='Immutable. Version policy defines the versions that the registry will accept. Default value: "VERSION_POLICY_UNSPECIFIED" Possible values: ["VERSION_POLICY_UNSPECIFIED", "RELEASE", "SNAPSHOT"].',
    )


class MavenRepository(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicRepository: Optional[str] = Field(
        None,
        description='Immutable. Address of the remote repository. Default value: "MAVEN_CENTRAL" Possible values: ["MAVEN_CENTRAL"].',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class MostRecentVersions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    keepCount: Optional[int] = Field(
        None, description='Minimum number of versions to keep.'
    )
    packageNamePrefixes: Optional[List[str]] = Field(
        None,
        description='Match versions by package prefix. Applied on any prefix match.',
    )


class NpmRepository(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicRepository: Optional[str] = Field(
        None,
        description='Immutable. Address of the remote repository. Default value: "NPMJS" Possible values: ["NPMJS"].',
    )


class PythonRepository(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicRepository: Optional[str] = Field(
        None,
        description='Immutable. Address of the remote repository. Default value: "PYPI" Possible values: ["PYPI"].',
    )


class RemoteRepositoryConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None, description='Immutable. The description of the remote source.'
    )
    dockerRepository: Optional[DockerRepository] = Field(
        None, description='Immutable. Specific settings for a Docker remote repository.'
    )
    mavenRepository: Optional[MavenRepository] = Field(
        None, description='Immutable. Specific settings for a Maven remote repository.'
    )
    npmRepository: Optional[NpmRepository] = Field(
        None, description='Immutable. Specific settings for an Npm remote repository.'
    )
    pythonRepository: Optional[PythonRepository] = Field(
        None, description='Immutable. Specific settings for a Python remote repository.'
    )


class RepositoryRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/locations/{{location}}/repositories/{{value}}`, where {{value}} is the `name` field of an `ArtifactRegistryRepository` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepositoryRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/locations/{{location}}/repositories/{{value}}`, where {{value}} is the `name` field of an `ArtifactRegistryRepository` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cleanupPolicies: Optional[List[CleanupPolicy]] = Field(
        None,
        description='Cleanup policies for this repository. Cleanup policies indicate when\ncertain package versions can be automatically deleted.\nMap keys are policy IDs supplied by users during policy creation. They must\nunique within a repository and be under 128 characters in length.',
    )
    cleanupPolicyDryRun: Optional[bool] = Field(
        None,
        description='If true, the cleanup pipeline is prevented from deleting versions in this\nrepository.',
    )
    description: Optional[str] = Field(
        None, description='The user-provided description of the repository.'
    )
    dockerConfig: Optional[DockerConfig] = Field(
        None,
        description='Docker repository config contains repository level configuration for the repositories of docker type.',
    )
    format: str = Field(
        ...,
        description='Immutable. The format of packages that are stored in the repository. Supported formats\ncan be found [here](https://cloud.google.com/artifact-registry/docs/supported-formats).\nYou can only create alpha formats if you are a member of the\n[alpha user group](https://cloud.google.com/artifact-registry/docs/supported-formats#alpha-access).',
    )
    kmsKeyRef: Optional[Union[KmsKeyRef, KmsKeyRef1]] = Field(
        None,
        description='The customer managed encryption key that’s used to encrypt the\ncontents of the Repository.',
    )
    location: str = Field(
        ...,
        description='Immutable. The name of the location this repository is located in.',
    )
    mavenConfig: Optional[MavenConfig] = Field(
        None,
        description='MavenRepositoryConfig is maven related repository details.\nProvides additional configuration details for repositories of the maven\nformat type.',
    )
    mode: Optional[str] = Field(
        None,
        description='Immutable. The mode configures the repository to serve artifacts from different sources. Default value: "STANDARD_REPOSITORY" Possible values: ["STANDARD_REPOSITORY", "VIRTUAL_REPOSITORY", "REMOTE_REPOSITORY"].',
    )
    remoteRepositoryConfig: Optional[RemoteRepositoryConfig] = Field(
        None, description='Immutable. Configuration specific for a Remote Repository.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The repositoryId of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    virtualRepositoryConfig: Optional[VirtualRepositoryConfig] = Field(
        None, description='Configuration specific for a Virtual Repository.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition1]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None, description='The time when the repository was created.'
    )
    name: Optional[str] = Field(
        None, description='The name of the repository, for example:\n"repo1".'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    updateTime: Optional[str] = Field(
        None, description='The time when the repository was last updated.'
    )


class UpstreamPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Optional[str] = Field(
        None, description='The user-provided ID of the upstream policy.'
    )
    priority: Optional[int] = Field(
        None,
        description='Entries with a greater priority value take precedence in the pull order.',
    )
    repositoryRef: Optional[Union[RepositoryRef, RepositoryRef1]] = Field(
        None,
        description='A reference to the repository resource, for example:\n"projects/p1/locations/us-central1/repositories/repo1".',
    )


class VirtualRepositoryConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    upstreamPolicies: Optional[List[UpstreamPolicy]] = Field(
        None,
        description='Policies that configure the upstream artifacts distributed by the Virtual\nRepository. Upstream policies cannot be set on a standard repository.',
    )
