# generated by datamodel-codegen:
#   filename:  bigqueryanalyticshublisting_v1alpha1.json
#   timestamp: 2024-03-15T04:51:14+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class BigqueryDataset(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    dataset: str = Field(
        ...,
        description='Resource name of the dataset source for this listing. e.g. projects/myproject/datasets/123.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class DataProvider(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: str = Field(..., description='Name of the data provider.')
    primaryContact: Optional[str] = Field(
        None, description='Email or URL of the data provider.'
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Publisher(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: str = Field(..., description='Name of the listing publisher.')
    primaryContact: Optional[str] = Field(
        None, description='Email or URL of the listing publisher.'
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bigqueryDataset: BigqueryDataset = Field(
        ..., description='Shared dataset i.e. BigQuery dataset source.'
    )
    categories: Optional[List[str]] = Field(
        None, description='Categories of the listing. Up to two categories are allowed.'
    )
    dataExchangeId: str = Field(
        ...,
        description='Immutable. The ID of the data exchange. Must contain only Unicode letters, numbers (0-9), underscores (_). Should not use characters that require URL-escaping, or characters outside of ASCII, spaces.',
    )
    dataProvider: Optional[DataProvider] = Field(
        None, description='Details of the data provider who owns the source data.'
    )
    description: Optional[str] = Field(
        None,
        description='Short description of the listing. The description must not contain Unicode non-characters and C0 and C1 control codes except tabs (HT), new lines (LF), carriage returns (CR), and page breaks (FF).',
    )
    displayName: str = Field(
        ...,
        description="Human-readable display name of the listing. The display name must contain only Unicode letters, numbers (0-9), underscores (_), dashes (-), spaces ( ), ampersands (&) and can't start or end with spaces.",
    )
    documentation: Optional[str] = Field(
        None, description='Documentation describing the listing.'
    )
    icon: Optional[str] = Field(
        None, description='Base64 encoded image representing the listing.'
    )
    location: str = Field(
        ...,
        description='Immutable. The name of the location this data exchange listing.',
    )
    primaryContact: Optional[str] = Field(
        None, description='Email or URL of the primary point of contact of the listing.'
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    publisher: Optional[Publisher] = Field(
        None,
        description='Details of the publisher who owns the listing and who can share the source data.',
    )
    requestAccess: Optional[str] = Field(
        None,
        description='Email or URL of the request access of the listing. Subscribers can use this reference to request access.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The listingId of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    name: Optional[str] = Field(
        None,
        description='The resource name of the listing. e.g. "projects/myproject/locations/US/dataExchanges/123/listings/456".',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
