# generated by datamodel-codegen:
#   filename:  bigqueryjob_v1beta1.json
#   timestamp: 2024-03-15T04:51:17+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Copy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    createDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies whether the job is allowed to create new tables. The following values are supported:\nCREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table.\nCREATE_NEVER: The table must already exist. If it does not, a \'notFound\' error is returned in the job result.\nCreation, truncation and append actions occur as one atomic update upon job completion Default value: "CREATE_NEVER" Possible values: ["CREATE_IF_NEEDED", "CREATE_NEVER"].',
    )
    destinationEncryptionConfiguration: Optional[DestinationEncryptionConfiguration] = (
        Field(
            None,
            description='Immutable. Custom encryption configuration (e.g., Cloud KMS keys).',
        )
    )
    destinationTable: Optional[DestinationTable] = Field(
        None, description='Immutable. The destination table.'
    )
    sourceTables: List[SourceTable] = Field(
        ..., description='Immutable. Source tables to copy.'
    )
    writeDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies the action that occurs if the destination table already exists. The following values are supported:\nWRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data and uses the schema from the query result.\nWRITE_APPEND: If the table already exists, BigQuery appends the data to the table.\nWRITE_EMPTY: If the table already exists and contains data, a \'duplicate\' error is returned in the job result.\nEach action is atomic and only occurs if BigQuery is able to complete the job successfully.\nCreation, truncation and append actions occur as one atomic update upon job completion. Default value: "WRITE_EMPTY" Possible values: ["WRITE_TRUNCATE", "WRITE_APPEND", "WRITE_EMPTY"].',
    )


class DatasetRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryDataset` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class DatasetRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryDataset` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class DefaultDataset(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    datasetRef: Union[DatasetRef, DatasetRef1] = Field(
        ..., description='A reference to the dataset.'
    )


class DestinationEncryptionConfiguration(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef, KmsKeyRef1] = Field(
        ...,
        description='Describes the Cloud KMS encryption key that will be used to protect\ndestination BigQuery table. The BigQuery Service Account associated\nwith your project requires access to this encryption key.',
    )
    kmsKeyVersion: Optional[str] = Field(
        None,
        description='Describes the Cloud KMS encryption key version used to protect destination BigQuery table.',
    )


class DestinationEncryptionConfiguration1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef2, KmsKeyRef3] = Field(
        ...,
        description='Describes the Cloud KMS encryption key that will be used to protect\ndestination BigQuery table. The BigQuery Service Account associated\nwith your project requires access to this encryption key.',
    )
    kmsKeyVersion: Optional[str] = Field(
        None,
        description='Describes the Cloud KMS encryption key version used to protect destination BigQuery table.',
    )


class DestinationEncryptionConfiguration2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef4, KmsKeyRef5] = Field(
        ...,
        description='Describes the Cloud KMS encryption key that will be used to protect\ndestination BigQuery table. The BigQuery Service Account associated\nwith your project requires access to this encryption key.',
    )
    kmsKeyVersion: Optional[str] = Field(
        None,
        description='Describes the Cloud KMS encryption key version used to protect destination BigQuery table.',
    )


class DestinationTable(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tableRef: Union[TableRef, TableRef1] = Field(
        ..., description='A reference to the table.'
    )


class DestinationTable1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tableRef: Union[TableRef6, TableRef7] = Field(
        ..., description='A reference to the table.'
    )


class DestinationTable2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tableRef: Union[TableRef8, TableRef9] = Field(
        ..., description='A reference to the table.'
    )


class Error(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    location: Optional[str] = Field(
        None, description='Specifies where the error occurred, if present.'
    )
    message: Optional[str] = Field(
        None, description='A human-readable description of the error.'
    )
    reason: Optional[str] = Field(
        None, description='A short error code that summarizes the error.'
    )


class ErrorResultItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    location: Optional[str] = Field(
        None, description='Specifies where the error occurred, if present.'
    )
    message: Optional[str] = Field(
        None, description='A human-readable description of the error.'
    )
    reason: Optional[str] = Field(
        None, description='A short error code that summarizes the error.'
    )


class Extract(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    compression: Optional[str] = Field(
        None,
        description='Immutable. The compression type to use for exported files. Possible values include GZIP, DEFLATE, SNAPPY, and NONE.\nThe default value is NONE. DEFLATE and SNAPPY are only supported for Avro.',
    )
    destinationFormat: Optional[str] = Field(
        None,
        description='Immutable. The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO for tables and SAVED_MODEL for models.\nThe default value for tables is CSV. Tables with nested or repeated fields cannot be exported as CSV.\nThe default value for models is SAVED_MODEL.',
    )
    destinationUris: List[str] = Field(
        ...,
        description='Immutable. A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.',
    )
    fieldDelimiter: Optional[str] = Field(
        None,
        description="Immutable. When extracting data in CSV format, this defines the delimiter to use between fields in the exported data.\nDefault is ','.",
    )
    printHeader: Optional[bool] = Field(
        None,
        description='Immutable. Whether to print out a header row in the results. Default is true.',
    )
    sourceTable: Optional[SourceTable1] = Field(
        None, description='Immutable. A reference to the table being exported.'
    )
    useAvroLogicalTypes: Optional[bool] = Field(
        None,
        description='Immutable. Whether to use logical types when extracting to AVRO format.',
    )


class KmsKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Load(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowJaggedRows: Optional[bool] = Field(
        None,
        description='Immutable. Accept rows that are missing trailing optional columns. The missing values are treated as nulls.\nIf false, records with missing trailing columns are treated as bad records, and if there are too many bad records,\nan invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.',
    )
    allowQuotedNewlines: Optional[bool] = Field(
        None,
        description='Immutable. Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file.\nThe default value is false.',
    )
    autodetect: Optional[bool] = Field(
        None,
        description='Immutable. Indicates if we should automatically infer the options and schema for CSV and JSON sources.',
    )
    createDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies whether the job is allowed to create new tables. The following values are supported:\nCREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table.\nCREATE_NEVER: The table must already exist. If it does not, a \'notFound\' error is returned in the job result.\nCreation, truncation and append actions occur as one atomic update upon job completion Default value: "CREATE_NEVER" Possible values: ["CREATE_IF_NEEDED", "CREATE_NEVER"].',
    )
    destinationEncryptionConfiguration: Optional[
        DestinationEncryptionConfiguration1
    ] = Field(
        None,
        description='Immutable. Custom encryption configuration (e.g., Cloud KMS keys).',
    )
    destinationTable: DestinationTable1 = Field(
        ..., description='Immutable. The destination table to load the data into.'
    )
    encoding: Optional[str] = Field(
        None,
        description='Immutable. The character encoding of the data. The supported values are UTF-8 or ISO-8859-1.\nThe default value is UTF-8. BigQuery decodes the data after the raw, binary data\nhas been split using the values of the quote and fieldDelimiter properties.',
    )
    fieldDelimiter: Optional[str] = Field(
        None,
        description='Immutable. The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character.\nTo use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts\nthe string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the\ndata in its raw, binary state. BigQuery also supports the escape sequence "\\t" to specify a tab separator.\nThe default value is a comma (\',\').',
    )
    ignoreUnknownValues: Optional[bool] = Field(
        None,
        description="Immutable. Indicates if BigQuery should allow extra values that are not represented in the table schema.\nIf true, the extra values are ignored. If false, records with extra columns are treated as bad records,\nand if there are too many bad records, an invalid error is returned in the job result.\nThe default value is false. The sourceFormat property determines what BigQuery treats as an extra value:\nCSV: Trailing columns\nJSON: Named values that don't match any column names.",
    )
    jsonExtension: Optional[str] = Field(
        None,
        description='Immutable. If sourceFormat is set to newline-delimited JSON, indicates whether it should be processed as a JSON variant such as GeoJSON.\nFor a sourceFormat other than JSON, omit this field. If the sourceFormat is newline-delimited JSON: - for newline-delimited\nGeoJSON: set to GEOJSON.',
    )
    maxBadRecords: Optional[int] = Field(
        None,
        description='Immutable. The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value,\nan invalid error is returned in the job result. The default value is 0, which requires that all records are valid.',
    )
    nullMarker: Optional[str] = Field(
        None,
        description='Immutable. Specifies a string that represents a null value in a CSV file. For example, if you specify "\\N", BigQuery interprets "\\N" as a null value\nwhen loading a CSV file. The default value is the empty string. If you set this property to a custom value, BigQuery throws an error if an\nempty string is present for all data types except for STRING and BYTE. For STRING and BYTE columns, BigQuery interprets the empty string as\nan empty value.',
    )
    parquetOptions: Optional[ParquetOptions] = Field(
        None,
        description='Immutable. Parquet Options for load and make external tables.',
    )
    projectionFields: Optional[List[str]] = Field(
        None,
        description='Immutable. If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup.\nProperty names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties.\nIf any named property isn\'t found in the Cloud Datastore backup, an invalid error is returned in the job result.',
    )
    quote: Optional[str] = Field(
        None,
        description='Immutable. The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding,\nand then uses the first byte of the encoded string to split the data in its raw, binary state.\nThe default value is a double-quote (\'"\'). If your data does not contain quoted sections, set the property value to an empty string.\nIf your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.',
    )
    schemaUpdateOptions: Optional[List[str]] = Field(
        None,
        description='Immutable. Allows the schema of the destination table to be updated as a side effect of the load job if a schema is autodetected or\nsupplied in the job configuration. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND;\nwhen writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators.\nFor normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified:\nALLOW_FIELD_ADDITION: allow adding a nullable field to the schema.\nALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.',
    )
    skipLeadingRows: Optional[int] = Field(
        None,
        description='Immutable. The number of rows at the top of a CSV file that BigQuery will skip when loading the data.\nThe default value is 0. This property is useful if you have header rows in the file that should be skipped.\nWhen autodetect is on, the behavior is the following:\nskipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected,\nthe row is read as data. Otherwise data is read starting from the second row.\nskipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row.\nskipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected,\nrow N is just skipped. Otherwise row N is used to extract column names for the detected schema.',
    )
    sourceFormat: Optional[str] = Field(
        None,
        description='Immutable. The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP".\nFor newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". For parquet, specify "PARQUET".\nFor orc, specify "ORC". [Beta] For Bigtable, specify "BIGTABLE".\nThe default value is CSV.',
    )
    sourceUris: List[str] = Field(
        ...,
        description="Immutable. The fully-qualified URIs that point to your data in Google Cloud.\nFor Google Cloud Storage URIs: Each URI can contain one '\\*' wildcard character\nand it must come after the 'bucket' name. Size limits related to load jobs apply\nto external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be\nspecified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table.\nFor Google Cloud Datastore backups: Exactly one URI can be specified. Also, the '\\*' wildcard character is not allowed.",
    )
    timePartitioning: Optional[TimePartitioning] = Field(
        None,
        description='Immutable. Time-based partitioning specification for the destination table.',
    )
    writeDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies the action that occurs if the destination table already exists. The following values are supported:\nWRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data and uses the schema from the query result.\nWRITE_APPEND: If the table already exists, BigQuery appends the data to the table.\nWRITE_EMPTY: If the table already exists and contains data, a \'duplicate\' error is returned in the job result.\nEach action is atomic and only occurs if BigQuery is able to complete the job successfully.\nCreation, truncation and append actions occur as one atomic update upon job completion. Default value: "WRITE_EMPTY" Possible values: ["WRITE_TRUNCATE", "WRITE_APPEND", "WRITE_EMPTY"].',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Optional[Spec] = None
    status: Optional[Status] = None


class ParquetOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableListInference: Optional[bool] = Field(
        None,
        description='Immutable. If sourceFormat is set to PARQUET, indicates whether to use schema inference specifically for Parquet LIST logical type.',
    )
    enumAsString: Optional[bool] = Field(
        None,
        description='Immutable. If sourceFormat is set to PARQUET, indicates whether to infer Parquet ENUM logical type as STRING instead of BYTES by default.',
    )


class Query(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowLargeResults: Optional[bool] = Field(
        None,
        description='Immutable. If true and query uses legacy SQL dialect, allows the query to produce arbitrarily large result tables at a slight cost in performance.\nRequires destinationTable to be set. For standard SQL queries, this flag is ignored and large results are always allowed.\nHowever, you must still set destinationTable when result size exceeds the allowed maximum response size.',
    )
    createDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies whether the job is allowed to create new tables. The following values are supported:\nCREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table.\nCREATE_NEVER: The table must already exist. If it does not, a \'notFound\' error is returned in the job result.\nCreation, truncation and append actions occur as one atomic update upon job completion Default value: "CREATE_NEVER" Possible values: ["CREATE_IF_NEEDED", "CREATE_NEVER"].',
    )
    defaultDataset: Optional[DefaultDataset] = Field(
        None,
        description='Immutable. Specifies the default dataset to use for unqualified table names in the query. Note that this does not alter behavior of unqualified dataset names.',
    )
    destinationEncryptionConfiguration: Optional[
        DestinationEncryptionConfiguration2
    ] = Field(
        None,
        description='Immutable. Custom encryption configuration (e.g., Cloud KMS keys).',
    )
    destinationTable: Optional[DestinationTable2] = Field(
        None,
        description='Immutable. Describes the table where the query results should be stored.\nThis property must be set for large results that exceed the maximum response size.\nFor queries that produce anonymous (cached) results, this field will be populated by BigQuery.',
    )
    flattenResults: Optional[bool] = Field(
        None,
        description='Immutable. If true and query uses legacy SQL dialect, flattens all nested and repeated fields in the query results.\nallowLargeResults must be true if this is set to false. For standard SQL queries, this flag is ignored and results are never flattened.',
    )
    maximumBillingTier: Optional[int] = Field(
        None,
        description='Immutable. Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge).\nIf unspecified, this will be set to your project default.',
    )
    maximumBytesBilled: Optional[str] = Field(
        None,
        description='Immutable. Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge).\nIf unspecified, this will be set to your project default.',
    )
    parameterMode: Optional[str] = Field(
        None,
        description='Immutable. Standard SQL only. Set to POSITIONAL to use positional (?) query parameters or to NAMED to use named (@myparam) query parameters in this query.',
    )
    priority: Optional[str] = Field(
        None,
        description='Immutable. Specifies a priority for the query. Default value: "INTERACTIVE" Possible values: ["INTERACTIVE", "BATCH"].',
    )
    query: str = Field(
        ...,
        description='Immutable. SQL query text to execute. The useLegacySql field can be used to indicate whether the query uses legacy SQL or standard SQL.\n*NOTE*: queries containing [DML language](https://cloud.google.com/bigquery/docs/reference/standard-sql/data-manipulation-language)\n(\'DELETE\', \'UPDATE\', \'MERGE\', \'INSERT\') must specify \'create_disposition = ""\' and \'write_disposition = ""\'.',
    )
    schemaUpdateOptions: Optional[List[str]] = Field(
        None,
        description='Immutable. Allows the schema of the destination table to be updated as a side effect of the query job.\nSchema update options are supported in two cases: when writeDisposition is WRITE_APPEND;\nwhen writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table,\nspecified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema.\nOne or more of the following values are specified:\nALLOW_FIELD_ADDITION: allow adding a nullable field to the schema.\nALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.',
    )
    scriptOptions: Optional[ScriptOptions] = Field(
        None, description='Immutable. Options controlling the execution of scripts.'
    )
    useLegacySql: Optional[bool] = Field(
        None,
        description="Immutable. Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true.\nIf set to false, the query will use BigQuery's standard SQL.",
    )
    useQueryCache: Optional[bool] = Field(
        None,
        description='Immutable. Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever\ntables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified.\nThe default value is true.',
    )
    userDefinedFunctionResources: Optional[List[UserDefinedFunctionResource]] = Field(
        None,
        description='Immutable. Describes user-defined function resources used in the query.',
    )
    writeDisposition: Optional[str] = Field(
        None,
        description='Immutable. Specifies the action that occurs if the destination table already exists. The following values are supported:\nWRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data and uses the schema from the query result.\nWRITE_APPEND: If the table already exists, BigQuery appends the data to the table.\nWRITE_EMPTY: If the table already exists and contains data, a \'duplicate\' error is returned in the job result.\nEach action is atomic and only occurs if BigQuery is able to complete the job successfully.\nCreation, truncation and append actions occur as one atomic update upon job completion. Default value: "WRITE_EMPTY" Possible values: ["WRITE_TRUNCATE", "WRITE_APPEND", "WRITE_EMPTY"].',
    )


class ScriptOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    keyResultStatement: Optional[str] = Field(
        None,
        description='Immutable. Determines which statement in the script represents the "key result",\nused to populate the schema and query results of the script job. Possible values: ["LAST", "FIRST_SELECT"].',
    )
    statementByteBudget: Optional[str] = Field(
        None,
        description='Immutable. Limit on the number of bytes billed per statement. Exceeding this budget results in an error.',
    )
    statementTimeoutMs: Optional[str] = Field(
        None, description='Immutable. Timeout period for each statement in a script.'
    )


class SourceTable(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tableRef: Union[TableRef2, TableRef3] = Field(
        ..., description='A reference to the table.'
    )


class SourceTable1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tableRef: Union[TableRef4, TableRef5] = Field(
        ..., description='A reference to the table.'
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    copy_: Optional[Copy] = Field(
        None, alias='copy', description='Immutable. Copies a table.'
    )
    extract: Optional[Extract] = Field(
        None, description='Immutable. Configures an extract job.'
    )
    jobTimeoutMs: Optional[str] = Field(
        None,
        description='Immutable. Job timeout in milliseconds. If this time limit is exceeded, BigQuery may attempt to terminate the job.',
    )
    load: Optional[Load] = Field(None, description='Immutable. Configures a load job.')
    location: Optional[str] = Field(
        None,
        description='Immutable. The geographic location of the job. The default value is US.',
    )
    query: Optional[Query] = Field(
        None, description='Immutable. Configures a query job.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The jobId of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    jobType: Optional[str] = Field(None, description='The type of the job.')
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    status: Optional[List[StatusItem]] = Field(
        None,
        description='The status of this job. Examine this value when polling an asynchronous job to see if the job is complete.',
    )
    userEmail: Optional[str] = Field(
        None, description='Email address of the user who ran the job.'
    )


class StatusItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    errorResult: Optional[List[ErrorResultItem]] = Field(
        None,
        description='Final error result of the job. If present, indicates that the job has completed and was unsuccessful.',
    )
    errors: Optional[List[Error]] = Field(
        None,
        description='The first errors encountered during the running of the job. The final message\nincludes the number of errors that caused the process to stop. Errors here do\nnot necessarily mean that the job has not completed or was unsuccessful.',
    )
    state: Optional[str] = Field(
        None,
        description="Running state of the job. Valid states include 'PENDING', 'RUNNING', and 'DONE'.",
    )


class TableRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef6(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef7(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef8(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TableRef9(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `BigQueryTable` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TimePartitioning(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    expirationMs: Optional[str] = Field(
        None,
        description='Immutable. Number of milliseconds for which to keep the storage for a partition. A wrapper is used here because 0 is an invalid value.',
    )
    field: Optional[str] = Field(
        None,
        description="Immutable. If not set, the table is partitioned by pseudo column '_PARTITIONTIME'; if set, the table is partitioned by this field.\nThe field must be a top-level TIMESTAMP or DATE field. Its mode must be NULLABLE or REQUIRED.\nA wrapper is used here because an empty string is an invalid value.",
    )
    type: str = Field(
        ...,
        description='Immutable. The only type supported is DAY, which will generate one partition per day. Providing an empty string used to cause an error,\nbut in OnePlatform the field will be treated as unset.',
    )


class UserDefinedFunctionResource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    inlineCode: Optional[str] = Field(
        None,
        description='Immutable. An inline resource that contains code for a user-defined function (UDF).\nProviding a inline code resource is equivalent to providing a URI for a file containing the same code.',
    )
    resourceUri: Optional[str] = Field(
        None,
        description='Immutable. A code resource to load from a Google Cloud Storage URI (gs://bucket/path).',
    )
