# generated by datamodel-codegen:
#   filename:  cloudbuildtrigger_v1beta1.json
#   timestamp: 2024-03-15T04:51:26+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class ApprovalConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    approvalRequired: Optional[bool] = Field(
        None,
        description='Whether or not approval is needed. If this is set on a build, it will become pending when run,\nand will need to be explicitly approved to start.',
    )


class Artifacts(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    images: Optional[List[str]] = Field(
        None,
        description="A list of images to be pushed upon the successful completion of all build steps.\n\nThe images will be pushed using the builder service account's credentials.\n\nThe digests of the pushed images will be stored in the Build resource's results field.\n\nIf any of the images fail to be pushed, the build is marked FAILURE.",
    )
    objects: Optional[Objects] = Field(
        None,
        description="A list of objects to be uploaded to Cloud Storage upon successful completion of all build steps.\n\nFiles in the workspace matching specified paths globs will be uploaded to the\nCloud Storage location using the builder service account's credentials.\n\nThe location and generation of the uploaded objects will be stored in the Build resource's results field.\n\nIf any objects fail to be pushed, the build is marked FAILURE.",
    )


class AvailableSecrets(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretManager: List[SecretManagerItem] = Field(
        ...,
        description='Pairs a secret environment variable with a SecretVersion in Secret Manager.',
    )


class BitbucketServerConfigRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerConfigRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerConfigRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerConfigRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerConfigResourceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerConfigResourceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildBitbucketServerConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BitbucketServerTriggerConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bitbucketServerConfigResourceRef: Union[
        BitbucketServerConfigResourceRef, BitbucketServerConfigResourceRef1
    ] = Field(
        ...,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the bitbucket server config. Format:\nprojects/{project}/locations/{location}/bitbucketServerConfigs/{id}.',
    )
    projectKey: str = Field(
        ...,
        description='Key of the project that the repo is in. For example: The key for https://mybitbucket.server/projects/TEST/repos/test-repo is "TEST".',
    )
    pullRequest: Optional[PullRequest] = Field(
        None, description='Filter to match changes in pull requests.'
    )
    push: Optional[Push] = Field(
        None, description='Filter to match changes in refs like branches, tags.'
    )
    repoSlug: str = Field(
        ...,
        description="Slug of the repository. A repository slug is a URL-friendly version of a repository name, automatically generated by Bitbucket for use in the URL.\nFor example, if the repository name is 'test repo', in the URL it would become 'test-repo' as in https://mybitbucket.server/projects/TEST/repos/test-repo.",
    )


class BucketRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BucketRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Build(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    artifacts: Optional[Artifacts] = Field(
        None,
        description='Artifacts produced by the build that should be uploaded upon successful completion of all build steps.',
    )
    availableSecrets: Optional[AvailableSecrets] = Field(
        None, description='Secrets and secret environment variables.'
    )
    images: Optional[List[str]] = Field(
        None,
        description="A list of images to be pushed upon the successful completion of all build steps.\nThe images are pushed using the builder service account's credentials.\nThe digests of the pushed images will be stored in the Build resource's results field.\nIf any of the images fail to be pushed, the build status is marked FAILURE.",
    )
    logsBucketRef: Optional[Union[LogsBucketRef, LogsBucketRef1]] = Field(
        None,
        description='Google Cloud Storage bucket where logs should be written. Logs file\nnames will be of the format ${logsBucket}/log-${build_id}.txt.',
    )
    options: Optional[Options] = Field(
        None, description='Special options for this build.'
    )
    queueTtl: Optional[str] = Field(
        None,
        description='TTL in queue for this build. If provided and the build is enqueued longer than this value,\nthe build will expire and the build status will be EXPIRED.\nThe TTL starts ticking from createTime.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    secret: Optional[List[SecretItem]] = Field(
        None, description='Secrets to decrypt using Cloud Key Management Service.'
    )
    source: Optional[Source] = Field(
        None,
        description="The location of the source files to build.\n\nOne of 'storageSource' or 'repoSource' must be provided.",
    )
    step: List[StepItem] = Field(
        ..., description='The operations to be performed on the workspace.'
    )
    substitutions: Optional[Dict[str, str]] = Field(
        None, description='Substitutions data for Build resource.'
    )
    tags: Optional[List[str]] = Field(
        None, description='Tags for annotation of a Build. These are not docker tags.'
    )
    timeout: Optional[str] = Field(
        None,
        description='Amount of time that this build should be allowed to run, to second granularity.\nIf this amount of time elapses, work on the build will cease and the build status will be TIMEOUT.\nThis timeout must be equal to or greater than the sum of the timeouts for build steps within the build.\nThe expected format is the number of seconds followed by s.\nDefault time is ten minutes (600s).',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class EnterpriseConfigResourceNameRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class EnterpriseConfigResourceNameRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class GitFileSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bitbucketServerConfigRef: Optional[
        Union[BitbucketServerConfigRef, BitbucketServerConfigRef1]
    ] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the bitbucket server config. Format:\nprojects/{project}/locations/{location}/bitbucketServerConfigs/{id}.',
    )
    githubEnterpriseConfigRef: Optional[
        Union[GithubEnterpriseConfigRef, GithubEnterpriseConfigRef1]
    ] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the github enterprise config. Format:\nprojects/{project}/locations/{location}/githubEnterpriseConfigs/{id}.',
    )
    path: str = Field(
        ...,
        description='The path of the file, with the repo root as the root of the path.',
    )
    repoType: str = Field(
        ...,
        description='The type of the repo, since it may not be explicit from the repo field (e.g from a URL).\nValues can be UNKNOWN, CLOUD_SOURCE_REPOSITORIES, GITHUB, BITBUCKET_SERVER Possible values: ["UNKNOWN", "CLOUD_SOURCE_REPOSITORIES", "GITHUB", "BITBUCKET_SERVER"].',
    )
    repositoryRef: Optional[Union[RepositoryRef, RepositoryRef1]] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe fully qualified resource name of the Repo API repository. The fully qualified resource name of the Repo API repository.\nIf unspecified, the repo from which the trigger invocation originated is assumed to be the repo from which to read the specified path.',
    )
    revision: Optional[str] = Field(
        None,
        description='The branch, tag, arbitrary ref, or SHA version of the repo to use when resolving the\nfilename (optional). This field respects the same syntax/resolution as described here: https://git-scm.com/docs/gitrevisions\nIf unspecified, the revision from which the trigger invocation originated is assumed to be the revision from which to read the specified path.',
    )
    uri: Optional[str] = Field(
        None,
        description='The URI of the repo (optional). If unspecified, the repo from which the trigger\ninvocation originated is assumed to be the repo from which to read the specified path.',
    )


class Github(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enterpriseConfigResourceNameRef: Optional[
        Union[EnterpriseConfigResourceNameRef, EnterpriseConfigResourceNameRef1]
    ] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the github enterprise config. Format:\nprojects/{project}/locations/{location}/githubEnterpriseConfigs/{id}.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the repository. For example: The name for\nhttps://github.com/googlecloudplatform/cloud-builders is "cloud-builders".',
    )
    owner: Optional[str] = Field(
        None,
        description='Owner of the repository. For example: The owner for\nhttps://github.com/googlecloudplatform/cloud-builders is "googlecloudplatform".',
    )
    pullRequest: Optional[PullRequest1] = Field(
        None,
        description="filter to match changes in pull requests. Specify only one of 'pull_request' or 'push'.",
    )
    push: Optional[Push1] = Field(
        None,
        description="filter to match changes in refs, like branches or tags. Specify only one of 'pull_request' or 'push'.",
    )


class GithubEnterpriseConfigRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class GithubEnterpriseConfigRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class GithubEnterpriseConfigRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class GithubEnterpriseConfigRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildGithubEnterpriseConfig` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class LogsBucketRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `url` field of a `StorageBucket` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class LogsBucketRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `url` field of a `StorageBucket` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Optional[Spec] = None
    status: Optional[Status] = None


class Objects(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    location: Optional[str] = Field(
        None,
        description='Cloud Storage bucket and optional object path, in the form "gs://bucket/path/to/somewhere/".\n\nFiles in the workspace matching any path pattern will be uploaded to Cloud Storage with\nthis location as a prefix.',
    )
    paths: Optional[List[str]] = Field(
        None, description="Path globs used to match files in the build's workspace."
    )
    timing: Optional[List[TimingItem]] = Field(
        None,
        description='Output only. Stores timing information for pushing all artifact objects.',
    )


class Options(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    diskSizeGb: Optional[int] = Field(
        None,
        description='Requested disk size for the VM that runs the build. Note that this is NOT "disk free";\nsome of the space will be used by the operating system and build utilities.\nAlso note that this is the minimum disk size that will be allocated for the build --\nthe build may run with a larger disk than requested. At present, the maximum disk size\nis 1000GB; builds that request more than the maximum are rejected with an error.',
    )
    dynamicSubstitutions: Optional[bool] = Field(
        None,
        description='Option to specify whether or not to apply bash style string operations to the substitutions.\n\nNOTE this is always enabled for triggered builds and cannot be overridden in the build configuration file.',
    )
    env: Optional[List[str]] = Field(
        None,
        description='A list of global environment variable definitions that will exist for all build steps\nin this build. If a variable is defined in both globally and in a build step,\nthe variable will use the build step value.\n\nThe elements are of the form "KEY=VALUE" for the environment variable "KEY" being given the value "VALUE".',
    )
    logStreamingOption: Optional[str] = Field(
        None,
        description='Option to define build log streaming behavior to Google Cloud Storage. Possible values: ["STREAM_DEFAULT", "STREAM_ON", "STREAM_OFF"].',
    )
    logging: Optional[str] = Field(
        None,
        description='Option to specify the logging mode, which determines if and where build logs are stored. Possible values: ["LOGGING_UNSPECIFIED", "LEGACY", "GCS_ONLY", "STACKDRIVER_ONLY", "CLOUD_LOGGING_ONLY", "NONE"].',
    )
    machineType: Optional[str] = Field(
        None, description='Compute Engine machine type on which to run the build.'
    )
    requestedVerifyOption: Optional[str] = Field(
        None,
        description='Requested verifiability options. Possible values: ["NOT_VERIFIED", "VERIFIED"].',
    )
    secretEnv: Optional[List[str]] = Field(
        None,
        description="A list of global environment variables, which are encrypted using a Cloud Key Management\nService crypto key. These values must be specified in the build's Secret. These variables\nwill be available to all build steps in this build.",
    )
    sourceProvenanceHash: Optional[List[str]] = Field(
        None,
        description='Requested hash for SourceProvenance. Possible values: ["NONE", "SHA256", "MD5"].',
    )
    substitutionOption: Optional[str] = Field(
        None,
        description='Option to specify behavior when there is an error in the substitution checks.\n\nNOTE this is always set to ALLOW_LOOSE for triggered builds and cannot be overridden\nin the build configuration file. Possible values: ["MUST_MATCH", "ALLOW_LOOSE"].',
    )
    volumes: Optional[List[Volume]] = Field(
        None,
        description='Global list of volumes to mount for ALL build steps\n\nEach volume is created as an empty volume prior to starting the build process.\nUpon completion of the build, volumes and their contents are discarded. Global\nvolume names and paths cannot conflict with the volumes defined a build step.\n\nUsing a global volume in a build with only one step is not valid as it is indicative\nof a build request with an incorrect configuration.',
    )
    workerPool: Optional[str] = Field(
        None,
        description='Option to specify a WorkerPool for the build. Format projects/{project}/workerPools/{workerPool}\n\nThis field is experimental.',
    )


class PubsubConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    serviceAccountRef: Optional[Union[ServiceAccountRef, ServiceAccountRef1]] = Field(
        None, description='Service account that will make the push request.'
    )
    state: Optional[str] = Field(
        None,
        description='Potential issues with the underlying Pub/Sub subscription configuration.\nOnly populated on get requests.',
    )
    subscription: Optional[str] = Field(
        None, description='Output only. Name of the subscription.'
    )
    topicRef: Union[TopicRef, TopicRef1] = Field(
        ...,
        description='The name of the topic from which this subscription\nis receiving messages.',
    )


class PullRequest(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: str = Field(
        ...,
        description='Regex of branches to match.\nThe syntax of the regular expressions accepted is the syntax accepted by RE2 and described at https://github.com/google/re2/wiki/Syntax.',
    )
    commentControl: Optional[str] = Field(
        None,
        description='Configure builds to run whether a repository owner or collaborator need to comment /gcbrun. Possible values: ["COMMENTS_DISABLED", "COMMENTS_ENABLED", "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"].',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='If true, branches that do NOT match the git_ref will trigger a build.',
    )


class PullRequest1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: str = Field(..., description='Regex of branches to match.')
    commentControl: Optional[str] = Field(
        None,
        description='Whether to block builds on a "/gcbrun" comment from a repository owner or collaborator. Possible values: ["COMMENTS_DISABLED", "COMMENTS_ENABLED", "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"].',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='If true, branches that do NOT match the git_ref will trigger a build.',
    )


class PullRequest2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: Optional[str] = Field(
        None,
        description='Regex of branches to match.\n\nThe syntax of the regular expressions accepted is the syntax accepted by\nRE2 and described at https://github.com/google/re2/wiki/Syntax.',
    )
    commentControl: Optional[str] = Field(
        None,
        description='Configure builds to run whether a repository owner or collaborator need to comment \'/gcbrun\'. Possible values: ["COMMENTS_DISABLED", "COMMENTS_ENABLED", "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"].',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='If true, branches that do NOT match the git_ref will trigger a build.',
    )


class Push(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: Optional[str] = Field(
        None,
        description='Regex of branches to match.  Specify only one of branch or tag.',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='When true, only trigger a build if the revision regex does NOT match the gitRef regex.',
    )
    tag: Optional[str] = Field(
        None, description='Regex of tags to match.  Specify only one of branch or tag.'
    )


class Push1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: Optional[str] = Field(
        None,
        description='Regex of branches to match.  Specify only one of branch or tag.',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='When true, only trigger a build if the revision regex does NOT match the git_ref regex.',
    )
    tag: Optional[str] = Field(
        None, description='Regex of tags to match.  Specify only one of branch or tag.'
    )


class Push2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branch: Optional[str] = Field(
        None,
        description='Regex of branches to match.\n\nThe syntax of the regular expressions accepted is the syntax accepted by\nRE2 and described at https://github.com/google/re2/wiki/Syntax.',
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='If true, only trigger a build if the revision regex does NOT match the git_ref regex.',
    )
    tag: Optional[str] = Field(
        None,
        description='Regex of tags to match.\n\nThe syntax of the regular expressions accepted is the syntax accepted by\nRE2 and described at https://github.com/google/re2/wiki/Syntax.',
    )


class RepoRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `SourceRepoRepository` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepoRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `SourceRepoRepository` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepoRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `SourceRepoRepository` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepoRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `SourceRepoRepository` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepoSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branchName: Optional[str] = Field(
        None,
        description='Regex matching branches to build. Exactly one a of branch name, tag, or commit SHA must be provided.\nThe syntax of the regular expressions accepted is the syntax accepted by RE2 and\ndescribed at https://github.com/google/re2/wiki/Syntax.',
    )
    commitSha: Optional[str] = Field(
        None,
        description='Explicit commit SHA to build. Exactly one a of branch name, tag, or commit SHA must be provided.',
    )
    dir: Optional[str] = Field(
        None,
        description="Directory, relative to the source root, in which to run the build.\nThis must be a relative path. If a step's dir is specified and is an absolute path,\nthis value is ignored for that step's execution.",
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='Only trigger a build if the revision regex does NOT match the revision regex.',
    )
    projectId: Optional[str] = Field(
        None,
        description='ID of the project that owns the Cloud Source Repository.\nIf omitted, the project ID requesting the build is assumed.',
    )
    repoRef: Union[RepoRef, RepoRef1] = Field(
        ...,
        description='The desired Cloud Source Repository. If omitted, "default" is\nassumed.',
    )
    substitutions: Optional[Dict[str, str]] = Field(
        None,
        description='Substitutions to use in a triggered build. Should only be used with triggers.run.',
    )
    tagName: Optional[str] = Field(
        None,
        description='Regex matching tags to build. Exactly one a of branch name, tag, or commit SHA must be provided.\nThe syntax of the regular expressions accepted is the syntax accepted by RE2 and\ndescribed at https://github.com/google/re2/wiki/Syntax.',
    )


class RepositoryEventConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    pullRequest: Optional[PullRequest2] = Field(
        None, description='Contains filter properties for matching Pull Requests.'
    )
    push: Optional[Push2] = Field(
        None, description='Contains filter properties for matching git pushes.'
    )
    repository: Optional[str] = Field(
        None, description='The resource name of the Repo API resource.'
    )


class RepositoryRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildV2Repository` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepositoryRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildV2Repository` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepositoryRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `CloudBuildV2Repository` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RepositoryRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `CloudBuildV2Repository` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class SecretItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef, KmsKeyRef1] = Field(
        ..., description='KMS crypto key to use to decrypt these envs.'
    )
    secretEnv: Optional[Dict[str, str]] = Field(
        None,
        description="Map of environment variable name to its encrypted value.\nSecret environment variables must be unique across all of a build's secrets,\nand must be used by at least one build step. Values can be at most 64 KB in size.\nThere can be at most 100 secret values across all of a build's secrets.",
    )


class SecretManagerItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    env: str = Field(
        ...,
        description="Environment variable name to associate with the secret. Secret environment\nvariables must be unique across all of a build's secrets, and must be used\nby at least one build step.",
    )
    versionRef: Union[VersionRef, VersionRef1]


class SecretRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `SecretManagerSecretVersion` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class SecretRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `SecretManagerSecretVersion` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/serviceAccounts/{{value}}`, where {{value}} is the `email` field of an `IAMServiceAccount` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/serviceAccounts/{{value}}`, where {{value}} is the `email` field of an `IAMServiceAccount` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Source(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    repoSource: Optional[RepoSource] = Field(
        None, description='Location of the source in a Google Cloud Source Repository.'
    )
    storageSource: Optional[StorageSource] = Field(
        None,
        description='Location of the source in an archive file in Google Cloud Storage.',
    )


class SourceToBuild(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bitbucketServerConfigRef: Optional[
        Union[BitbucketServerConfigRef2, BitbucketServerConfigRef3]
    ] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the bitbucket server config. Format:\nprojects/{project}/locations/{location}/bitbucketServerConfigs/{id}.',
    )
    githubEnterpriseConfigRef: Optional[
        Union[GithubEnterpriseConfigRef2, GithubEnterpriseConfigRef3]
    ] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe full resource name of the github enterprise config. Format:\nprojects/{project}/locations/{location}/githubEnterpriseConfigs/{id}.',
    )
    ref: str = Field(
        ..., description='The branch or tag to use. Must start with "refs/" (required).'
    )
    repoType: str = Field(
        ...,
        description='The type of the repo, since it may not be explicit from the repo field (e.g from a URL).\nValues can be UNKNOWN, CLOUD_SOURCE_REPOSITORIES, GITHUB, BITBUCKET_SERVER Possible values: ["UNKNOWN", "CLOUD_SOURCE_REPOSITORIES", "GITHUB", "BITBUCKET_SERVER"].',
    )
    repositoryRef: Optional[Union[RepositoryRef2, RepositoryRef3]] = Field(
        None,
        description='Only `external` field is supported to configure the reference.\n\nThe qualified resource name of the Repo API repository.\nEither uri or repository can be specified and is required.',
    )
    uri: Optional[str] = Field(None, description='The URI of the repo.')


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    approvalConfig: Optional[ApprovalConfig] = Field(
        None,
        description='Configuration for manual approval to start a build invocation of this BuildTrigger.\nBuilds created by this trigger will require approval before they execute.\nAny user with a Cloud Build Approver role for the project can approve a build.',
    )
    bitbucketServerTriggerConfig: Optional[BitbucketServerTriggerConfig] = Field(
        None,
        description='BitbucketServerTriggerConfig describes the configuration of a trigger that creates a build whenever a Bitbucket Server event is received.',
    )
    build: Optional[Build] = Field(
        None,
        description='Contents of the build template. Either a filename or build template must be provided.',
    )
    description: Optional[str] = Field(
        None, description='Human-readable description of the trigger.'
    )
    disabled: Optional[bool] = Field(
        None,
        description='Whether the trigger is disabled or not. If true, the trigger will never result in a build.',
    )
    filename: Optional[str] = Field(
        None,
        description='Path, from the source root, to a file whose contents is used for the template.\nEither a filename or build template must be provided. Set this only when using trigger_template or github.\nWhen using Pub/Sub, Webhook or Manual set the file name using git_file_source instead.',
    )
    filter: Optional[str] = Field(
        None,
        description='A Common Expression Language string. Used only with Pub/Sub and Webhook.',
    )
    gitFileSource: Optional[GitFileSource] = Field(
        None,
        description='The file source describing the local or remote Build template.',
    )
    github: Optional[Github] = Field(
        None,
        description="Describes the configuration of a trigger that creates a build whenever a GitHub event is received.\n\nOne of 'trigger_template', 'github', 'pubsub_config' or 'webhook_config' must be provided.",
    )
    ignoredFiles: Optional[List[str]] = Field(
        None,
        description="ignoredFiles and includedFiles are file glob matches using https://golang.org/pkg/path/filepath/#Match\nextended with support for '**'.\n\nIf ignoredFiles and changed files are both empty, then they are not\nused to determine whether or not to trigger a build.\n\nIf ignoredFiles is not empty, then we ignore any files that match any\nof the ignored_file globs. If the change has no files that are outside\nof the ignoredFiles globs, then we do not trigger a build.",
    )
    includeBuildLogs: Optional[str] = Field(
        None,
        description='Build logs will be sent back to GitHub as part of the checkrun\nresult.  Values can be INCLUDE_BUILD_LOGS_UNSPECIFIED or\nINCLUDE_BUILD_LOGS_WITH_STATUS Possible values: ["INCLUDE_BUILD_LOGS_UNSPECIFIED", "INCLUDE_BUILD_LOGS_WITH_STATUS"].',
    )
    includedFiles: Optional[List[str]] = Field(
        None,
        description="ignoredFiles and includedFiles are file glob matches using https://golang.org/pkg/path/filepath/#Match\nextended with support for '**'.\n\nIf any of the files altered in the commit pass the ignoredFiles filter\nand includedFiles is empty, then as far as this filter is concerned, we\nshould trigger the build.\n\nIf any of the files altered in the commit pass the ignoredFiles filter\nand includedFiles is not empty, then we make sure that at least one of\nthose files matches a includedFiles glob. If not, then we do not trigger\na build.",
    )
    location: Optional[str] = Field(
        None,
        description='Immutable. The [Cloud Build location](https://cloud.google.com/build/docs/locations) for the trigger.\nIf not specified, "global" is used.',
    )
    pubsubConfig: Optional[PubsubConfig] = Field(
        None,
        description="PubsubConfig describes the configuration of a trigger that creates\na build whenever a Pub/Sub message is published.\n\nOne of 'trigger_template', 'github', 'pubsub_config' 'webhook_config' or 'source_to_build' must be provided.",
    )
    repositoryEventConfig: Optional[RepositoryEventConfig] = Field(
        None,
        description='The configuration of a trigger that creates a build whenever an event from Repo API is received.',
    )
    serviceAccountRef: Optional[Union[ServiceAccountRef2, ServiceAccountRef3]] = Field(
        None,
        description='The service account used for all user-controlled operations including\ntriggers.patch, triggers.run, builds.create, and builds.cancel.\n\nIf no service account is set, then the standard Cloud Build service account\n([PROJECT_NUM]@system.gserviceaccount.com) will be used instead.\n\nWhen populating via the external field, the following format is supported:\nprojects/{PROJECT_ID}/serviceAccounts/{SERVICE_ACCOUNT_EMAIL}',
    )
    sourceToBuild: Optional[SourceToBuild] = Field(
        None,
        description="The repo and ref of the repository from which to build.\nThis field is used only for those triggers that do not respond to SCM events.\nTriggers that respond to such events build source at whatever commit caused the event.\nThis field is currently only used by Webhook, Pub/Sub, Manual, and Cron triggers.\n\nOne of 'trigger_template', 'github', 'pubsub_config' 'webhook_config' or 'source_to_build' must be provided.",
    )
    substitutions: Optional[Dict[str, str]] = Field(
        None, description='Substitutions data for Build resource.'
    )
    tags: Optional[List[str]] = Field(
        None, description='Tags for annotation of a BuildTrigger.'
    )
    triggerTemplate: Optional[TriggerTemplate] = Field(
        None,
        description="Template describing the types of source changes to trigger a build.\n\nBranch and tag names in trigger templates are interpreted as regular\nexpressions. Any branch or tag change that matches that regular\nexpression will trigger a build.\n\nOne of 'trigger_template', 'github', 'pubsub_config', 'webhook_config' or 'source_to_build' must be provided.",
    )
    webhookConfig: Optional[WebhookConfig] = Field(
        None,
        description="WebhookConfig describes the configuration of a trigger that creates\na build whenever a webhook is sent to a trigger's webhook URL.\n\nOne of 'trigger_template', 'github', 'pubsub_config' 'webhook_config' or 'source_to_build' must be provided.",
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None, description='Time when the trigger was created.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    triggerId: Optional[str] = Field(
        None, description='The unique identifier for the trigger.'
    )


class StepItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowExitCodes: Optional[List[int]] = Field(
        None,
        description="Allow this build step to fail without failing the entire build if and\nonly if the exit code is one of the specified codes.\n\nIf 'allowFailure' is also specified, this field will take precedence.",
    )
    allowFailure: Optional[bool] = Field(
        None,
        description="Allow this build step to fail without failing the entire build.\nIf false, the entire build will fail if this step fails. Otherwise, the\nbuild will succeed, but this step will still have a failure status.\nError information will be reported in the 'failureDetail' field.\n\n'allowExitCodes' takes precedence over this field.",
    )
    args: Optional[List[str]] = Field(
        None,
        description="A list of arguments that will be presented to the step when it is started.\n\nIf the image used to run the step's container has an entrypoint, the args\nare used as arguments to that entrypoint. If the image does not define an\nentrypoint, the first element in args is used as the entrypoint, and the\nremainder will be used as arguments.",
    )
    dir: Optional[str] = Field(
        None,
        description="Working directory to use when running this step's container.\n\nIf this value is a relative path, it is relative to the build's working\ndirectory. If this value is absolute, it may be outside the build's working\ndirectory, in which case the contents of the path may not be persisted\nacross build step executions, unless a 'volume' for that path is specified.\n\nIf the build specifies a 'RepoSource' with 'dir' and a step with a\n'dir',\nwhich specifies an absolute path, the 'RepoSource' 'dir' is ignored\nfor the step's execution.",
    )
    entrypoint: Optional[str] = Field(
        None,
        description="Entrypoint to be used instead of the build step image's\ndefault entrypoint.\nIf unset, the image's default entrypoint is used.",
    )
    env: Optional[List[str]] = Field(
        None,
        description='A list of environment variable definitions to be used when\nrunning a step.\n\nThe elements are of the form "KEY=VALUE" for the environment variable\n"KEY" being given the value "VALUE".',
    )
    id: Optional[str] = Field(
        None,
        description="Unique identifier for this build step, used in 'wait_for' to\nreference this build step as a dependency.",
    )
    name: str = Field(
        ...,
        description='The name of the container image that will run this particular build step.\n\nIf the image is available in the host\'s Docker daemon\'s cache, it will be\nrun directly. If not, the host will attempt to pull the image first, using\nthe builder service account\'s credentials if necessary.\n\nThe Docker daemon\'s cache will already have the latest versions of all of\nthe officially supported build steps (see https://github.com/GoogleCloudPlatform/cloud-builders\nfor images and examples).\nThe Docker daemon will also have cached many of the layers for some popular\nimages, like "ubuntu", "debian", but they will be refreshed at the time\nyou attempt to use them.\n\nIf you built an image in a previous build step, it will be stored in the\nhost\'s Docker daemon\'s cache and is available to use as the name for a\nlater build step.',
    )
    script: Optional[str] = Field(
        None,
        description='A shell script to be executed in the step.\nWhen script is provided, the user cannot specify the entrypoint or args.',
    )
    secretEnv: Optional[List[str]] = Field(
        None,
        description="A list of environment variables which are encrypted using\na Cloud Key\nManagement Service crypto key. These values must be specified in\nthe build's 'Secret'.",
    )
    timeout: Optional[str] = Field(
        None,
        description='Time limit for executing this build step. If not defined,\nthe step has no\ntime limit and will be allowed to continue to run until either it\ncompletes or the build itself times out.',
    )
    timing: Optional[str] = Field(
        None,
        description='Output only. Stores timing information for executing this\nbuild step.',
    )
    volumes: Optional[List[Volume1]] = Field(
        None,
        description='List of volumes to mount into the build step.\n\nEach volume is created as an empty volume prior to execution of the\nbuild step. Upon completion of the build, volumes and their contents\nare discarded.\n\nUsing a named volume in only one step is not valid as it is\nindicative of a build request with an incorrect configuration.',
    )
    waitFor: Optional[List[str]] = Field(
        None,
        description="The ID(s) of the step(s) that this build step depends on.\n\nThis build step will not start until all the build steps in 'wait_for'\nhave completed successfully. If 'wait_for' is empty, this build step\nwill start when all previous build steps in the 'Build.Steps' list\nhave completed successfully.",
    )


class StorageSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bucketRef: Union[BucketRef, BucketRef1] = Field(
        ..., description='Google Cloud Storage bucket containing the source.'
    )
    generation: Optional[str] = Field(
        None,
        description='Google Cloud Storage generation for the object.\nIf the generation is omitted, the latest generation will be used.',
    )
    object: str = Field(
        ...,
        description='Google Cloud Storage object containing the source.\nThis object must be a gzipped archive file (.tar.gz) containing source to build.',
    )


class TimingItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    endTime: Optional[str] = Field(
        None,
        description='End of time span.\n\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to\nnine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    startTime: Optional[str] = Field(
        None,
        description='Start of time span.\n\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to\nnine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )


class TopicRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TopicRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TriggerTemplate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    branchName: Optional[str] = Field(
        None,
        description='Name of the branch to build. Exactly one a of branch name, tag, or commit SHA must be provided.\nThis field is a regular expression.',
    )
    commitSha: Optional[str] = Field(
        None,
        description='Explicit commit SHA to build. Exactly one of a branch name, tag, or commit SHA must be provided.',
    )
    dir: Optional[str] = Field(
        None,
        description="Directory, relative to the source root, in which to run the build.\n\nThis must be a relative path. If a step's dir is specified and\nis an absolute path, this value is ignored for that step's\nexecution.",
    )
    invertRegex: Optional[bool] = Field(
        None,
        description='Only trigger a build if the revision regex does NOT match the revision regex.',
    )
    repoRef: Optional[Union[RepoRef2, RepoRef3]] = Field(
        None,
        description='The Cloud Source Repository to build. If omitted, the repo with\nname "default" is assumed.',
    )
    tagName: Optional[str] = Field(
        None,
        description='Name of the tag to build. Exactly one of a branch name, tag, or commit SHA must be provided.\nThis field is a regular expression.',
    )


class VersionRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `SecretManagerSecretVersion` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class VersionRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `SecretManagerSecretVersion` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Volume(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the volume to mount.\n\nVolume names must be unique per build step and must be valid names for Docker volumes.\nEach named volume must be used by at least two build steps.',
    )
    path: Optional[str] = Field(
        None,
        description='Path at which to mount the volume.\n\nPaths must be absolute and cannot conflict with other volume paths on the same\nbuild step or with certain reserved volume paths.',
    )


class Volume1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: str = Field(
        ...,
        description='Name of the volume to mount.\n\nVolume names must be unique per build step and must be valid names for\nDocker volumes. Each named volume must be used by at least two build steps.',
    )
    path: str = Field(
        ...,
        description='Path at which to mount the volume.\n\nPaths must be absolute and cannot conflict with other volume paths on\nthe same build step or with certain reserved volume paths.',
    )


class WebhookConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretRef: Union[SecretRef, SecretRef1] = Field(
        ..., description='The secret required'
    )
    state: Optional[str] = Field(
        None,
        description='Potential issues with the underlying Pub/Sub subscription configuration.\nOnly populated on get requests.',
    )
