# generated by datamodel-codegen:
#   filename:  cloudiotdeviceregistry_v1alpha1.json
#   timestamp: 2024-03-15T04:51:29+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Credential(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicKeyCertificate: Dict[str, Any] = Field(
        ..., description='A public key certificate format and data.'
    )


class EventNotificationConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    pubsubTopicName: str = Field(
        ..., description='PubSub topic name to publish device events.'
    )
    subfolderMatches: Optional[str] = Field(
        None,
        description="If the subfolder name matches this string exactly, this\nconfiguration will be used. The string must not include the\nleading '/' character. If empty, all strings are matched. Empty\nvalue can only be used for the last 'event_notification_configs'\nitem.",
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    credentials: Optional[List[Credential]] = Field(
        None, description='List of public key certificates to authenticate devices.'
    )
    eventNotificationConfigs: Optional[List[EventNotificationConfig]] = Field(
        None,
        description='List of configurations for event notifications, such as PubSub topics\nto publish device events to.',
    )
    httpConfig: Optional[Dict[str, Any]] = Field(
        None, description='Activate or deactivate HTTP.'
    )
    logLevel: Optional[str] = Field(
        None,
        description='The default logging verbosity for activity from devices in this\nregistry. Specifies which events should be written to logs. For\nexample, if the LogLevel is ERROR, only events that terminate in\nerrors will be logged. LogLevel is inclusive; enabling INFO logging\nwill also enable ERROR logging. Default value: "NONE" Possible values: ["NONE", "ERROR", "INFO", "DEBUG"].',
    )
    mqttConfig: Optional[Dict[str, Any]] = Field(
        None, description='Activate or deactivate MQTT.'
    )
    project: Optional[str] = Field(None, description='Immutable.')
    region: str = Field(
        ...,
        description='Immutable. The region in which the created registry should reside.\nIf it is not provided, the provider region is used.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    stateNotificationConfig: Optional[Dict[str, Any]] = Field(
        None, description='A PubSub topic to publish device state updates.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
