# generated by datamodel-codegen:
#   filename:  cloudtasksqueue_v1alpha1.json
#   timestamp: 2024-03-15T04:51:30+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AppEngineRoutingOverride(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    host: Optional[str] = Field(None, description='The host that the task is sent to.')
    instance: Optional[str] = Field(
        None,
        description='App instance.\n\nBy default, the task is sent to an instance which is available when the task is attempted.',
    )
    service: Optional[str] = Field(
        None,
        description='App service.\n\nBy default, the task is sent to the service which is the default service when the task is attempted.',
    )
    version: Optional[str] = Field(
        None,
        description='App version.\n\nBy default, the task is sent to the version which is the default version when the task is attempted.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RateLimits(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maxBurstSize: Optional[int] = Field(
        None,
        description='The max burst size.\n\nMax burst size limits how fast tasks in queue are processed when many tasks are\nin the queue and the rate is high. This field allows the queue to have a high\nrate so processing starts shortly after a task is enqueued, but still limits\nresource usage when many tasks are enqueued in a short period of time.',
    )
    maxConcurrentDispatches: Optional[int] = Field(
        None,
        description='The maximum number of concurrent tasks that Cloud Tasks allows to\nbe dispatched for this queue. After this threshold has been\nreached, Cloud Tasks stops dispatching tasks until the number of\nconcurrent requests decreases.',
    )
    maxDispatchesPerSecond: Optional[float] = Field(
        None,
        description='The maximum rate at which tasks are dispatched from this queue.\n\nIf unspecified when the queue is created, Cloud Tasks will pick the default.',
    )


class RetryConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maxAttempts: Optional[int] = Field(
        None,
        description='Number of attempts per task.\n\nCloud Tasks will attempt the task maxAttempts times (that is, if\nthe first attempt fails, then there will be maxAttempts - 1\nretries). Must be >= -1.\n\nIf unspecified when the queue is created, Cloud Tasks will pick\nthe default.\n\n-1 indicates unlimited attempts.',
    )
    maxBackoff: Optional[str] = Field(
        None,
        description="A task will be scheduled for retry between minBackoff and\nmaxBackoff duration after it fails, if the queue's RetryConfig\nspecifies that the task should be retried.",
    )
    maxDoublings: Optional[int] = Field(
        None,
        description="The time between retries will double maxDoublings times.\n\nA task's retry interval starts at minBackoff, then doubles maxDoublings times,\nthen increases linearly, and finally retries retries at intervals of maxBackoff\nup to maxAttempts times.",
    )
    maxRetryDuration: Optional[str] = Field(
        None,
        description='If positive, maxRetryDuration specifies the time limit for\nretrying a failed task, measured from when the task was first\nattempted. Once maxRetryDuration time has passed and the task has\nbeen attempted maxAttempts times, no further attempts will be\nmade and the task will be deleted.\n\nIf zero, then the task age is unlimited.',
    )
    minBackoff: Optional[str] = Field(
        None,
        description="A task will be scheduled for retry between minBackoff and\nmaxBackoff duration after it fails, if the queue's RetryConfig\nspecifies that the task should be retried.",
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    appEngineRoutingOverride: Optional[AppEngineRoutingOverride] = Field(
        None,
        description='Overrides for task-level appEngineRouting. These settings apply only\nto App Engine tasks in this queue.',
    )
    location: str = Field(..., description='Immutable. The location of the queue.')
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    rateLimits: Optional[RateLimits] = Field(
        None,
        description="Rate limits for task dispatches.\n\nThe queue's actual dispatch rate is the result of:\n\n* Number of tasks in the queue\n* User-specified throttling: rateLimits, retryConfig, and the queue's state.\n* System throttling due to 429 (Too Many Requests) or 503 (Service\n  Unavailable) responses from the worker, high error rates, or to\n  smooth sudden large traffic spikes.",
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    retryConfig: Optional[RetryConfig] = Field(
        None, description='Settings that determine the retry behavior.'
    )
    stackdriverLoggingConfig: Optional[StackdriverLoggingConfig] = Field(
        None,
        description='Configuration options for writing logs to Stackdriver Logging.',
    )


class StackdriverLoggingConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    samplingRatio: float = Field(
        ...,
        description='Specifies the fraction of operations to write to Stackdriver Logging.\nThis field may contain any value between 0.0 and 1.0, inclusive. 0.0 is the\ndefault and means that no operations are logged.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
