# generated by datamodel-codegen:
#   filename:  computefirewallpolicyrule_v1beta1.json
#   timestamp: 2024-03-15T04:51:36+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class FirewallPolicyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The firewall policy of the resource.\n\nAllowed value: The Google Cloud resource name of a `ComputeFirewallPolicy` resource (format: `locations/global/firewallPolicies/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class FirewallPolicyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The firewall policy of the resource.\n\nAllowed value: The Google Cloud resource name of a `ComputeFirewallPolicy` resource (format: `locations/global/firewallPolicies/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Layer4Config(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    ipProtocol: str = Field(
        ...,
        description='The IP protocol to which this rule applies. The protocol type is required when creating a firewall rule. This value can either be one of the following well known protocol strings (`tcp`, `udp`, `icmp`, `esp`, `ah`, `ipip`, `sctp`), or the IP protocol number.',
    )
    ports: Optional[List[str]] = Field(
        None,
        description='An optional list of ports to which this rule applies. This field is only applicable for UDP or TCP protocol. Each entry must be either an integer or a range. If not specified, this rule applies to connections through any port. Example inputs include: ``.',
    )


class Match(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    destAddressGroups: Optional[List[str]] = Field(
        None,
        description='Address groups which should be matched against the traffic destination. Maximum number of destination address groups is 10. Destination address groups is only supported in Egress rules.',
    )
    destFqdns: Optional[List[str]] = Field(
        None,
        description='Domain names that will be used to match against the resolved domain name of destination of traffic. Can only be specified if DIRECTION is egress.',
    )
    destIPRanges: Optional[List[str]] = Field(
        None,
        description='CIDR IP address range. Maximum number of destination CIDR IP ranges allowed is 256.',
    )
    destRegionCodes: Optional[List[str]] = Field(
        None,
        description='The Unicode country codes whose IP addresses will be used to match against the source of traffic. Can only be specified if DIRECTION is egress.',
    )
    destThreatIntelligences: Optional[List[str]] = Field(
        None, description='Name of the Google Cloud Threat Intelligence list.'
    )
    layer4Configs: List[Layer4Config] = Field(
        ..., description='Pairs of IP protocols and ports that the rule should match.'
    )
    srcAddressGroups: Optional[List[str]] = Field(
        None,
        description='Address groups which should be matched against the traffic source. Maximum number of source address groups is 10. Source address groups is only supported in Ingress rules.',
    )
    srcFqdns: Optional[List[str]] = Field(
        None,
        description='Domain names that will be used to match against the resolved domain name of source of traffic. Can only be specified if DIRECTION is ingress.',
    )
    srcIPRanges: Optional[List[str]] = Field(
        None,
        description='CIDR IP address range. Maximum number of source CIDR IP ranges allowed is 256.',
    )
    srcRegionCodes: Optional[List[str]] = Field(
        None,
        description='The Unicode country codes whose IP addresses will be used to match against the source of traffic. Can only be specified if DIRECTION is ingress.',
    )
    srcThreatIntelligences: Optional[List[str]] = Field(
        None, description='Name of the Google Cloud Threat Intelligence list.'
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    action: str = Field(
        ...,
        description='The Action to perform when the client connection triggers the rule. Valid actions are "allow", "deny" and "goto_next".',
    )
    description: Optional[str] = Field(
        None, description='An optional description for this resource.'
    )
    direction: str = Field(
        ...,
        description='The direction in which this rule applies. Possible values: INGRESS, EGRESS',
    )
    disabled: Optional[bool] = Field(
        None,
        description='Denotes whether the firewall policy rule is disabled. When set to true, the firewall policy rule is not enforced and traffic behaves as if it did not exist. If this is unspecified, the firewall policy rule will be enabled.',
    )
    enableLogging: Optional[bool] = Field(
        None,
        description='Denotes whether to enable logging for a particular rule. If logging is enabled, logs will be exported to the configured export destination in Stackdriver. Logs may be exported to BigQuery or Pub/Sub. Note: you cannot enable logging on "goto_next" rules.',
    )
    firewallPolicyRef: Union[FirewallPolicyRef, FirewallPolicyRef1] = Field(
        ..., description='Immutable.'
    )
    match: Match = Field(
        ...,
        description="A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding 'action' is enforced.",
    )
    priority: int = Field(
        ...,
        description='Immutable. An integer indicating the priority of a rule in the list. The priority must be a positive value between 0 and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and 2147483647 is the lowest prority.',
    )
    targetResources: Optional[List[Union[TargetResources, TargetResources1]]] = None
    targetServiceAccounts: Optional[
        List[Union[TargetServiceAccounts, TargetServiceAccounts1]]
    ] = None


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    kind: Optional[str] = Field(
        None,
        description='Type of the resource. Always `compute#firewallPolicyRule` for firewall policy rules',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    ruleTupleCount: Optional[int] = Field(
        None,
        description='Calculation of the complexity of a single firewall policy rule.',
    )


class TargetResources(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TargetResources1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TargetServiceAccounts(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The Google Cloud resource name of an `IAMServiceAccount` resource (format: `projects/{{project}}/serviceAccounts/{{name}}@{{project}}.iam.gserviceaccount.com`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TargetServiceAccounts1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The Google Cloud resource name of an `IAMServiceAccount` resource (format: `projects/{{project}}/serviceAccounts/{{name}}@{{project}}.iam.gserviceaccount.com`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )
