# generated by datamodel-codegen:
#   filename:  computeinstancegroupmanager_v1beta1.json
#   timestamp: 2024-03-15T04:51:40+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AutoHealingPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    healthCheckRef: Optional[Union[HealthCheckRef, HealthCheckRef1]] = None
    initialDelaySec: Optional[int] = Field(
        None,
        description='The number of seconds that the managed instance group waits before it applies autohealing policies to new instances or recently recreated instances. This initial delay allows instances to initialize and run their startup scripts before the instance group determines that they are UNHEALTHY. This prevents the managed instance group from recreating its instances prematurely. This value must be from range [0, 3600].',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class CurrentActions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    abandoning: Optional[int] = Field(
        None,
        description='[Output Only] The total number of instances in the managed instance group that are scheduled to be abandoned. Abandoning an instance removes it from the managed instance group without deleting it.',
    )
    creating: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are scheduled to be created or are currently being created. If the group fails to create any of these instances, it tries again until it creates the instance successfully. If you have disabled creation retries, this field will not be populated; instead, the `creatingWithoutRetries` field will be populated.',
    )
    creatingWithoutRetries: Optional[int] = Field(
        None,
        description="[Output Only] The number of instances that the managed instance group will attempt to create. The group attempts to create each instance only once. If the group fails to create any of these instances, it decreases the group's `targetSize` value accordingly.",
    )
    deleting: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are scheduled to be deleted or are currently being deleted.',
    )
    none: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are running and have no scheduled actions.',
    )
    recreating: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are scheduled to be recreated or are currently being being recreated. Recreating an instance deletes the existing root persistent disk and creates a new disk from the image that is defined in the instance template.',
    )
    refreshing: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are being reconfigured with properties that do not require a restart or a recreate action. For example, setting or removing target pools for the instance.',
    )
    restarting: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are scheduled to be restarted or are currently being restarted.',
    )
    verifying: Optional[int] = Field(
        None,
        description='[Output Only] The number of instances in the managed instance group that are being verified. See the `managedInstances[].currentAction` property in the `listManagedInstances` method documentation.',
    )


class Disks(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoDelete: Optional[str] = Field(
        None,
        description='These stateful disks will never be deleted during autohealing, update or VM instance recreate operations. This flag is used to configure if the disk should be deleted after it is no longer used by the group, e.g. when the given instance or the whole group is deleted. Note: disks attached in READ_ONLY mode cannot be auto-deleted. Possible values: NEVER, ON_PERMANENT_INSTANCE_DELETION',
    )


class DistributionPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    targetShape: Optional[str] = Field(
        None,
        description='The distribution shape to which the group converges either proactively or on resize events (depending on the value set in `updatePolicy.instanceRedistributionType`). Possible values: TARGET_SHAPE_UNSPECIFIED, ANY, BALANCED, ANY_SINGLE_ZONE',
    )
    zones: Optional[List[Zone]] = Field(
        None,
        description='Immutable. Zones where the regional managed instance group will create and manage its instances.',
    )


class ExternalIps(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoDelete: Optional[str] = Field(
        None,
        description='These stateful IPs will never be released during autohealing, update or VM instance recreate operations. This flag is used to configure if the IP reservation should be deleted after it is no longer used by the group, e.g. when the given instance or the whole group is deleted. Possible values: NEVER, ON_PERMANENT_INSTANCE_DELETION',
    )


class HealthCheckRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The URL for the health check that signals autohealing.\n\nAllowed value: The `selfLink` field of a `ComputeHealthCheck` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class HealthCheckRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The URL for the health check that signals autohealing.\n\nAllowed value: The `selfLink` field of a `ComputeHealthCheck` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class InstanceTemplateRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description="The URL of the instance template that is specified for this managed instance group. The group uses this template to create all new instances in the managed instance group. The templates for existing instances in the group do not change unless you run `recreateInstances`, run `applyUpdatesToInstances`, or set the group's `updatePolicy.type` to `PROACTIVE`.\n\nAllowed value: The `selfLink` field of a `ComputeInstanceTemplate` resource.",
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class InstanceTemplateRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description="The URL of the instance template that is specified for this managed instance group. The group uses this template to create all new instances in the managed instance group. The templates for existing instances in the group do not change unless you run `recreateInstances`, run `applyUpdatesToInstances`, or set the group's `updatePolicy.type` to `PROACTIVE`.\n\nAllowed value: The `selfLink` field of a `ComputeInstanceTemplate` resource.",
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class InstanceTemplateRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description="The URL of the instance template that is specified for this managed instance group. The group uses this template to create new instances in the managed instance group until the `targetSize` for this version is reached. The templates for existing instances in the group do not change unless you run `recreateInstances`, run `applyUpdatesToInstances`, or set the group's `updatePolicy.type` to `PROACTIVE`; in those cases, existing instances are updated until the `targetSize` for this version is reached.\n\nAllowed value: The `selfLink` field of a `ComputeInstanceTemplate` resource.",
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class InstanceTemplateRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description="The URL of the instance template that is specified for this managed instance group. The group uses this template to create new instances in the managed instance group until the `targetSize` for this version is reached. The templates for existing instances in the group do not change unless you run `recreateInstances`, run `applyUpdatesToInstances`, or set the group's `updatePolicy.type` to `PROACTIVE`; in those cases, existing instances are updated until the `targetSize` for this version is reached.\n\nAllowed value: The `selfLink` field of a `ComputeInstanceTemplate` resource.",
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class InternalIps(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoDelete: Optional[str] = Field(
        None,
        description='These stateful IPs will never be released during autohealing, update or VM instance recreate operations. This flag is used to configure if the IP reservation should be deleted after it is no longer used by the group, e.g. when the given instance or the whole group is deleted. Possible values: NEVER, ON_PERMANENT_INSTANCE_DELETION',
    )


class MaxSurge(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    fixed: Optional[int] = Field(
        None,
        description='Specifies a fixed number of VM instances. This must be a positive integer.',
    )
    percent: Optional[int] = Field(
        None,
        description='Specifies a percentage of instances between 0 to 100%, inclusive. For example, specify `80` for 80%.',
    )


class MaxSurge1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    calculated: Optional[int] = Field(
        None,
        description='[Output Only] Absolute value of VM instances calculated based on the specific mode. - If the value is `fixed`, then the `calculated` value is equal to the `fixed` value. - If the value is a `percent`, then the `calculated` value is `percent`/100 * `targetSize`. For example, the `calculated` value of a 80% of a managed instance group with 150 instances would be (80/100 * 150) = 120 VM instances. If there is a remainder, the number is rounded.',
    )


class MaxUnavailable(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    fixed: Optional[int] = Field(
        None,
        description='Specifies a fixed number of VM instances. This must be a positive integer.',
    )
    percent: Optional[int] = Field(
        None,
        description='Specifies a percentage of instances between 0 to 100%, inclusive. For example, specify `80` for 80%.',
    )


class MaxUnavailable1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    calculated: Optional[int] = Field(
        None,
        description='[Output Only] Absolute value of VM instances calculated based on the specific mode. - If the value is `fixed`, then the `calculated` value is equal to the `fixed` value. - If the value is a `percent`, then the `calculated` value is `percent`/100 * `targetSize`. For example, the `calculated` value of a 80% of a managed instance group with 150 instances would be (80/100 * 150) = 120 VM instances. If there is a remainder, the number is rounded.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class NamedPort(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None,
        description='Immutable. The name for this named port. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).',
    )
    port: Optional[int] = Field(
        None,
        description='Immutable. The port number, which can be a value between 1 and 65535.',
    )


class PerInstanceConfigs(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allEffective: Optional[bool] = Field(
        None,
        description="A bit indicating if all of the group's per-instance configs (listed in the output of a listPerInstanceConfigs API call) have status `EFFECTIVE` or there are no per-instance-configs.",
    )


class PreservedState(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disks: Optional[Dict[str, Disks]] = Field(
        None,
        description='Disks created on the instances that will be preserved on instance delete, update, etc. This map is keyed with the device names of the disks.',
    )
    externalIps: Optional[Dict[str, ExternalIps]] = Field(
        None,
        description='External network IPs assigned to the instances that will be preserved on instance delete, update, etc. This map is keyed with the network interface name.',
    )
    internalIps: Optional[Dict[str, InternalIps]] = Field(
        None,
        description='Internal network IPs assigned to the instances that will be preserved on instance delete, update, etc. This map is keyed with the network interface name.',
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The service account to be used as credentials for all operations performed by the managed instance group on instances. The service accounts needs all permissions required to create and delete instances. By default, the service account: {projectNumber}@cloudservices.gserviceaccount.com is used.\n\nAllowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The service account to be used as credentials for all operations performed by the managed instance group on instances. The service accounts needs all permissions required to create and delete instances. By default, the service account: {projectNumber}@cloudservices.gserviceaccount.com is used.\n\nAllowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoHealingPolicies: Optional[List[AutoHealingPolicy]] = Field(
        None,
        description='The autohealing policy for this managed instance group. You can specify only one value.',
    )
    baseInstanceName: Optional[str] = Field(
        None,
        description='The base instance name to use for instances in this group. The value must be 1-58 characters long. Instances are named by appending a hyphen and a random four-character string to the base instance name. The base instance name must comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).',
    )
    description: Optional[str] = Field(
        None, description='Immutable. An optional description of this resource.'
    )
    distributionPolicy: Optional[DistributionPolicy] = Field(
        None,
        description='Policy specifying the intended distribution of managed instances across zones in a regional managed instance group.',
    )
    failoverAction: Optional[str] = Field(
        None,
        description='The action to perform in case of zone failure. Only one value is supported, `NO_FAILOVER`. The default is `NO_FAILOVER`. Possible values: UNKNOWN, NO_FAILOVER',
    )
    instanceTemplateRef: Optional[Union[InstanceTemplateRef, InstanceTemplateRef1]] = (
        None
    )
    location: Optional[str] = Field(
        None, description='Immutable. The location of this resource.'
    )
    namedPorts: Optional[List[NamedPort]] = Field(
        None,
        description='Immutable. Named ports configured for the Instance Groups complementary to this Instance Group Manager.',
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='Immutable. The Project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    serviceAccountRef: Optional[Union[ServiceAccountRef, ServiceAccountRef1]] = None
    statefulPolicy: Optional[StatefulPolicy] = Field(
        None, description='Stateful configuration for this Instanced Group Manager'
    )
    targetPools: Optional[List[Union[TargetPools, TargetPools1]]] = None
    targetSize: int = Field(
        ...,
        description='The target number of running instances for this managed instance group. You can reduce this number by using the instanceGroupManager deleteInstances or abandonInstances methods. Resizing the group also changes this number.',
    )
    updatePolicy: Optional[UpdatePolicy] = Field(
        None, description='The update policy for this managed instance group.'
    )
    versions: Optional[List[Version]] = Field(
        None,
        description='Specifies the instance templates used by this managed instance group to create instances. Each version is defined by an `instanceTemplate` and a `name`. Every version can appear at most once per instance group. This field overrides the top-level `instanceTemplate` field. Read more about the [relationships between these fields](/compute/docs/instance-groups/rolling-out-updates-to-managed-instance-groups#relationship_between_versions_and_instancetemplate_properties_for_a_managed_instance_group). Exactly one `version` must leave the `targetSize` field unset. That version will be applied to all remaining instances. For more information, read about [canary updates](/compute/docs/instance-groups/rolling-out-updates-to-managed-instance-groups#starting_a_canary_update).',
    )


class Stateful(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hasStatefulConfig: Optional[bool] = Field(
        None,
        description='[Output Only] A bit indicating whether the managed instance group has stateful configuration, that is, if you have configured any items in a stateful policy or in per-instance configs. The group might report that it has no stateful config even when there is still some preserved state on a managed instance, for example, if you have deleted all PICs but not yet applied those deletions.',
    )
    isStateful: Optional[bool] = Field(
        None,
        description='[Output Only] A bit indicating whether the managed instance group has stateful configuration, that is, if you have configured any items in a stateful policy or in per-instance configs. The group might report that it has no stateful config even when there is still some preserved state on a managed instance, for example, if you have deleted all PICs but not yet applied those deletions. This field is deprecated in favor of has_stateful_config.',
    )
    perInstanceConfigs: Optional[PerInstanceConfigs] = Field(
        None,
        description='[Output Only] Status of per-instance configs on the instance.',
    )


class StatefulPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    preservedState: Optional[PreservedState] = None


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    creationTimestamp: Optional[str] = Field(
        None,
        description='The creation timestamp for this managed instance group in \\[RFC3339\\](https://www.ietf.org/rfc/rfc3339.txt) text format.',
    )
    currentActions: Optional[CurrentActions] = Field(
        None,
        description='[Output Only] The list of instance actions and the number of instances in this managed instance group that are scheduled for each of those actions.',
    )
    fingerprint: Optional[str] = Field(
        None,
        description='Fingerprint of this resource. This field may be used in optimistic locking. It will be ignored when inserting an InstanceGroupManager. An up-to-date fingerprint must be provided in order to update the InstanceGroupManager, otherwise the request will fail with error `412 conditionNotMet`. To see the latest fingerprint, make a `get()` request to retrieve an InstanceGroupManager.',
    )
    id: Optional[int] = Field(
        None,
        description='[Output Only] A unique identifier for this resource type. The server generates this identifier.',
    )
    instanceGroup: Optional[str] = Field(
        None, description='[Output Only] The URL of the Instance Group resource.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    region: Optional[str] = Field(
        None,
        description='[Output Only] The URL of the [region](/compute/docs/regions-zones/#available) where the managed instance group resides (for regional resources).',
    )
    selfLink: Optional[str] = Field(
        None,
        description='[Output Only] The URL for this managed instance group. The server defines this URL.',
    )
    status: Optional[Status1] = Field(
        None, description='[Output Only] The status of this managed instance group.'
    )
    updatePolicy: Optional[UpdatePolicy1] = None
    zone: Optional[str] = Field(
        None,
        description='[Output Only] The URL of a [zone](/compute/docs/regions-zones/#available) where the managed instance group is located (for zonal resources).',
    )


class Status1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoscaler: Optional[str] = Field(
        None,
        description='[Output Only] The URL of the [Autoscaler](/compute/docs/autoscaler/) that targets this instance group manager.',
    )
    isStable: Optional[bool] = Field(
        None,
        description='[Output Only] A bit indicating whether the managed instance group is in a stable state. A stable state means that: none of the instances in the managed instance group is currently undergoing any type of change (for example, creation, restart, or deletion); no future changes are scheduled for instances in the managed instance group; and the managed instance group itself is not being modified.',
    )
    stateful: Optional[Stateful] = Field(
        None,
        description='[Output Only] Stateful status of the given Instance Group Manager.',
    )
    versionTarget: Optional[VersionTarget] = Field(
        None,
        description="[Output Only] A status of consistency of Instances' versions with their target version specified by `version` field on Instance Group Manager.",
    )


class TargetPools(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeTargetPool` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TargetPools1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeTargetPool` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TargetSize(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    calculated: Optional[int] = Field(
        None,
        description='[Output Only] Absolute value of VM instances calculated based on the specific mode. - If the value is `fixed`, then the `calculated` value is equal to the `fixed` value. - If the value is a `percent`, then the `calculated` value is `percent`/100 * `targetSize`. For example, the `calculated` value of a 80% of a managed instance group with 150 instances would be (80/100 * 150) = 120 VM instances. If there is a remainder, the number is rounded.',
    )
    fixed: Optional[int] = Field(
        None,
        description='Specifies a fixed number of VM instances. This must be a positive integer.',
    )
    percent: Optional[int] = Field(
        None,
        description='Specifies a percentage of instances between 0 to 100%, inclusive. For example, specify `80` for 80%.',
    )


class UpdatePolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    instanceRedistributionType: Optional[str] = Field(
        None,
        description='The [instance redistribution policy](/compute/docs/instance-groups/regional-migs#proactive_instance_redistribution) for regional managed instance groups. Valid values are: - `PROACTIVE` (default): The group attempts to maintain an even distribution of VM instances across zones in the region. - `NONE`: For non-autoscaled groups, proactive redistribution is disabled.',
    )
    maxSurge: Optional[MaxSurge] = Field(
        None,
        description='The maximum number of instances that can be created above the specified `targetSize` during the update process. This value can be either a fixed number or, if the group has 10 or more instances, a percentage. If you set a percentage, the number of instances is rounded if necessary. The default value for `maxSurge` is a fixed value equal to the number of zones in which the managed instance group operates. At least one of either `maxSurge` or `maxUnavailable` must be greater than 0. Learn more about [`maxSurge`](/compute/docs/instance-groups/rolling-out-updates-to-managed-instance-groups#max_surge).',
    )
    maxUnavailable: Optional[MaxUnavailable] = Field(
        None,
        description="The maximum number of instances that can be unavailable during the update process. An instance is considered available if all of the following conditions are satisfied: - The instance's [status](/compute/docs/instances/checking-instance-status) is `RUNNING`. - If there is a [health check](/compute/docs/instance-groups/autohealing-instances-in-migs) on the instance group, the instance's health check status must be `HEALTHY` at least once. If there is no health check on the group, then the instance only needs to have a status of `RUNNING` to be considered available. This value can be either a fixed number or, if the group has 10 or more instances, a percentage. If you set a percentage, the number of instances is rounded if necessary. The default value for `maxUnavailable` is a fixed value equal to the number of zones in which the managed instance group operates. At least one of either `maxSurge` or `maxUnavailable` must be greater than 0. Learn more about [`maxUnavailable`](/compute/docs/instance-groups/rolling-out-updates-to-managed-instance-groups#max_unavailable).",
    )
    minReadySec: Optional[int] = Field(
        None,
        description='Minimum number of seconds to wait for after a newly created instance becomes available. This value must be from range [0, 3600].',
    )
    minimalAction: Optional[str] = Field(
        None,
        description='Minimal action to be taken on an instance. You can specify either `RESTART` to restart existing instances or `REPLACE` to delete and create new instances from the target template. If you specify a `RESTART`, the Updater will attempt to perform that action only. However, if the Updater determines that the minimal action you specify is not enough to perform the update, it might perform a more disruptive action.',
    )
    mostDisruptiveAllowedAction: Optional[str] = Field(
        None,
        description='Most disruptive action that is allowed to be taken on an instance. You can specify either `NONE` to forbid any actions, `REFRESH` to allow actions that do not need instance restart, `RESTART` to allow actions that can be applied without instance replacing or `REPLACE` to allow all possible actions. If the Updater determines that the minimal update action needed is more disruptive than most disruptive allowed action you specify it will not perform the update at all.',
    )
    replacementMethod: Optional[str] = Field(
        None,
        description='What action should be used to replace instances. See minimal_action.REPLACE Possible values: SUBSTITUTE, RECREATE',
    )
    type: Optional[str] = Field(
        None,
        description='The type of update process. You can specify either `PROACTIVE` so that the instance group manager proactively executes actions in order to bring instances to their target versions or `OPPORTUNISTIC` so that no action is proactively executed but the update will be performed as part of other actions (for example, resizes or `recreateInstances` calls).',
    )


class UpdatePolicy1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maxSurge: Optional[MaxSurge1] = None
    maxUnavailable: Optional[MaxUnavailable1] = None


class Version(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    instanceTemplateRef: Optional[Union[InstanceTemplateRef2, InstanceTemplateRef3]] = (
        None
    )
    name: Optional[str] = Field(
        None,
        description='Name of the version. Unique among all versions in the scope of this managed instance group.',
    )
    targetSize: Optional[TargetSize] = Field(
        None,
        description='Specifies the intended number of instances to be created from the `instanceTemplate`. The final number of instances created from the template will be equal to: - If expressed as a fixed number, the minimum of either `targetSize.fixed` or `instanceGroupManager.targetSize` is used. - if expressed as a `percent`, the `targetSize` would be `(targetSize.percent/100 * InstanceGroupManager.targetSize)` If there is a remainder, the number is rounded. If unset, this version will update any remaining instances not updated by another `version`. Read [Starting a canary update](/compute/docs/instance-groups/rolling-out-updates-to-managed-instance-groups#starting_a_canary_update) for more information.',
    )


class VersionTarget(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    isReached: Optional[bool] = Field(
        None,
        description="[Output Only] A bit indicating whether version target has been reached in this managed instance group, i.e. all instances are in their target version. Instances' target version are specified by `version` field on Instance Group Manager.",
    )


class Zone(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    zone: Optional[str] = Field(
        None,
        description='Immutable. The URL of the [zone](/compute/docs/regions-zones/#available). The zone must exist in the region where the managed instance group is located.',
    )
