# generated by datamodel-codegen:
#   filename:  computenodetemplate_v1beta1.json
#   timestamp: 2024-03-15T04:51:45+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class NodeTypeFlexibility(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cpus: Optional[str] = Field(
        None, description='Immutable. Number of virtual CPUs to use.'
    )
    localSsd: Optional[str] = Field(None, description='Use local SSD.')
    memory: Optional[str] = Field(
        None,
        description='Immutable. Physical memory available to the node, defined in MB.',
    )


class ServerBinding(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    type: str = Field(
        ...,
        description='Immutable. Type of server binding policy. If \'RESTART_NODE_ON_ANY_SERVER\',\nnodes using this template will restart on any physical server\nfollowing a maintenance event.\n\nIf \'RESTART_NODE_ON_MINIMAL_SERVER\', nodes using this template\nwill restart on the same physical server following a maintenance\nevent, instead of being live migrated to or restarted on a new\nphysical server. This option may be useful if you are using\nsoftware licenses tied to the underlying server characteristics\nsuch as physical sockets or cores, to avoid the need for\nadditional licenses when maintenance occurs. However, VMs on such\nnodes will experience outages while maintenance is applied. Possible values: ["RESTART_NODE_ON_ANY_SERVER", "RESTART_NODE_ON_MINIMAL_SERVERS"].',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cpuOvercommitType: Optional[str] = Field(
        None,
        description='Immutable. CPU overcommit. Default value: "NONE" Possible values: ["ENABLED", "NONE"].',
    )
    description: Optional[str] = Field(
        None, description='Immutable. An optional textual description of the resource.'
    )
    nodeType: Optional[str] = Field(
        None,
        description='Immutable. Node type to use for nodes group that are created from this template.\nOnly one of nodeTypeFlexibility and nodeType can be specified.',
    )
    nodeTypeFlexibility: Optional[NodeTypeFlexibility] = Field(
        None,
        description='Immutable. Flexible properties for the desired node type. Node groups that\nuse this node template will create nodes of a type that matches\nthese properties. Only one of nodeTypeFlexibility and nodeType can\nbe specified.',
    )
    region: str = Field(
        ...,
        description='Immutable. Region where nodes using the node template will be created.\nIf it is not provided, the provider region is used.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    serverBinding: Optional[ServerBinding] = Field(
        None,
        description='Immutable. The server binding policy for nodes using this template. Determines\nwhere the nodes should restart following a maintenance event.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    creationTimestamp: Optional[str] = Field(
        None, description='Creation timestamp in RFC3339 text format.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    selfLink: Optional[str] = None
