# generated by datamodel-codegen:
#   filename:  computereservation_v1beta1.json
#   timestamp: 2024-03-15T04:51:50+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class GuestAccelerator(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    acceleratorCount: int = Field(
        ...,
        description='Immutable. The number of the guest accelerator cards exposed to\nthis instance.',
    )
    acceleratorType: str = Field(
        ...,
        description="Immutable. The full or partial URL of the accelerator type to\nattach to this instance. For example:\n'projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100'\n\nIf you are creating an instance template, specify only the accelerator name.",
    )


class InstanceProperties(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    guestAccelerators: Optional[List[GuestAccelerator]] = Field(
        None, description='Immutable. Guest accelerator type and count.'
    )
    localSsds: Optional[List[LocalSsd]] = Field(
        None,
        description="Immutable. The amount of local ssd to reserve with each instance. This\nreserves disks of type 'local-ssd'.",
    )
    machineType: str = Field(
        ..., description='Immutable. The name of the machine type to reserve.'
    )
    minCpuPlatform: Optional[str] = Field(
        None,
        description='Immutable. The minimum CPU platform for the reservation. For example,\n\'"Intel Skylake"\'. See\nthe CPU platform availability reference](https://cloud.google.com/compute/docs/instances/specify-min-cpu-platform#availablezones)\nfor information on available CPU platforms.',
    )


class LocalSsd(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    diskSizeGb: int = Field(
        ..., description='Immutable. The size of the disk in base-2 GB.'
    )
    interface: Optional[str] = Field(
        None,
        description='Immutable. The disk interface to use for attaching this disk. Default value: "SCSI" Possible values: ["SCSI", "NVME"].',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None, description='Immutable. An optional description of this resource.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    specificReservation: SpecificReservation = Field(
        ..., description='Reservation for instances with specific machine shapes.'
    )
    specificReservationRequired: Optional[bool] = Field(
        None,
        description='Immutable. When set to true, only VMs that target this reservation by name can\nconsume this reservation. Otherwise, it can be consumed by VMs with\naffinity for any reservation. Defaults to false.',
    )
    zone: str = Field(
        ..., description='Immutable. The zone where the reservation is made.'
    )


class SpecificReservation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    count: int = Field(..., description='The number of resources that are allocated.')
    inUseCount: Optional[int] = Field(
        None, description='How many instances are in use.'
    )
    instanceProperties: InstanceProperties = Field(
        ..., description='Immutable. The instance properties for the reservation.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    commitment: Optional[str] = Field(
        None,
        description='Full or partial URL to a parent commitment. This field displays for\nreservations that are tied to a commitment.',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    creationTimestamp: Optional[str] = Field(
        None, description='Creation timestamp in RFC3339 text format.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    selfLink: Optional[str] = None
    status: Optional[str] = Field(None, description='The status of the reservation.')
