# generated by datamodel-codegen:
#   filename:  computerouterpeer_v1beta1.json
#   timestamp: 2024-03-15T04:51:53+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AdvertisedIpRange(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None, description='User-specified description for the IP range.'
    )
    range: str = Field(
        ...,
        description='The IP range to advertise. The value must be a\nCIDR-formatted string.',
    )


class Bfd(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    minReceiveInterval: Optional[int] = Field(
        None,
        description='The minimum interval, in milliseconds, between BFD control packets\nreceived from the peer router. The actual value is negotiated\nbetween the two routers and is equal to the greater of this value\nand the transmit interval of the other router. If set, this value\nmust be between 1000 and 30000.',
    )
    minTransmitInterval: Optional[int] = Field(
        None,
        description='The minimum interval, in milliseconds, between BFD control packets\ntransmitted to the peer router. The actual value is negotiated\nbetween the two routers and is equal to the greater of this value\nand the corresponding receive interval of the other router. If set,\nthis value must be between 1000 and 30000.',
    )
    multiplier: Optional[int] = Field(
        None,
        description='The number of consecutive BFD packets that must be missed before\nBFD declares that a peer is unavailable. If set, the value must\nbe a value between 5 and 16.',
    )
    sessionInitializationMode: str = Field(
        ...,
        description='The BFD session initialization mode for this BGP peer.\nIf set to \'ACTIVE\', the Cloud Router will initiate the BFD session\nfor this BGP peer. If set to \'PASSIVE\', the Cloud Router will wait\nfor the peer router to initiate the BFD session for this BGP peer.\nIf set to \'DISABLED\', BFD is disabled for this BGP peer. Possible values: ["ACTIVE", "DISABLED", "PASSIVE"].',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class IpAddress(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = None


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class RouterApplianceInstanceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeInstance` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RouterApplianceInstanceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeInstance` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RouterInterfaceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `ComputeRouterInterface` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RouterInterfaceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `ComputeRouterInterface` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RouterRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `ComputeRouter` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RouterRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `ComputeRouter` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    advertiseMode: Optional[str] = Field(
        None,
        description='User-specified flag to indicate which mode to use for advertisement.\nValid values of this enum field are: \'DEFAULT\', \'CUSTOM\' Default value: "DEFAULT" Possible values: ["DEFAULT", "CUSTOM"].',
    )
    advertisedGroups: Optional[List[str]] = Field(
        None,
        description='User-specified list of prefix groups to advertise in custom\nmode, which currently supports the following option:\n\n* \'ALL_SUBNETS\': Advertises all of the router\'s own VPC subnets.\nThis excludes any routes learned for subnets that use VPC Network\nPeering.\n\n\nNote that this field can only be populated if advertiseMode is \'CUSTOM\'\nand overrides the list defined for the router (in the "bgp" message).\nThese groups are advertised in addition to any specified prefixes.\nLeave this field blank to advertise no custom groups.',
    )
    advertisedIpRanges: Optional[List[AdvertisedIpRange]] = Field(
        None,
        description="User-specified list of individual IP ranges to advertise in\ncustom mode. This field can only be populated if advertiseMode\nis 'CUSTOM' and is advertised to all peers of the router. These IP\nranges will be advertised in addition to any specified groups.\nLeave this field blank to advertise no custom IP ranges.",
    )
    advertisedRoutePriority: Optional[int] = Field(
        None,
        description='The priority of routes advertised to this BGP peer.\nWhere there is more than one matching route of maximum\nlength, the routes with the lowest priority value win.',
    )
    bfd: Optional[Bfd] = Field(
        None, description='BFD configuration for the BGP peering.'
    )
    enable: Optional[bool] = Field(
        None,
        description='The status of the BGP peer connection. If set to false, any active session\nwith the peer is terminated and all associated routing information is removed.\nIf set to true, the peer connection can be established with routing information.\nThe default is true.',
    )
    enableIpv6: Optional[bool] = Field(
        None,
        description='Enable IPv6 traffic over BGP Peer. If not specified, it is disabled by default.',
    )
    ipAddress: Optional[IpAddress] = Field(
        None,
        description='IP address of the interface inside Google Cloud Platform.\nOnly IPv4 is supported.',
    )
    ipv6NexthopAddress: Optional[str] = Field(
        None,
        description='IPv6 address of the interface inside Google Cloud Platform.\nThe address must be in the range 2600:2d00:0:2::/64 or 2600:2d00:0:3::/64.\nIf you do not specify the next hop addresses, Google Cloud automatically\nassigns unused addresses from the 2600:2d00:0:2::/64 or 2600:2d00:0:3::/64 range for you.',
    )
    peerAsn: int = Field(
        ...,
        description='Peer BGP Autonomous System Number (ASN).\nEach BGP interface may use a different value.',
    )
    peerIpAddress: Optional[str] = Field(
        None,
        description="IP address of the BGP interface outside Google Cloud Platform.\nOnly IPv4 is supported. Required if 'ip_address' is set.",
    )
    peerIpv6NexthopAddress: Optional[str] = Field(
        None,
        description='IPv6 address of the BGP interface outside Google Cloud Platform.\nThe address must be in the range 2600:2d00:0:2::/64 or 2600:2d00:0:3::/64.\nIf you do not specify the next hop addresses, Google Cloud automatically\nassigns unused addresses from the 2600:2d00:0:2::/64 or 2600:2d00:0:3::/64 range for you.',
    )
    region: str = Field(
        ...,
        description='Immutable. Region where the router and BgpPeer reside.\nIf it is not provided, the provider region is used.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    routerApplianceInstanceRef: Optional[
        Union[RouterApplianceInstanceRef, RouterApplianceInstanceRef1]
    ] = Field(
        None,
        description='The URI of the VM instance that is used as third-party router\nappliances such as Next Gen Firewalls, Virtual Routers, or Router\nAppliances. The VM instance must be located in zones contained in\nthe same region as this Cloud Router. The VM instance is the peer\nside of the BGP session.',
    )
    routerInterfaceRef: Union[RouterInterfaceRef, RouterInterfaceRef1] = Field(
        ..., description='The interface the BGP peer is associated with.'
    )
    routerRef: Union[RouterRef, RouterRef1] = Field(
        ..., description='The Cloud Router in which this BGP peer will be configured.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    managementType: Optional[str] = Field(
        None,
        description="The resource that configures and manages this BGP peer.\n\n* 'MANAGED_BY_USER' is the default value and can be managed by\nyou or other users\n* 'MANAGED_BY_ATTACHMENT' is a BGP peer that is configured and\nmanaged by Cloud Interconnect, specifically by an\nInterconnectAttachment of type PARTNER. Google automatically\ncreates, updates, and deletes this type of BGP peer when the\nPARTNER InterconnectAttachment is created, updated,\nor deleted.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
