# generated by datamodel-codegen:
#   filename:  containercluster_v1beta1.json
#   timestamp: 2024-03-15T04:52:04+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AdditionalPodRangesConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    podRangeNames: List[str] = Field(
        ...,
        description='Name for pod secondary ipv4 range which has the actual range defined ahead.',
    )


class AddonsConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cloudrunConfig: Optional[CloudrunConfig] = Field(
        None,
        description='The status of the CloudRun addon. It is disabled by default. Set disabled = false to enable.',
    )
    configConnectorConfig: Optional[ConfigConnectorConfig] = Field(
        None, description='The of the Config Connector addon.'
    )
    dnsCacheConfig: Optional[DnsCacheConfig] = Field(
        None,
        description='The status of the NodeLocal DNSCache addon. It is disabled by default. Set enabled = true to enable.',
    )
    gcePersistentDiskCsiDriverConfig: Optional[GcePersistentDiskCsiDriverConfig] = (
        Field(
            None,
            description='Whether this cluster should enable the Google Compute Engine Persistent Disk Container Storage Interface (CSI) Driver. Set enabled = true to enable. The Compute Engine persistent disk CSI Driver is enabled by default on newly created clusters for the following versions: Linux clusters: GKE version 1.18.10-gke.2100 or later, or 1.19.3-gke.2100 or later.',
        )
    )
    gcpFilestoreCsiDriverConfig: Optional[GcpFilestoreCsiDriverConfig] = Field(
        None,
        description='The status of the Filestore CSI driver addon, which allows the usage of filestore instance as volumes. Defaults to disabled; set enabled = true to enable.',
    )
    gcsFuseCsiDriverConfig: Optional[GcsFuseCsiDriverConfig] = Field(
        None,
        description='The status of the GCS Fuse CSI driver addon, which allows the usage of gcs bucket as volumes. Defaults to disabled; set enabled = true to enable.',
    )
    gkeBackupAgentConfig: Optional[GkeBackupAgentConfig] = Field(
        None,
        description='The status of the Backup for GKE Agent addon. It is disabled by default. Set enabled = true to enable.',
    )
    horizontalPodAutoscaling: Optional[HorizontalPodAutoscaling] = Field(
        None,
        description='The status of the Horizontal Pod Autoscaling addon, which increases or decreases the number of replica pods a replication controller has based on the resource usage of the existing pods. It ensures that a Heapster pod is running in the cluster, which is also used by the Cloud Monitoring service. It is enabled by default; set disabled = true to disable.',
    )
    httpLoadBalancing: Optional[HttpLoadBalancing] = Field(
        None,
        description='The status of the HTTP (L7) load balancing controller addon, which makes it easy to set up HTTP load balancers for services in a cluster. It is enabled by default; set disabled = true to disable.',
    )
    istioConfig: Optional[IstioConfig] = Field(
        None, description='The status of the Istio addon.'
    )
    kalmConfig: Optional[KalmConfig] = Field(
        None,
        description='Configuration for the KALM addon, which manages the lifecycle of k8s. It is disabled by default; Set enabled = true to enable.',
    )
    networkPolicyConfig: Optional[NetworkPolicyConfig] = Field(
        None,
        description='Whether we should enable the network policy addon for the master. This must be enabled in order to enable network policy for the nodes. To enable this, you must also define a network_policy block, otherwise nothing will happen. It can only be disabled if the nodes already do not have network policies enabled. Defaults to disabled; set disabled = false to enable.',
    )


class AdvancedDatapathObservabilityConfigItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableMetrics: bool = Field(
        ..., description='Whether or not the advanced datapath metrics are enabled.'
    )
    relayMode: Optional[str] = Field(
        None, description='Mode used to make Relay available.'
    )


class AdvancedMachineFeatures(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    threadsPerCore: int = Field(
        ...,
        description='Immutable. The number of threads per physical core. To disable simultaneous multithreading (SMT) set this to 1. If unset, the maximum number of threads supported per core by the underlying processor is assumed.',
    )


class AuthenticatorGroupsConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    securityGroup: str = Field(
        ...,
        description='The name of the RBAC security group for use with Google security groups in Kubernetes RBAC. Group name must be in format gke-security-groups@yourdomain.com.',
    )


class AutoProvisioningDefaults(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bootDiskKMSKeyRef: Optional[Union[BootDiskKMSKeyRef, BootDiskKMSKeyRef1]] = Field(
        None,
        description='Immutable. The Customer Managed Encryption Key used to encrypt the\nboot disk attached to each node in the node pool.',
    )
    diskSize: Optional[int] = Field(
        None,
        description='Size of the disk attached to each node, specified in GB. The smallest allowed disk size is 10GB.',
    )
    imageType: Optional[str] = Field(
        None,
        description='The default image type used by NAP once a new node pool is being created.',
    )
    management: Optional[Management] = Field(
        None, description='NodeManagement configuration for this NodePool.'
    )
    minCpuPlatform: Optional[str] = Field(
        None,
        description='Minimum CPU platform to be used by this instance. The instance may be scheduled on the specified or newer CPU platform. Applicable values are the friendly names of CPU platforms, such as Intel Haswell.',
    )
    oauthScopes: Optional[List[str]] = Field(
        None, description='Scopes that are used by NAP when creating node pools.'
    )
    serviceAccountRef: Optional[Union[ServiceAccountRef, ServiceAccountRef1]] = None
    shieldedInstanceConfig: Optional[ShieldedInstanceConfig] = Field(
        None, description='Shielded Instance options.'
    )
    upgradeSettings: Optional[UpgradeSettings] = Field(
        None, description='Specifies the upgrade settings for NAP created node pools.'
    )


class BigqueryDestination(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    datasetId: str = Field(..., description='The ID of a BigQuery Dataset.')


class BinaryAuthorization(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: Optional[bool] = Field(
        None,
        description='DEPRECATED. Deprecated in favor of evaluation_mode. Enable Binary Authorization for this cluster.',
    )
    evaluationMode: Optional[str] = Field(
        None,
        description='Mode of operation for Binary Authorization policy evaluation.',
    )


class BlueGreenSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    nodePoolSoakDuration: Optional[str] = Field(
        None,
        description='Time needed after draining entire blue pool. After this period, blue pool will be cleaned up.\n\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tA duration in seconds with up to nine fractional digits, ending with \'s\'. Example: "3.5s".',
    )
    standardRolloutPolicy: Optional[StandardRolloutPolicy] = Field(
        None, description='Standard policy for the blue-green upgrade.'
    )


class BootDiskKMSCryptoKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BootDiskKMSCryptoKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BootDiskKMSKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BootDiskKMSKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class CidrBlock(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cidrBlock: str = Field(
        ...,
        description='External network that can access Kubernetes master through HTTPS. Must be specified in CIDR notation.',
    )
    displayName: Optional[str] = Field(
        None, description='Field for users to identify CIDR blocks.'
    )


class ClientCertificateConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    issueClientCertificate: bool = Field(
        ...,
        description='Immutable. Whether client certificate authorization is enabled for this cluster.',
    )


class CloudrunConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool
    loadBalancerType: Optional[str] = None


class ClusterAutoscaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoProvisioningDefaults: Optional[AutoProvisioningDefaults] = Field(
        None, description='Contains defaults for a node pool created by NAP.'
    )
    autoscalingProfile: Optional[str] = Field(
        None,
        description='Configuration options for the Autoscaling profile feature, which lets you choose whether the cluster autoscaler should optimize for resource utilization or resource availability when deciding to remove nodes from a cluster. Can be BALANCED or OPTIMIZE_UTILIZATION. Defaults to BALANCED.',
    )
    enabled: Optional[bool] = Field(
        None,
        description='Whether node auto-provisioning is enabled. Resource limits for cpu and memory must be defined to enable node auto-provisioning.',
    )
    resourceLimits: Optional[List[ResourceLimit]] = Field(
        None,
        description='Global constraints for machine resources in the cluster. Configuring the cpu and memory types is required if node auto-provisioning is enabled. These limits will apply to node pool autoscaling in addition to node auto-provisioning.',
    )


class ClusterTelemetry(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    type: str = Field(..., description='Type of the integration.')


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class ConfidentialNodes(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='Immutable. Whether Confidential Nodes feature is enabled for all nodes in this cluster.',
    )


class ConfidentialNodes1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='Immutable. Whether Confidential Nodes feature is enabled for all nodes in this pool.',
    )


class ConfigConnectorConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class CostManagementConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='Whether to enable GKE cost allocation. When you enable GKE cost allocation, the cluster name and namespace of your GKE workloads appear in the labels field of the billing export to BigQuery. Defaults to false.',
    )


class DailyMaintenanceWindow(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    duration: Optional[str] = None
    startTime: str


class DatabaseEncryption(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    keyName: Optional[str] = Field(
        None, description='The key to use to encrypt/decrypt secrets.'
    )
    state: str = Field(..., description='ENCRYPTED or DECRYPTED.')


class DefaultSnatStatus(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool = Field(
        ...,
        description='When disabled is set to false, default IP masquerade rules will be applied to the nodes to prevent sNAT on cluster internal traffic.',
    )


class DnsCacheConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class DnsConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clusterDns: Optional[str] = Field(
        None, description='Which in-cluster DNS provider should be used.'
    )
    clusterDnsDomain: Optional[str] = Field(
        None, description='The suffix used for all cluster service records.'
    )
    clusterDnsScope: Optional[str] = Field(
        None, description='The scope of access to cluster DNS records.'
    )


class EnableK8sBetaApis(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabledApis: List[str] = Field(..., description='Enabled Kubernetes Beta APIs.')


class EphemeralStorageConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    localSsdCount: int = Field(
        ...,
        description='Immutable. Number of local SSDs to use to back ephemeral storage. Uses NVMe interfaces. Each local SSD must be 375 or 3000 GB in size, and all local SSDs must share the same size.',
    )


class EphemeralStorageLocalSsdConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    localSsdCount: int = Field(
        ...,
        description='Immutable. Number of local SSDs to use to back ephemeral storage. Uses NVMe interfaces. Each local SSD must be 375 or 3000 GB in size, and all local SSDs must share the same size.',
    )


class ExclusionOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    scope: str = Field(
        ...,
        description='The scope of automatic upgrades to restrict in the exclusion window.',
    )


class FastSocket(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Whether or not NCCL Fast Socket is enabled.'
    )


class Filter(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    eventType: List[str] = Field(
        ...,
        description='Can be used to filter what notifications are sent. Valid values include include UPGRADE_AVAILABLE_EVENT, UPGRADE_EVENT and SECURITY_BULLETIN_EVENT.',
    )


class GatewayApiConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    channel: str = Field(
        ..., description='The Gateway API release channel to use for Gateway API.'
    )


class GcePersistentDiskCsiDriverConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class GcfsConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(..., description='Immutable. Whether or not GCFS is enabled.')


class GcfsConfig1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(..., description='Whether or not GCFS is enabled.')


class GcpFilestoreCsiDriverConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class GcsFuseCsiDriverConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class GkeBackupAgentConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class GpuDriverInstallationConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    gpuDriverVersion: str = Field(
        ..., description='Immutable. Mode for how the GPU driver is installed.'
    )


class GpuSharingConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    gpuSharingStrategy: str = Field(
        ...,
        description='Immutable. The type of GPU sharing strategy to enable on the GPU node. Possible values are described in the API package (https://pkg.go.dev/google.golang.org/api/container/v1#GPUSharingConfig).',
    )
    maxSharedClientsPerGpu: int = Field(
        ...,
        description='Immutable. The maximum number of containers that can share a GPU.',
    )


class GuestAcceleratorItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    count: int = Field(
        ...,
        description='Immutable. The number of the accelerator cards exposed to an instance.',
    )
    gpuDriverInstallationConfig: Optional[GpuDriverInstallationConfig] = Field(
        None,
        description='Immutable. Configuration for auto installation of GPU driver.',
    )
    gpuPartitionSize: Optional[str] = Field(
        None,
        description='Immutable. Size of partitions to create on the GPU. Valid values are described in the NVIDIA mig user guide (https://docs.nvidia.com/datacenter/tesla/mig-user-guide/#partitioning).',
    )
    gpuSharingConfig: Optional[GpuSharingConfig] = Field(
        None, description='Immutable. Configuration for GPU sharing.'
    )
    type: str = Field(..., description='Immutable. The accelerator type resource name.')


class Gvnic(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Immutable. Whether or not gvnic is enabled.'
    )


class HorizontalPodAutoscaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool


class HostMaintenancePolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maintenanceInterval: str = Field(..., description='Immutable. .')


class HttpLoadBalancing(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool


class IdentityServiceConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: Optional[bool] = Field(
        None, description='Whether to enable the Identity Service component.'
    )


class IpAllocationPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    additionalPodRangesConfig: Optional[AdditionalPodRangesConfig] = Field(
        None,
        description='AdditionalPodRangesConfig is the configuration for additional pod secondary ranges supporting the ClusterUpdate message.',
    )
    clusterIpv4CidrBlock: Optional[str] = Field(
        None,
        description='Immutable. The IP address range for the cluster pod IPs. Set to blank to have a range chosen with the default size. Set to /netmask (e.g. /14) to have a range chosen with a specific netmask. Set to a CIDR notation (e.g. 10.96.0.0/14) from the RFC-1918 private networks (e.g. 10.0.0.0/8, 172.16.0.0/12, 192.168.0.0/16) to pick a specific range to use.',
    )
    clusterSecondaryRangeName: Optional[str] = Field(
        None,
        description="Immutable. The name of the existing secondary range in the cluster's subnetwork to use for pod IP addresses. Alternatively, cluster_ipv4_cidr_block can be used to automatically create a GKE-managed one.",
    )
    podCidrOverprovisionConfig: Optional[PodCidrOverprovisionConfig] = Field(
        None,
        description='Immutable. Configuration for cluster level pod cidr overprovision. Default is disabled=false.',
    )
    servicesIpv4CidrBlock: Optional[str] = Field(
        None,
        description='Immutable. The IP address range of the services IPs in this cluster. Set to blank to have a range chosen with the default size. Set to /netmask (e.g. /14) to have a range chosen with a specific netmask. Set to a CIDR notation (e.g. 10.96.0.0/14) from the RFC-1918 private networks (e.g. 10.0.0.0/8, 172.16.0.0/12, 192.168.0.0/16) to pick a specific range to use.',
    )
    servicesSecondaryRangeName: Optional[str] = Field(
        None,
        description="Immutable. The name of the existing secondary range in the cluster's subnetwork to use for service ClusterIPs. Alternatively, services_ipv4_cidr_block can be used to automatically create a GKE-managed one.",
    )
    stackType: Optional[str] = Field(
        None,
        description='Immutable. The IP Stack type of the cluster. Choose between IPV4 and IPV4_IPV6. Default type is IPV4 Only if not set.',
    )


class IstioConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    auth: Optional[str] = Field(
        None,
        description='The authentication type between services in Istio. Available options include AUTH_MUTUAL_TLS.',
    )
    disabled: bool = Field(
        ...,
        description='The status of the Istio addon, which makes it easy to set up Istio for services in a cluster. It is disabled by default. Set disabled = false to enable.',
    )


class KalmConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool


class KubeletConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cpuCfsQuota: Optional[bool] = Field(
        None,
        description='Enable CPU CFS quota enforcement for containers that specify CPU limits.',
    )
    cpuCfsQuotaPeriod: Optional[str] = Field(
        None, description="Set the CPU CFS quota period value 'cpu.cfs_period_us'."
    )
    cpuManagerPolicy: str = Field(
        ..., description='Control the CPU management policy on the node.'
    )
    podPidsLimit: Optional[int] = Field(
        None,
        description='Controls the maximum number of processes allowed to run in a pod.',
    )


class LinuxNodeConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    sysctls: Dict[str, str] = Field(
        ...,
        description='The Linux kernel parameters to be applied to the nodes and all pods running on the nodes.',
    )


class LocalNvmeSsdBlockConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    localSsdCount: int = Field(
        ...,
        description='Immutable. Number of raw-block local NVMe SSD disks to be attached to the node. Each local SSD is 375 GB in size.',
    )


class LoggingConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableComponents: List[str] = Field(
        ...,
        description='GKE components exposing logs. Valid values include SYSTEM_COMPONENTS, APISERVER, CONTROLLER_MANAGER, SCHEDULER, and WORKLOADS.',
    )


class MaintenanceExclusionItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    endTime: str
    exclusionName: str
    exclusionOptions: Optional[ExclusionOptions] = Field(
        None, description='Maintenance exclusion related options.'
    )
    startTime: str


class MaintenancePolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    dailyMaintenanceWindow: Optional[DailyMaintenanceWindow] = Field(
        None,
        description='Time window specified for daily maintenance operations. Specify start_time in RFC3339 format "HH:MM”, where HH : [00-23] and MM : [00-59] GMT.',
    )
    maintenanceExclusion: Optional[List[MaintenanceExclusionItem]] = Field(
        None,
        description='Exceptions to maintenance window. Non-emergency maintenance should not occur in these windows.',
    )
    recurringWindow: Optional[RecurringWindow] = Field(
        None, description='Time window for recurring maintenance operations.'
    )


class ManagedPrometheus(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Whether or not the managed collection is enabled.'
    )


class Management(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoRepair: Optional[bool] = Field(
        None,
        description='Specifies whether the node auto-repair is enabled for the node pool. If enabled, the nodes in this node pool will be monitored and, if they fail health checks too many times, an automatic repair action will be triggered.',
    )
    autoUpgrade: Optional[bool] = Field(
        None,
        description='Specifies whether node auto-upgrade is enabled for the node pool. If enabled, node auto-upgrade helps keep the nodes in your node pool up to date with the latest release version of Kubernetes.',
    )
    upgradeOptions: Optional[List[UpgradeOption]] = Field(
        None, description='Specifies the Auto Upgrade knobs for the node pool.'
    )


class MasterAuth(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clientCertificate: Optional[str] = Field(
        None,
        description='Base64 encoded public certificate used by clients to authenticate to the cluster endpoint.',
    )
    clientCertificateConfig: Optional[ClientCertificateConfig] = Field(
        None,
        description='Immutable. Whether client certificate authorization is enabled for this cluster.',
    )
    clientKey: Optional[str] = Field(
        None,
        description='Base64 encoded private key used by clients to authenticate to the cluster endpoint.',
    )
    clusterCaCertificate: Optional[str] = Field(
        None,
        description='Base64 encoded public certificate that is the root of trust for the cluster.',
    )
    password: Optional[Union[Password, Password1]] = Field(
        None,
        description='The password to use for HTTP basic authentication when accessing the Kubernetes master endpoint.',
    )
    username: Optional[str] = Field(
        None,
        description='The username to use for HTTP basic authentication when accessing the Kubernetes master endpoint. If not present basic auth will be disabled.',
    )


class MasterAuthorizedNetworksConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cidrBlocks: Optional[List[CidrBlock]] = Field(
        None,
        description='External networks that can access the Kubernetes cluster master through HTTPS.',
    )
    gcpPublicCidrsAccessEnabled: Optional[bool] = Field(
        None,
        description='Whether master is accessbile via Google Compute Engine Public IP addresses.',
    )


class MasterGlobalAccessConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Whether the cluster master is accessible globally or not.'
    )


class MeshCertificates(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableCertificates: bool = Field(
        ...,
        description='When enabled the GKE Workload Identity Certificates controller and node agent will be deployed in the cluster.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class MonitoringConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    advancedDatapathObservabilityConfig: Optional[
        List[AdvancedDatapathObservabilityConfigItem]
    ] = Field(
        None, description='Configuration of Advanced Datapath Observability features.'
    )
    enableComponents: Optional[List[str]] = Field(
        None,
        description='GKE components exposing metrics. Valid values include SYSTEM_COMPONENTS, APISERVER, SCHEDULER, CONTROLLER_MANAGER, STORAGE, HPA, POD, DAEMONSET, DEPLOYMENT, STATEFULSET and WORKLOADS.',
    )
    managedPrometheus: Optional[ManagedPrometheus] = Field(
        None,
        description='Configuration for Google Cloud Managed Services for Prometheus.',
    )


class NetworkPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Whether network policy is enabled on the cluster.'
    )
    provider: Optional[str] = Field(
        None,
        description='The selected network policy provider. Defaults to PROVIDER_UNSPECIFIED.',
    )


class NetworkPolicyConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool


class NetworkRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NetworkRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NetworkTags(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tags: Optional[List[str]] = Field(
        None, description='List of network tags applied to auto-provisioned node pools.'
    )


class NodeAffinityItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    key: str = Field(..., description='Immutable. .')
    operator: str = Field(..., description='Immutable. .')
    values: List[str] = Field(..., description='Immutable. .')


class NodeConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    advancedMachineFeatures: Optional[AdvancedMachineFeatures] = Field(
        None,
        description='Immutable. Specifies options for controlling advanced machine features.',
    )
    bootDiskKMSCryptoKeyRef: Optional[
        Union[BootDiskKMSCryptoKeyRef, BootDiskKMSCryptoKeyRef1]
    ] = None
    confidentialNodes: Optional[ConfidentialNodes1] = Field(
        None,
        description="Immutable. Configuration for the confidential nodes feature, which makes nodes run on confidential VMs. Warning: This configuration can't be changed (or added/removed) after pool creation without deleting and recreating the entire pool.",
    )
    diskSizeGb: Optional[int] = Field(
        None,
        description='Immutable. Size of the disk attached to each node, specified in GB. The smallest allowed disk size is 10GB.',
    )
    diskType: Optional[str] = Field(
        None,
        description='Immutable. Type of the disk attached to each node. Such as pd-standard, pd-balanced or pd-ssd.',
    )
    ephemeralStorageConfig: Optional[EphemeralStorageConfig] = Field(
        None,
        description='Immutable. Parameters for the ephemeral storage filesystem. If unspecified, ephemeral storage is backed by the boot disk.',
    )
    ephemeralStorageLocalSsdConfig: Optional[EphemeralStorageLocalSsdConfig] = Field(
        None,
        description='Immutable. Parameters for the ephemeral storage filesystem. If unspecified, ephemeral storage is backed by the boot disk.',
    )
    fastSocket: Optional[FastSocket] = Field(
        None, description='Enable or disable NCCL Fast Socket in the node pool.'
    )
    gcfsConfig: Optional[GcfsConfig] = Field(
        None, description='Immutable. GCFS configuration for this node.'
    )
    guestAccelerator: Optional[List[GuestAcceleratorItem]] = Field(
        None,
        description='Immutable. List of the type and count of accelerator cards attached to the instance.',
    )
    gvnic: Optional[Gvnic] = Field(
        None, description='Immutable. Enable or disable gvnic in the node pool.'
    )
    hostMaintenancePolicy: Optional[HostMaintenancePolicy] = Field(
        None,
        description='Immutable. The maintenance policy for the hosts on which the GKE VMs run on.',
    )
    imageType: Optional[str] = Field(
        None,
        description='The image type to use for this node. Note that for a given image type, the latest version of it will be used.',
    )
    kubeletConfig: Optional[KubeletConfig] = Field(
        None, description='Node kubelet configs.'
    )
    labels: Optional[Dict[str, str]] = Field(
        None,
        description='Immutable. The map of Kubernetes labels (key/value pairs) to be applied to each node. These will added in addition to any default label(s) that Kubernetes may apply to the node.',
    )
    linuxNodeConfig: Optional[LinuxNodeConfig] = Field(
        None, description='Parameters that can be configured on Linux nodes.'
    )
    localNvmeSsdBlockConfig: Optional[LocalNvmeSsdBlockConfig] = Field(
        None, description='Immutable. Parameters for raw-block local NVMe SSDs.'
    )
    localSsdCount: Optional[int] = Field(
        None,
        description='Immutable. The number of local SSD disks to be attached to the node.',
    )
    loggingVariant: Optional[str] = Field(
        None,
        description='Type of logging agent that is used as the default value for node pools in the cluster. Valid values include DEFAULT and MAX_THROUGHPUT.',
    )
    machineType: Optional[str] = Field(
        None, description='Immutable. The name of a Google Compute Engine machine type.'
    )
    metadata: Optional[Dict[str, str]] = Field(
        None,
        description='Immutable. The metadata key/value pairs assigned to instances in the cluster.',
    )
    minCpuPlatform: Optional[str] = Field(
        None,
        description='Immutable. Minimum CPU platform to be used by this instance. The instance may be scheduled on the specified or newer CPU platform.',
    )
    nodeGroupRef: Optional[Union[NodeGroupRef, NodeGroupRef1]] = Field(
        None,
        description='Immutable. Setting this field will assign instances\nof this pool to run on the specified node group. This is useful\nfor running workloads on sole tenant nodes.',
    )
    oauthScopes: Optional[List[str]] = Field(
        None,
        description='Immutable. The set of Google API scopes to be made available on all of the node VMs.',
    )
    preemptible: Optional[bool] = Field(
        None,
        description='Immutable. Whether the nodes are created as preemptible VM instances.',
    )
    reservationAffinity: Optional[ReservationAffinity] = Field(
        None,
        description='Immutable. The reservation affinity configuration for the node pool.',
    )
    resourceLabels: Optional[Dict[str, str]] = Field(
        None,
        description='The GCE resource labels (a map of key/value pairs) to be applied to the node pool.',
    )
    sandboxConfig: Optional[SandboxConfig] = Field(
        None, description='Immutable. Sandbox configuration for this node.'
    )
    serviceAccountRef: Optional[Union[ServiceAccountRef2, ServiceAccountRef3]] = None
    shieldedInstanceConfig: Optional[ShieldedInstanceConfig1] = Field(
        None, description='Immutable. Shielded Instance options.'
    )
    soleTenantConfig: Optional[SoleTenantConfig] = Field(
        None, description='Immutable. Node affinity options for sole tenant node pools.'
    )
    spot: Optional[bool] = Field(
        None,
        description='Immutable. Whether the nodes are created as spot VM instances.',
    )
    tags: Optional[List[str]] = Field(
        None, description='The list of instance tags applied to all nodes.'
    )
    taint: Optional[List[TaintItem]] = Field(
        None,
        description='Immutable. List of Kubernetes taints to be applied to each node.',
    )
    workloadMetadataConfig: Optional[WorkloadMetadataConfig] = Field(
        None,
        description='Immutable. The workload metadata configuration for this node.',
    )


class NodeConfigDefaults(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    gcfsConfig: Optional[GcfsConfig1] = Field(
        None, description='GCFS configuration for this node.'
    )
    loggingVariant: Optional[str] = Field(
        None,
        description='Type of logging agent that is used as the default value for node pools in the cluster. Valid values include DEFAULT and MAX_THROUGHPUT.',
    )


class NodeGroupRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `ComputeNodeGroup` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NodeGroupRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `ComputeNodeGroup` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NodePoolAutoConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    networkTags: Optional[NetworkTags] = Field(
        None,
        description="Collection of Compute Engine network tags that can be applied to a node's underlying VM instance.",
    )


class NodePoolDefaults(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    nodeConfigDefaults: Optional[NodeConfigDefaults] = Field(
        None, description='Subset of NodeConfig message that has defaults.'
    )


class NotificationConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    pubsub: Pubsub = Field(..., description='Notification config for Cloud Pub/Sub.')


class Password(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: str = Field(
        ...,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: Optional[ValueFrom] = Field(
        None,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class Password1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: Optional[str] = Field(
        None,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: ValueFrom1 = Field(
        ...,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class PodCidrOverprovisionConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disabled: bool


class PodSecurityPolicyConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='Enable the PodSecurityPolicy controller for this cluster. If enabled, pods must be valid under a PodSecurityPolicy to be created.',
    )


class PrivateClusterConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enablePrivateEndpoint: Optional[bool] = Field(
        None,
        description="When true, the cluster's private endpoint is used as the cluster endpoint and access through the public endpoint is disabled. When false, either endpoint can be used.",
    )
    enablePrivateNodes: Optional[bool] = Field(
        None,
        description="Immutable. Enables the private cluster feature, creating a private endpoint on the cluster. In a private cluster, nodes only have RFC 1918 private addresses and communicate with the master's private endpoint via private networking.",
    )
    masterGlobalAccessConfig: Optional[MasterGlobalAccessConfig] = Field(
        None, description='Controls cluster master global access settings.'
    )
    masterIpv4CidrBlock: Optional[str] = Field(
        None,
        description="Immutable. The IP range in CIDR notation to use for the hosted master network. This range will be used for assigning private IP addresses to the cluster master(s) and the ILB VIP. This range must not overlap with any other ranges in use within the cluster's network, and it must be a /28 subnet. See Private Cluster Limitations for more details. This field only applies to private clusters, when enable_private_nodes is true.",
    )
    peeringName: Optional[str] = Field(
        None,
        description='The name of the peering between this cluster and the Google owned VPC.',
    )
    privateEndpoint: Optional[str] = Field(
        None, description="The internal IP address of this cluster's master endpoint."
    )
    privateEndpointSubnetworkRef: Optional[
        Union[PrivateEndpointSubnetworkRef, PrivateEndpointSubnetworkRef1]
    ] = Field(
        None,
        description="Immutable. Subnetwork in cluster's network where master's endpoint\nwill be provisioned.",
    )
    publicEndpoint: Optional[str] = Field(
        None, description="The external IP address of this cluster's master endpoint."
    )


class PrivateEndpointSubnetworkRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeSubnetwork` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class PrivateEndpointSubnetworkRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeSubnetwork` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProtectConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    workloadConfig: Optional[WorkloadConfig] = Field(
        None,
        description="WorkloadConfig defines which actions are enabled for a cluster's workload configurations.",
    )
    workloadVulnerabilityMode: Optional[str] = Field(
        None,
        description='Sets which mode to use for Protect workload vulnerability scanning feature. Accepted values are DISABLED, BASIC.',
    )


class Pubsub(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ..., description='Whether or not the notification config is enabled.'
    )
    filter: Optional[Filter] = Field(
        None,
        description='Allows filtering to one or more specific event types. If event types are present, those and only those event types will be transmitted to the cluster. Other types will be skipped. If no filter is specified, or no event types are present, all event types will be sent.',
    )
    topicRef: Optional[Union[TopicRef, TopicRef1]] = Field(
        None, description='The PubSubTopic to send the notification to.'
    )


class RecurringWindow(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    endTime: str
    recurrence: str
    startTime: str


class ReleaseChannel(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    channel: str = Field(
        ...,
        description='The selected release channel. Accepted values are:\n* UNSPECIFIED: Not set.\n* RAPID: Weekly upgrade cadence; Early testers and developers who requires new features.\n* REGULAR: Multiple per month upgrade cadence; Production users who need features not yet offered in the Stable channel.\n* STABLE: Every few months upgrade cadence; Production users who need stability above all else, and for whom frequent upgrades are too risky.',
    )


class ReservationAffinity(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    consumeReservationType: str = Field(
        ...,
        description='Immutable. Corresponds to the type of reservation consumption.',
    )
    key: Optional[str] = Field(
        None, description='Immutable. The label key of a reservation resource.'
    )
    values: Optional[List[str]] = Field(
        None, description='Immutable. The label values of the reservation resource.'
    )


class ResourceLimit(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    maximum: Optional[int] = Field(
        None, description='Maximum amount of the resource in the cluster.'
    )
    minimum: Optional[int] = Field(
        None, description='Minimum amount of the resource in the cluster.'
    )
    resourceType: str = Field(
        ...,
        description='The type of the resource. For example, cpu and memory. See the guide to using Node Auto-Provisioning for a list of types.',
    )


class ResourceUsageExportConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bigqueryDestination: BigqueryDestination = Field(
        ...,
        description='Parameters for using BigQuery as the destination of resource usage export.',
    )
    enableNetworkEgressMetering: Optional[bool] = Field(
        None,
        description='Whether to enable network egress metering for this cluster. If enabled, a daemonset will be created in the cluster to meter network egress traffic.',
    )
    enableResourceConsumptionMetering: Optional[bool] = Field(
        None,
        description='Whether to enable resource consumption metering on this cluster. When enabled, a table will be created in the resource export BigQuery dataset to store resource consumption data. The resulting table can be joined with the resource usage table or with BigQuery billing export. Defaults to true.',
    )


class SandboxConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    sandboxType: str = Field(
        ..., description="Type of the sandbox to use for the node (e.g. 'gvisor')."
    )


class SecretKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    key: str = Field(..., description='Key that identifies the value to be extracted.')
    name: str = Field(..., description='Name of the Secret to extract a value from.')


class SecurityPostureConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    mode: Optional[str] = Field(
        None,
        description="Sets the mode of the Kubernetes security posture API's off-cluster features. Available options include DISABLED and BASIC.",
    )
    vulnerabilityMode: Optional[str] = Field(
        None,
        description="Sets the mode of the Kubernetes security posture API's workload vulnerability scanning. Available options include VULNERABILITY_DISABLED and VULNERABILITY_BASIC.",
    )


class ServiceAccountRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceAccountRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `email` field of an `IAMServiceAccount` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceExternalIpsConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='When enabled, services with exterenal ips specified will be allowed.',
    )


class ShieldedInstanceConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableIntegrityMonitoring: Optional[bool] = Field(
        None,
        description='Defines whether the instance has integrity monitoring enabled.',
    )
    enableSecureBoot: Optional[bool] = Field(
        None, description='Defines whether the instance has Secure Boot enabled.'
    )


class ShieldedInstanceConfig1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enableIntegrityMonitoring: Optional[bool] = Field(
        None,
        description='Immutable. Defines whether the instance has integrity monitoring enabled.',
    )
    enableSecureBoot: Optional[bool] = Field(
        None,
        description='Immutable. Defines whether the instance has Secure Boot enabled.',
    )


class SoleTenantConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    nodeAffinity: List[NodeAffinityItem] = Field(..., description='Immutable. .')


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    addonsConfig: Optional[AddonsConfig] = Field(
        None, description='The configuration for addons supported by GKE.'
    )
    allowNetAdmin: Optional[bool] = Field(
        None, description='Enable NET_ADMIN for this cluster.'
    )
    authenticatorGroupsConfig: Optional[AuthenticatorGroupsConfig] = Field(
        None, description='Configuration for the Google Groups for GKE feature.'
    )
    binaryAuthorization: Optional[BinaryAuthorization] = Field(
        None, description='Configuration options for the Binary Authorization feature.'
    )
    clusterAutoscaling: Optional[ClusterAutoscaling] = Field(
        None,
        description="Per-cluster configuration of Node Auto-Provisioning with Cluster Autoscaler to automatically adjust the size of the cluster and create/delete node pools based on the current needs of the cluster's workload. See the guide to using Node Auto-Provisioning for more details.",
    )
    clusterIpv4Cidr: Optional[str] = Field(
        None,
        description='Immutable. The IP address range of the Kubernetes pods in this cluster in CIDR notation (e.g. 10.96.0.0/14). Leave blank to have one automatically chosen or specify a /14 block in 10.0.0.0/8. This field will only work for routes-based clusters, where ip_allocation_policy is not defined.',
    )
    clusterTelemetry: Optional[ClusterTelemetry] = Field(
        None, description='Telemetry integration for the cluster.'
    )
    confidentialNodes: Optional[ConfidentialNodes] = Field(
        None,
        description="Immutable. Configuration for the confidential nodes feature, which makes nodes run on confidential VMs. Warning: This configuration can't be changed (or added/removed) after cluster creation without deleting and recreating the entire cluster.",
    )
    costManagementConfig: Optional[CostManagementConfig] = Field(
        None, description='Cost management configuration for the cluster.'
    )
    databaseEncryption: Optional[DatabaseEncryption] = Field(
        None,
        description='Application-layer Secrets Encryption settings. The object format is {state = string, key_name = string}. Valid values of state are: "ENCRYPTED"; "DECRYPTED". key_name is the name of a CloudKMS key.',
    )
    datapathProvider: Optional[str] = Field(
        None,
        description='Immutable. The desired datapath provider for this cluster. By default, uses the IPTables-based kube-proxy implementation.',
    )
    defaultMaxPodsPerNode: Optional[int] = Field(
        None,
        description='Immutable. The default maximum number of pods per node in this cluster. This doesn\'t work on "routes-based" clusters, clusters that don\'t have IP Aliasing enabled.',
    )
    defaultSnatStatus: Optional[DefaultSnatStatus] = Field(
        None,
        description='Whether the cluster disables default in-node sNAT rules. In-node sNAT rules will be disabled when defaultSnatStatus is disabled.',
    )
    description: Optional[str] = Field(
        None, description='Immutable.  Description of the cluster.'
    )
    dnsConfig: Optional[DnsConfig] = Field(
        None,
        description='Immutable. Configuration for Cloud DNS for Kubernetes Engine.',
    )
    enableAutopilot: Optional[bool] = Field(
        None, description='Immutable. Enable Autopilot for this cluster.'
    )
    enableBinaryAuthorization: Optional[bool] = Field(
        None,
        description='DEPRECATED. Deprecated in favor of binary_authorization. Enable Binary Authorization for this cluster. If enabled, all container images will be validated by Google Binary Authorization.',
    )
    enableFqdnNetworkPolicy: Optional[bool] = Field(
        None, description='Whether FQDN Network Policy is enabled on this cluster.'
    )
    enableIntranodeVisibility: Optional[bool] = Field(
        None,
        description='Whether Intra-node visibility is enabled for this cluster. This makes same node pod to pod traffic visible for VPC network.',
    )
    enableK8sBetaApis: Optional[EnableK8sBetaApis] = Field(
        None, description='Configuration for Kubernetes Beta APIs.'
    )
    enableKubernetesAlpha: Optional[bool] = Field(
        None,
        description='Immutable. Whether to enable Kubernetes Alpha features for this cluster. Note that when this option is enabled, the cluster cannot be upgraded and will be automatically deleted after 30 days.',
    )
    enableL4IlbSubsetting: Optional[bool] = Field(
        None, description='Whether L4ILB Subsetting is enabled for this cluster.'
    )
    enableLegacyAbac: Optional[bool] = Field(
        None,
        description='Whether the ABAC authorizer is enabled for this cluster. When enabled, identities in the system, including service accounts, nodes, and controllers, will have statically granted permissions beyond those provided by the RBAC configuration or IAM. Defaults to false.',
    )
    enableMultiNetworking: Optional[bool] = Field(
        None,
        description='Immutable. Whether multi-networking is enabled for this cluster.',
    )
    enableShieldedNodes: Optional[bool] = Field(
        None,
        description='Enable Shielded Nodes features on all nodes in this cluster. Defaults to true.',
    )
    enableTpu: Optional[bool] = Field(
        None,
        description='Immutable. Whether to enable Cloud TPU resources in this cluster.',
    )
    gatewayApiConfig: Optional[GatewayApiConfig] = Field(
        None, description='Configuration for GKE Gateway API controller.'
    )
    identityServiceConfig: Optional[IdentityServiceConfig] = Field(
        None,
        description='Configuration for Identity Service which allows customers to use external identity providers with the K8S API.',
    )
    initialNodeCount: Optional[int] = Field(
        None,
        description="Immutable. The number of nodes to create in this cluster's default node pool. In regional or multi-zonal clusters, this is the number of nodes per zone. Must be set if node_pool is not set. If you're using google_container_node_pool objects with no default node pool, you'll need to set this to a value of at least 1, alongside setting remove_default_node_pool to true.",
    )
    ipAllocationPolicy: Optional[IpAllocationPolicy] = Field(
        None,
        description='Immutable. Configuration of cluster IP allocation for VPC-native clusters. Adding this block enables IP aliasing, making the cluster VPC-native instead of routes-based.',
    )
    location: str = Field(
        ...,
        description='Immutable. The location (region or zone) in which the cluster master will be created, as well as the default node location. If you specify a zone (such as us-central1-a), the cluster will be a zonal cluster with a single cluster master. If you specify a region (such as us-west1), the cluster will be a regional cluster with multiple masters spread across zones in the region, and with default node locations in those zones as well.',
    )
    loggingConfig: Optional[LoggingConfig] = Field(
        None, description='Logging configuration for the cluster.'
    )
    loggingService: Optional[str] = Field(
        None,
        description='The logging service that the cluster should write logs to. Available options include logging.googleapis.com(Legacy Stackdriver), logging.googleapis.com/kubernetes(Stackdriver Kubernetes Engine Logging), and none. Defaults to logging.googleapis.com/kubernetes.',
    )
    maintenancePolicy: Optional[MaintenancePolicy] = Field(
        None, description='The maintenance policy to use for the cluster.'
    )
    masterAuth: Optional[MasterAuth] = Field(
        None,
        description='DEPRECATED. Basic authentication was removed for GKE cluster versions >= 1.19. The authentication information for accessing the Kubernetes master. Some values in this block are only returned by the API if your service account has permission to get credentials for your GKE cluster. If you see an unexpected diff unsetting your client cert, ensure you have the container.clusters.getCredentials permission.',
    )
    masterAuthorizedNetworksConfig: Optional[MasterAuthorizedNetworksConfig] = Field(
        None,
        description='The desired configuration options for master authorized networks. Omit the nested cidr_blocks attribute to disallow external access (except the cluster node IPs, which GKE automatically whitelists).',
    )
    meshCertificates: Optional[MeshCertificates] = Field(
        None,
        description='If set, and enable_certificates=true, the GKE Workload Identity Certificates controller and node agent will be deployed in the cluster.',
    )
    minMasterVersion: Optional[str] = Field(
        None,
        description="The minimum version of the master. GKE will auto-update the master to new versions, so this does not guarantee the current master version--use the read-only master_version field to obtain that. If unset, the cluster's version will be set by GKE to the version of the most recent official release (which is not necessarily the latest version).",
    )
    monitoringConfig: Optional[MonitoringConfig] = Field(
        None, description='Monitoring configuration for the cluster.'
    )
    monitoringService: Optional[str] = Field(
        None,
        description='The monitoring service that the cluster should write metrics to. Automatically send metrics from pods in the cluster to the Google Cloud Monitoring API. VM metrics will be collected by Google Compute Engine regardless of this setting Available options include monitoring.googleapis.com(Legacy Stackdriver), monitoring.googleapis.com/kubernetes(Stackdriver Kubernetes Engine Monitoring), and none. Defaults to monitoring.googleapis.com/kubernetes.',
    )
    networkPolicy: Optional[NetworkPolicy] = Field(
        None, description='Configuration options for the NetworkPolicy feature.'
    )
    networkRef: Optional[Union[NetworkRef, NetworkRef1]] = None
    networkingMode: Optional[str] = Field(
        None,
        description='Immutable. Determines whether alias IPs or routes will be used for pod IPs in the cluster.',
    )
    nodeConfig: Optional[NodeConfig] = Field(
        None, description='Immutable. The configuration of the nodepool.'
    )
    nodeLocations: Optional[List[str]] = Field(
        None,
        description="The list of zones in which the cluster's nodes are located. Nodes must be in the region of their regional cluster or in the same region as their cluster's zone for zonal clusters. If this is specified for a zonal cluster, omit the cluster's zone.",
    )
    nodePoolAutoConfig: Optional[NodePoolAutoConfig] = Field(
        None,
        description='Node pool configs that apply to all auto-provisioned node pools in autopilot clusters and node auto-provisioning enabled clusters.',
    )
    nodePoolDefaults: Optional[NodePoolDefaults] = Field(
        None, description='The default nodel pool settings for the entire cluster.'
    )
    nodeVersion: Optional[str] = None
    notificationConfig: Optional[NotificationConfig] = Field(
        None,
        description='The notification config for sending cluster upgrade notifications.',
    )
    podSecurityPolicyConfig: Optional[PodSecurityPolicyConfig] = Field(
        None, description='Configuration for the PodSecurityPolicy feature.'
    )
    privateClusterConfig: Optional[PrivateClusterConfig] = Field(
        None,
        description='Configuration for private clusters, clusters with private nodes.',
    )
    privateIpv6GoogleAccess: Optional[str] = Field(
        None,
        description='The desired state of IPv6 connectivity to Google Services. By default, no private IPv6 access to or from Google Services (all access will be via IPv4).',
    )
    protectConfig: Optional[ProtectConfig] = Field(
        None, description='Enable/Disable Protect API features for the cluster.'
    )
    releaseChannel: Optional[ReleaseChannel] = Field(
        None,
        description='Configuration options for the Release channel feature, which provide more control over automatic upgrades of your GKE clusters. Note that removing this field from your config will not unenroll it. Instead, use the "UNSPECIFIED" channel.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    resourceUsageExportConfig: Optional[ResourceUsageExportConfig] = Field(
        None, description='Configuration for the ResourceUsageExportConfig feature.'
    )
    securityPostureConfig: Optional[SecurityPostureConfig] = Field(
        None,
        description='Defines the config needed to enable/disable features for the Security Posture API.',
    )
    serviceExternalIpsConfig: Optional[ServiceExternalIpsConfig] = Field(
        None,
        description='If set, and enabled=true, services with external ips field will not be blocked.',
    )
    subnetworkRef: Optional[Union[SubnetworkRef, SubnetworkRef1]] = None
    verticalPodAutoscaling: Optional[VerticalPodAutoscaling] = Field(
        None,
        description='Vertical Pod Autoscaling automatically adjusts the resources of pods controlled by it.',
    )
    workloadIdentityConfig: Optional[WorkloadIdentityConfig] = Field(
        None,
        description='Configuration for the use of Kubernetes Service Accounts in GCP IAM policies.',
    )


class StandardRolloutPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    batchNodeCount: Optional[int] = Field(
        None, description='Number of blue nodes to drain in a batch.'
    )
    batchPercentage: Optional[float] = Field(
        None,
        description='Percentage of the bool pool nodes to drain in a batch. The range of this field should be (0.0, 1.0].',
    )
    batchSoakDuration: Optional[str] = Field(
        None,
        description='Soak time after each batch gets drained.\n\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tA duration in seconds with up to nine fractional digits, ending with \'s\'. Example: "3.5s".',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    endpoint: Optional[str] = Field(
        None, description="The IP address of this cluster's Kubernetes master."
    )
    labelFingerprint: Optional[str] = Field(
        None, description='The fingerprint of the set of labels for this cluster.'
    )
    masterVersion: Optional[str] = Field(
        None,
        description='The current version of the master in the cluster. This may be different than the min_master_version set in the config if the master has been updated by GKE.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    operation: Optional[str] = None
    selfLink: Optional[str] = Field(
        None, description='Server-defined URL for the resource.'
    )
    servicesIpv4Cidr: Optional[str] = Field(
        None,
        description='The IP address range of the Kubernetes services in this cluster, in CIDR notation (e.g. 1.2.3.4/29). Service addresses are typically put in the last /16 from the container CIDR.',
    )
    tpuIpv4CidrBlock: Optional[str] = Field(
        None,
        description='The IP address range of the Cloud TPUs in this cluster, in CIDR notation (e.g. 1.2.3.4/29).',
    )


class SubnetworkRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeSubnetwork` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class SubnetworkRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeSubnetwork` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TaintItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    effect: str = Field(..., description='Immutable. Effect for taint.')
    key: str = Field(..., description='Immutable. Key for taint.')
    value: str = Field(..., description='Immutable. Value for taint.')


class TopicRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TopicRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class UpgradeOption(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoUpgradeStartTime: Optional[str] = Field(
        None,
        description='This field is set when upgrades are about to commence with the approximate start time for the upgrades, in RFC3339 text format.',
    )
    description: Optional[str] = Field(
        None,
        description='This field is set when upgrades are about to commence with the description of the upgrade.',
    )


class UpgradeSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    blueGreenSettings: Optional[BlueGreenSettings] = Field(
        None, description='Settings for blue-green upgrade strategy.'
    )
    maxSurge: Optional[int] = Field(
        None,
        description='The maximum number of nodes that can be created beyond the current size of the node pool during the upgrade process.',
    )
    maxUnavailable: Optional[int] = Field(
        None,
        description='The maximum number of nodes that can be simultaneously unavailable during the upgrade process.',
    )
    strategy: Optional[str] = Field(
        None, description='Update strategy of the node pool.'
    )


class ValueFrom(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class VerticalPodAutoscaling(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(..., description='Enables vertical pod autoscaling.')


class WorkloadConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    auditMode: str = Field(
        ...,
        description="Sets which mode of auditing should be used for the cluster's workloads. Accepted values are DISABLED, BASIC.",
    )


class WorkloadIdentityConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    identityNamespace: Optional[str] = Field(
        None,
        description='DEPRECATED. This field will be removed in a future major release as it has been deprecated in the API. Use `workloadPool` instead; `workloadPool` field will supersede this field.\nEnables workload identity.',
    )
    workloadPool: Optional[str] = Field(
        None,
        description='The workload pool to attach all Kubernetes service accounts to.',
    )


class WorkloadMetadataConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    mode: Optional[str] = Field(
        None,
        description='Mode is the configuration for how to expose metadata to workloads running on the node.',
    )
    nodeMetadata: Optional[str] = Field(
        None,
        description='DEPRECATED. Deprecated in favor of mode. NodeMetadata is the configuration for how to expose metadata to the workloads running on the node.',
    )
