# generated by datamodel-codegen:
#   filename:  datafusioninstance_v1beta1.json
#   timestamp: 2024-03-15T04:52:09+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class AvailableVersionItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    availableFeatures: Optional[List[str]] = Field(
        None,
        description='Represents a list of available feature names for a given version.',
    )
    defaultVersion: Optional[bool] = Field(
        None,
        description='Whether this is currently the default version for Cloud Data Fusion',
    )
    versionNumber: Optional[str] = Field(
        None,
        description="The version number of the Data Fusion instance, such as '6.0.1.0'.",
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class DataprocServiceAccountRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description="User-managed service account to set on Dataproc when Cloud Data Fusion creates Dataproc to run data processing pipelines. This allows users to have fine-grained access control on Dataproc's accesses to cloud resources.\n\nAllowed value: The `email` field of an `IAMServiceAccount` resource.",
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class DataprocServiceAccountRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description="User-managed service account to set on Dataproc when Cloud Data Fusion creates Dataproc to run data processing pipelines. This allows users to have fine-grained access control on Dataproc's accesses to cloud resources.\n\nAllowed value: The `email` field of an `IAMServiceAccount` resource.",
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class NetworkConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    ipAllocation: Optional[str] = Field(
        None,
        description='Immutable. The IP range in CIDR notation to use for the managed Data Fusion instance nodes. This range must not overlap with any other ranges used in the customer network.',
    )
    networkRef: Optional[Union[NetworkRef, NetworkRef1]] = Field(
        None, description='Immutable.'
    )


class NetworkRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Name of the network in the customer project with which the Tenant Project will be peered for executing pipelines. In case of shared VPC where the network resides in another host project the network should specified in the form of projects/{host-project-id}/global/networks/{network}\n\nAllowed value: The Google Cloud resource name of a `ComputeNetwork` resource (format: `projects/{{project}}/global/networks/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NetworkRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Name of the network in the customer project with which the Tenant Project will be peered for executing pipelines. In case of shared VPC where the network resides in another host project the network should specified in the form of projects/{host-project-id}/global/networks/{network}\n\nAllowed value: The Google Cloud resource name of a `ComputeNetwork` resource (format: `projects/{{project}}/global/networks/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    dataprocServiceAccountRef: Optional[
        Union[DataprocServiceAccountRef, DataprocServiceAccountRef1]
    ] = None
    description: Optional[str] = Field(
        None, description='Immutable. A description of this instance.'
    )
    displayName: Optional[str] = Field(
        None, description='Immutable. Display name for an instance.'
    )
    enableStackdriverLogging: Optional[bool] = Field(
        None, description='Option to enable Stackdriver Logging.'
    )
    enableStackdriverMonitoring: Optional[bool] = Field(
        None, description='Option to enable Stackdriver Monitoring.'
    )
    location: str = Field(..., description='Immutable. The location for the resource')
    networkConfig: Optional[NetworkConfig] = Field(
        None,
        description='Immutable. Network configuration options. These are required when a private Data Fusion instance is to be created.',
    )
    options: Optional[Dict[str, str]] = Field(
        None,
        description='Immutable. Map of additional options used to configure the behavior of Data Fusion instance.',
    )
    privateInstance: Optional[bool] = Field(
        None,
        description='Immutable. Specifies whether the Data Fusion instance should be private. If set to true, all Data Fusion nodes will have private IP addresses and will not be able to access the public internet.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    type: str = Field(
        ...,
        description='Immutable. Required. Instance type. Possible values: TYPE_UNSPECIFIED, BASIC, ENTERPRISE, DEVELOPER',
    )
    version: Optional[str] = Field(
        None, description='Current version of the Data Fusion.'
    )
    zone: Optional[str] = Field(
        None,
        description='Immutable. Name of the zone in which the Data Fusion instance will be created. Only DEVELOPER instances use this field.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    apiEndpoint: Optional[str] = Field(
        None, description='Output only. Endpoint on which the REST APIs is accessible.'
    )
    availableVersion: Optional[List[AvailableVersionItem]] = Field(
        None, description='Available versions that the instance can be upgraded to.'
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The time the instance was created.'
    )
    gcsBucket: Optional[str] = Field(
        None,
        description='Output only. Cloud Storage bucket generated by Data Fusion in the customer project.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    p4ServiceAccount: Optional[str] = Field(
        None, description='Output only. P4 service account for the customer project.'
    )
    serviceEndpoint: Optional[str] = Field(
        None,
        description='Output only. Endpoint on which the Data Fusion UI is accessible.',
    )
    state: Optional[str] = Field(
        None,
        description='Output only. The current state of this Data Fusion instance. Possible values: STATE_UNSPECIFIED, ENABLED, DISABLED, UNKNOWN',
    )
    stateMessage: Optional[str] = Field(
        None,
        description='Output only. Additional information about the current state of this Data Fusion instance if available.',
    )
    tenantProjectId: Optional[str] = Field(
        None, description='Output only. The name of the tenant project.'
    )
    updateTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The time the instance was last updated.'
    )
