# generated by datamodel-codegen:
#   filename:  gkehubmembership_v1beta1.json
#   timestamp: 2024-03-15T04:52:41+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class Authority(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    issuer: Optional[str] = Field(
        None,
        description='Optional. A JSON Web Token (JWT) issuer URI. `issuer` must start with `https://` and be a valid URL with length <2000 characters. If set, then Google will allow valid OIDC tokens from this issuer to authenticate within the workload_identity_pool. OIDC discovery will be performed on this URI to validate tokens from the issuer. Clearing `issuer` disables Workload Identity. `issuer` cannot be directly modified; it must be cleared (and Workload Identity disabled) before using a new issuer (and re-enabling Workload Identity).',
    )


class Authority1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    identityProvider: Optional[str] = Field(
        None,
        description='Output only. An identity provider that reflects the `issuer` in the workload identity pool.',
    )
    workloadIdentityPool: Optional[str] = Field(
        None,
        description='Output only. The name of the workload identity pool in which `issuer` will be recognized. There is a single Workload Identity Pool per Hub that is shared between all Memberships that belong to that Hub. For a Hub hosted in: {PROJECT_ID}, the workload pool format is `{PROJECT_ID}.hub.id.goog`, although this is subject to change in newer versions of this API.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class ConnectResource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clusterScoped: Optional[bool] = Field(
        None,
        description='Whether the resource provided in the manifest is `cluster_scoped`. If unset, the manifest is assumed to be namespace scoped. This field is used for REST mapping when applying the resource in a cluster.',
    )
    manifest: Optional[str] = Field(None, description='YAML manifest of the resource.')


class Endpoint(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    gkeCluster: Optional[GkeCluster] = Field(
        None,
        description='Optional. GKE-specific information. Only present if this Membership is a GKE cluster.',
    )
    kubernetesResource: Optional[KubernetesResource] = Field(
        None,
        description='Optional. The in-cluster Kubernetes Resources that should be applied for a correctly registered cluster, in the steady state. These resources: * Ensure that the cluster is exclusively registered to one and only one Hub Membership. * Propagate Workload Pool Information available in the Membership Authority field. * Ensure proper initial configuration of default Hub Features.',
    )


class Endpoint1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kubernetesMetadata: Optional[KubernetesMetadata] = Field(
        None, description='Output only. Useful Kubernetes-specific metadata.'
    )
    kubernetesResource: Optional[KubernetesResource1] = None


class GkeCluster(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    resourceRef: Optional[Union[ResourceRef, ResourceRef1]] = None


class KubernetesMetadata(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kubernetesApiServerVersion: Optional[str] = Field(
        None,
        description='Output only. Kubernetes API server version string as reported by `/version`.',
    )
    memoryMb: Optional[int] = Field(
        None,
        description='Output only. The total memory capacity as reported by the sum of all Kubernetes nodes resources, defined in MB.',
    )
    nodeCount: Optional[int] = Field(
        None,
        description='Output only. Node count as reported by Kubernetes nodes resources.',
    )
    nodeProviderId: Optional[str] = Field(
        None,
        description='Output only. Node providerID as reported by the first node in the list of nodes on the Kubernetes endpoint. On Kubernetes platforms that support zero-node clusters (like GKE-on-GCP), the node_count will be zero and the node_provider_id will be empty.',
    )
    updateTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. The time at which these details were last updated. This update_time is different from the Membership-level update_time since EndpointDetails are updated internally for API consumers.',
    )
    vcpuCount: Optional[int] = Field(
        None,
        description='Output only. vCPU count as reported by Kubernetes nodes resources.',
    )


class KubernetesResource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    membershipCrManifest: Optional[str] = Field(
        None,
        description='Input only. The YAML representation of the Membership CR. This field is ignored for GKE clusters where Hub can read the CR directly. Callers should provide the CR that is currently present in the cluster during CreateMembership or UpdateMembership, or leave this field empty if none exists. The CR manifest is used to validate the cluster has not been registered with another Membership.',
    )
    resourceOptions: Optional[ResourceOptions] = Field(
        None, description='Optional. Options for Kubernetes resource generation.'
    )


class KubernetesResource1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    connectResources: Optional[List[ConnectResource]] = Field(
        None,
        description='Output only. The Kubernetes resources for installing the GKE Connect agent This field is only populated in the Membership returned from a successful long-running operation from CreateMembership or UpdateMembership. It is not populated during normal GetMembership or ListMemberships requests. To get the resource manifest after the initial registration, the caller should make a UpdateMembership call with an empty field mask.',
    )
    membershipResources: Optional[List[MembershipResource]] = Field(
        None,
        description='Output only. Additional Kubernetes resources that need to be applied to the cluster after Membership creation, and after every update. This field is only populated in the Membership returned from a successful long-running operation from CreateMembership or UpdateMembership. It is not populated during normal GetMembership or ListMemberships requests. To get the resource manifest after the initial registration, the caller should make a UpdateMembership call with an empty field mask.',
    )


class MembershipResource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clusterScoped: Optional[bool] = Field(
        None,
        description='Whether the resource provided in the manifest is `cluster_scoped`. If unset, the manifest is assumed to be namespace scoped. This field is used for REST mapping when applying the resource in a cluster.',
    )
    manifest: Optional[str] = Field(None, description='YAML manifest of the resource.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ResourceOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    connectVersion: Optional[str] = Field(
        None,
        description='Optional. The Connect agent version to use for connect_resources. Defaults to the latest GKE Connect version. The version must be a currently supported version, obsolete versions will be rejected.',
    )
    v1beta1Crd: Optional[bool] = Field(
        None,
        description='Optional. Use `apiextensions/v1beta1` instead of `apiextensions/v1` for CustomResourceDefinition resources. This option should be set for clusters with Kubernetes apiserver versions <1.16.',
    )


class ResourceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Immutable. Self-link of the GCP resource for the GKE cluster. For example: //container.googleapis.com/projects/my-project/locations/us-west1-a/clusters/my-cluster Zonal clusters are also supported.\n\nAllowed value: The `selfLink` field of a `ContainerCluster` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ResourceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Immutable. Self-link of the GCP resource for the GKE cluster. For example: //container.googleapis.com/projects/my-project/locations/us-west1-a/clusters/my-cluster Zonal clusters are also supported.\n\nAllowed value: The `selfLink` field of a `ContainerCluster` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    authority: Optional[Authority] = Field(
        None,
        description='Optional. How to identify workloads from this Membership. See the documentation on Workload Identity for more details: https://cloud.google.com/kubernetes-engine/docs/how-to/workload-identity',
    )
    description: Optional[str] = Field(
        None,
        description='Description of this membership, limited to 63 characters. Must match the regex: `*` This field is present for legacy purposes.',
    )
    endpoint: Optional[Endpoint] = Field(
        None, description='Optional. Endpoint information to reach this member.'
    )
    externalId: Optional[str] = Field(
        None,
        description='Optional. An externally-generated and managed ID for this Membership. This ID may be modified after creation, but this is not recommended. The ID must match the regex: `*` If this Membership represents a Kubernetes cluster, this value should be set to the UID of the `kube-system` namespace object.',
    )
    infrastructureType: Optional[str] = Field(
        None,
        description='Optional. The infrastructure type this Membership is running on. Possible values: INFRASTRUCTURE_TYPE_UNSPECIFIED, ON_PREM, MULTI_CLOUD',
    )
    location: str = Field(..., description='Immutable. The location for the resource')
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )


class State(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    code: Optional[str] = Field(
        None,
        description='Output only. The current state of the Membership resource. Possible values: CODE_UNSPECIFIED, CREATING, READY, DELETING, UPDATING, SERVICE_UPDATING',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    authority: Optional[Authority1] = None
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[AwareDatetime] = Field(
        None, description='Output only. When the Membership was created.'
    )
    deleteTime: Optional[AwareDatetime] = Field(
        None, description='Output only. When the Membership was deleted.'
    )
    endpoint: Optional[Endpoint1] = None
    lastConnectionTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. For clusters using Connect, the timestamp of the most recent connection established with Google Cloud. This time is updated every several minutes, not continuously. For clusters that do not use GKE Connect, or that have never connected successfully, this field will be unset.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    state: Optional[State] = Field(
        None, description='Output only. State of the Membership resource.'
    )
    uniqueId: Optional[str] = Field(
        None,
        description='Output only. Google-generated UUID for this resource. This is unique across all Membership resources. If a Membership resource is deleted and another resource with the same name is created, it gets a different unique_id.',
    )
    updateTime: Optional[AwareDatetime] = Field(
        None, description='Output only. When the Membership was last updated.'
    )
