# generated by datamodel-codegen:
#   filename:  iamauditconfig_v1beta1.json
#   timestamp: 2024-03-15T04:52:43+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field, constr


class AuditLogConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    exemptedMembers: Optional[List[str]] = Field(
        None,
        description="Identities that do not cause logging for this type of permission. The format is the same as that for 'members' in IAMPolicy/IAMPolicyMember.",
    )
    logType: constr(pattern=r'^(DATA_READ|DATA_WRITE|ADMIN_READ)$') = Field(
        ...,
        description="Permission type for which logging is to be configured. Must be one of 'DATA_READ', 'DATA_WRITE', or 'ADMIN_READ'.",
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Optional[Spec] = Field(
        None,
        description='IAMAuditConfigSpec defines the desired state of IAMAuditConfig.',
    )
    status: Optional[Status] = Field(
        None,
        description='IAMAuditConfigStatus defines the observed state of IAMAuditConfig.',
    )


class ResourceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    apiVersion: Optional[str] = None
    external: Optional[str] = None
    kind: str
    name: Optional[str] = None
    namespace: Optional[str] = None


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    auditLogConfigs: List[AuditLogConfig] = Field(
        ...,
        description='Required. The configuration for logging of each type of permission.',
    )
    resourceRef: ResourceRef = Field(
        ...,
        description='Immutable. Required. The GCP resource to set the IAMAuditConfig on (e.g. project).',
    )
    service: str = Field(
        ...,
        description="Immutable. Required. The service for which to enable Data Access audit logs. The special value 'allServices' covers all services. Note that if there are audit configs covering both 'allServices' and a specific service, then the union of the two audit configs is used for that service: the 'logTypes' specified in each 'auditLogConfig' are enabled, and the 'exemptedMembers' in each 'auditLogConfg' are exempted.",
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observations of the IAMAuditConfig's current state.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
