# generated by datamodel-codegen:
#   filename:  identityplatforminboundsamlconfig_v1alpha1.json
#   timestamp: 2024-03-15T04:52:50+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class IdpCertificate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    x509Certificate: Optional[str] = Field(
        None, description="The IdP's x509 certificate."
    )


class IdpConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    idpCertificates: List[IdpCertificate] = Field(
        ...,
        description="The IdP's certificate data to verify the signature in the SAMLResponse issued by the IDP.",
    )
    idpEntityId: str = Field(
        ..., description='Unique identifier for all SAML entities.'
    )
    signRequest: Optional[bool] = Field(
        None, description='Indicates if outbounding SAMLRequest should be signed.'
    )
    ssoUrl: str = Field(..., description='URL to send Authentication request to.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class SpCertificate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    x509Certificate: Optional[str] = Field(None, description='The x509 certificate.')


class SpConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    callbackUri: Optional[str] = Field(
        None,
        description="Callback URI where responses from IDP are handled. Must start with 'https://'.",
    )
    spCertificates: Optional[List[SpCertificate]] = Field(
        None,
        description="The IDP's certificate data to verify the signature in the SAMLResponse issued by the IDP.",
    )
    spEntityId: Optional[str] = Field(
        None, description='Unique identifier for all SAML entities.'
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    displayName: str = Field(..., description='Human friendly display name.')
    enabled: Optional[bool] = Field(
        None, description='If this config allows users to sign in with the provider.'
    )
    idpConfig: IdpConfig = Field(
        ...,
        description='SAML IdP configuration when the project acts as the relying party.',
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    spConfig: SpConfig = Field(
        ...,
        description='SAML SP (Service Provider) configuration when the project acts as the relying party to receive\nand accept an authentication assertion issued by a SAML identity provider.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
