# generated by datamodel-codegen:
#   filename:  monitoringalertpolicy_v1beta1.json
#   timestamp: 2024-03-15T04:52:58+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Aggregation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    alignmentPeriod: Optional[str] = Field(
        None,
        description='The alignment period for per-time\nseries alignment. If present,\nalignmentPeriod must be at least\n60 seconds. After per-time series\nalignment, each time series will\ncontain data points only on the\nperiod boundaries. If\nperSeriesAligner is not specified\nor equals ALIGN_NONE, then this\nfield is ignored. If\nperSeriesAligner is specified and\ndoes not equal ALIGN_NONE, then\nthis field must be defined;\notherwise an error is returned.',
    )
    crossSeriesReducer: Optional[str] = Field(
        None,
        description='The approach to be used to combine\ntime series. Not all reducer\nfunctions may be applied to all\ntime series, depending on the\nmetric type and the value type of\nthe original time series.\nReduction may change the metric\ntype of value type of the time\nseries.Time series data must be\naligned in order to perform cross-\ntime series reduction. If\ncrossSeriesReducer is specified,\nthen perSeriesAligner must be\nspecified and not equal ALIGN_NONE\nand alignmentPeriod must be\nspecified; otherwise, an error is\nreturned. Possible values: ["REDUCE_NONE", "REDUCE_MEAN", "REDUCE_MIN", "REDUCE_MAX", "REDUCE_SUM", "REDUCE_STDDEV", "REDUCE_COUNT", "REDUCE_COUNT_TRUE", "REDUCE_COUNT_FALSE", "REDUCE_FRACTION_TRUE", "REDUCE_PERCENTILE_99", "REDUCE_PERCENTILE_95", "REDUCE_PERCENTILE_50", "REDUCE_PERCENTILE_05"].',
    )
    groupByFields: Optional[List[str]] = Field(
        None,
        description='The set of fields to preserve when\ncrossSeriesReducer is specified.\nThe groupByFields determine how\nthe time series are partitioned\ninto subsets prior to applying the\naggregation function. Each subset\ncontains time series that have the\nsame value for each of the\ngrouping fields. Each individual\ntime series is a member of exactly\none subset. The crossSeriesReducer\nis applied to each subset of time\nseries. It is not possible to\nreduce across different resource\ntypes, so this field implicitly\ncontains resource.type. Fields not\nspecified in groupByFields are\naggregated away. If groupByFields\nis not specified and all the time\nseries have the same resource\ntype, then the time series are\naggregated into a single output\ntime series. If crossSeriesReducer\nis not defined, this field is\nignored.',
    )
    perSeriesAligner: Optional[str] = Field(
        None,
        description='The approach to be used to align\nindividual time series. Not all\nalignment functions may be applied\nto all time series, depending on\nthe metric type and value type of\nthe original time series.\nAlignment may change the metric\ntype or the value type of the time\nseries.Time series data must be\naligned in order to perform cross-\ntime series reduction. If\ncrossSeriesReducer is specified,\nthen perSeriesAligner must be\nspecified and not equal ALIGN_NONE\nand alignmentPeriod must be\nspecified; otherwise, an error is\nreturned. Possible values: ["ALIGN_NONE", "ALIGN_DELTA", "ALIGN_RATE", "ALIGN_INTERPOLATE", "ALIGN_NEXT_OLDER", "ALIGN_MIN", "ALIGN_MAX", "ALIGN_MEAN", "ALIGN_COUNT", "ALIGN_SUM", "ALIGN_STDDEV", "ALIGN_COUNT_TRUE", "ALIGN_COUNT_FALSE", "ALIGN_FRACTION_TRUE", "ALIGN_PERCENTILE_99", "ALIGN_PERCENTILE_95", "ALIGN_PERCENTILE_50", "ALIGN_PERCENTILE_05", "ALIGN_PERCENT_CHANGE"].',
    )


class AlertStrategy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    autoClose: Optional[str] = Field(
        None,
        description='If an alert policy that was active has no data for this long, any open incidents will close.',
    )
    notificationChannelStrategy: Optional[List[NotificationChannelStrategyItem]] = (
        Field(
            None,
            description="Control over how the notification channels in 'notification_channels'\nare notified when this alert fires, on a per-channel basis.",
        )
    )
    notificationRateLimit: Optional[NotificationRateLimit] = Field(
        None,
        description='Required for alert policies with a LogMatch condition.\nThis limit is not implemented for alert policies that are not log-based.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditionAbsent: Optional[ConditionAbsent] = Field(
        None,
        description='A condition that checks that a time series\ncontinues to receive new data points.',
    )
    conditionMatchedLog: Optional[ConditionMatchedLog] = Field(
        None,
        description='A condition that checks for log messages matching given constraints.\nIf set, no other conditions can be present.',
    )
    conditionMonitoringQueryLanguage: Optional[ConditionMonitoringQueryLanguage] = (
        Field(
            None,
            description='A Monitoring Query Language query that outputs a boolean stream.',
        )
    )
    conditionPrometheusQueryLanguage: Optional[ConditionPrometheusQueryLanguage] = (
        Field(
            None,
            description='A Monitoring Query Language query that outputs a boolean stream\n\nA condition type that allows alert policies to be defined using\nPrometheus Query Language (PromQL).\n\nThe PrometheusQueryLanguageCondition message contains information\nfrom a Prometheus alerting rule and its associated rule group.',
        )
    )
    conditionThreshold: Optional[ConditionThreshold] = Field(
        None,
        description='A condition that compares a time series against a\nthreshold.',
    )
    displayName: str = Field(
        ...,
        description="A short name or phrase used to identify the\ncondition in dashboards, notifications, and\nincidents. To avoid confusion, don't use the same\ndisplay name for multiple conditions in the same\npolicy.",
    )
    name: Optional[str] = Field(
        None,
        description='The unique resource name for this condition.\nIts syntax is:\nprojects/[PROJECT_ID]/alertPolicies/[POLICY_ID]/conditions/[CONDITION_ID]\n[CONDITION_ID] is assigned by Stackdriver Monitoring when\nthe condition is created as part of a new or updated alerting\npolicy.',
    )


class Condition1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class ConditionAbsent(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    aggregations: Optional[List[Aggregation]] = Field(
        None,
        description='Specifies the alignment of data points in\nindividual time series as well as how to\ncombine the retrieved time series together\n(such as when aggregating multiple streams\non each resource to a single stream for each\nresource or when aggregating streams across\nall members of a group of resources).\nMultiple aggregations are applied in the\norder specified.',
    )
    duration: str = Field(
        ...,
        description='The amount of time that a time series must\nfail to report new data to be considered\nfailing. Currently, only values that are a\nmultiple of a minute--e.g. 60s, 120s, or 300s\n--are supported.',
    )
    filter: Optional[str] = Field(
        None,
        description='A filter that identifies which time series\nshould be compared with the threshold.The\nfilter is similar to the one that is\nspecified in the\nMetricService.ListTimeSeries request (that\ncall is useful to verify the time series\nthat will be retrieved / processed) and must\nspecify the metric type and optionally may\ncontain restrictions on resource type,\nresource labels, and metric labels. This\nfield may not exceed 2048 Unicode characters\nin length.',
    )
    trigger: Optional[Trigger] = Field(
        None,
        description='The number/percent of time series for which\nthe comparison must hold in order for the\ncondition to trigger. If unspecified, then\nthe condition will trigger if the comparison\nis true for any of the time series that have\nbeen identified by filter and aggregations.',
    )


class ConditionMatchedLog(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    filter: str = Field(..., description='A logs-based filter.')
    labelExtractors: Optional[Dict[str, str]] = Field(
        None,
        description='A map from a label key to an extractor expression, which is used to\nextract the value for this label key. Each entry in this map is\na specification for how data should be extracted from log entries that\nmatch filter. Each combination of extracted values is treated as\na separate rule for the purposes of triggering notifications.\nLabel keys and corresponding values can be used in notifications\ngenerated by this condition.',
    )


class ConditionMonitoringQueryLanguage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    duration: str = Field(
        ...,
        description='The amount of time that a time series must\nviolate the threshold to be considered\nfailing. Currently, only values that are a\nmultiple of a minute--e.g., 0, 60, 120, or\n300 seconds--are supported. If an invalid\nvalue is given, an error will be returned.\nWhen choosing a duration, it is useful to\nkeep in mind the frequency of the underlying\ntime series data (which may also be affected\nby any alignments specified in the\naggregations field); a good duration is long\nenough so that a single outlier does not\ngenerate spurious alerts, but short enough\nthat unhealthy states are detected and\nalerted on quickly.',
    )
    evaluationMissingData: Optional[str] = Field(
        None,
        description='A condition control that determines how\nmetric-threshold conditions are evaluated when\ndata stops arriving. Possible values: ["EVALUATION_MISSING_DATA_INACTIVE", "EVALUATION_MISSING_DATA_ACTIVE", "EVALUATION_MISSING_DATA_NO_OP"].',
    )
    query: str = Field(
        ...,
        description='Monitoring Query Language query that outputs a boolean stream.',
    )
    trigger: Optional[Trigger] = Field(
        None,
        description='The number/percent of time series for which\nthe comparison must hold in order for the\ncondition to trigger. If unspecified, then\nthe condition will trigger if the comparison\nis true for any of the time series that have\nbeen identified by filter and aggregations,\nor by the ratio, if denominator_filter and\ndenominator_aggregations are specified.',
    )


class ConditionPrometheusQueryLanguage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    alertRule: Optional[str] = Field(
        None,
        description='The alerting rule name of this alert in the corresponding Prometheus\nconfiguration file.\n\nSome external tools may require this field to be populated correctly\nin order to refer to the original Prometheus configuration file.\nThe rule group name and the alert name are necessary to update the\nrelevant AlertPolicies in case the definition of the rule group changes\nin the future.\n\nThis field is optional. If this field is not empty, then it must be a\nvalid Prometheus label name.',
    )
    duration: Optional[str] = Field(
        None,
        description='Alerts are considered firing once their PromQL expression evaluated\nto be "true" for this long. Alerts whose PromQL expression was not\nevaluated to be "true" for long enough are considered pending. The\ndefault value is zero. Must be zero or positive.',
    )
    evaluationInterval: Optional[str] = Field(
        None,
        description='How often this rule should be evaluated. Must be a positive multiple\nof 30 seconds or missing. The default value is 30 seconds. If this\nPrometheusQueryLanguageCondition was generated from a Prometheus\nalerting rule, then this value should be taken from the enclosing\nrule group.',
    )
    labels: Optional[Dict[str, str]] = Field(
        None,
        description='Labels to add to or overwrite in the PromQL query result. Label names\nmust be valid.\n\nLabel values can be templatized by using variables. The only available\nvariable names are the names of the labels in the PromQL result, including\n"__name__" and "value". "labels" may be empty. This field is intended to be\nused for organizing and identifying the AlertPolicy.',
    )
    query: str = Field(
        ...,
        description='The PromQL expression to evaluate. Every evaluation cycle this\nexpression is evaluated at the current time, and all resultant time\nseries become pending/firing alerts. This field must not be empty.',
    )
    ruleGroup: Optional[str] = Field(
        None,
        description='The rule group name of this alert in the corresponding Prometheus\nconfiguration file.\n\nSome external tools may require this field to be populated correctly\nin order to refer to the original Prometheus configuration file.\nThe rule group name and the alert name are necessary to update the\nrelevant AlertPolicies in case the definition of the rule group changes\nin the future.\n\nThis field is optional. If this field is not empty, then it must be a\nvalid Prometheus label name.',
    )


class ConditionThreshold(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    aggregations: Optional[List[Aggregation]] = Field(
        None,
        description='Specifies the alignment of data points in\nindividual time series as well as how to\ncombine the retrieved time series together\n(such as when aggregating multiple streams\non each resource to a single stream for each\nresource or when aggregating streams across\nall members of a group of resources).\nMultiple aggregations are applied in the\norder specified.This field is similar to the\none in the MetricService.ListTimeSeries\nrequest. It is advisable to use the\nListTimeSeries method when debugging this\nfield.',
    )
    comparison: str = Field(
        ...,
        description='The comparison to apply between the time\nseries (indicated by filter and aggregation)\nand the threshold (indicated by\nthreshold_value). The comparison is applied\non each time series, with the time series on\nthe left-hand side and the threshold on the\nright-hand side. Only COMPARISON_LT and\nCOMPARISON_GT are supported currently. Possible values: ["COMPARISON_GT", "COMPARISON_GE", "COMPARISON_LT", "COMPARISON_LE", "COMPARISON_EQ", "COMPARISON_NE"].',
    )
    denominatorAggregations: Optional[List[DenominatorAggregation]] = Field(
        None,
        description='Specifies the alignment of data points in\nindividual time series selected by\ndenominatorFilter as well as how to combine\nthe retrieved time series together (such as\nwhen aggregating multiple streams on each\nresource to a single stream for each\nresource or when aggregating streams across\nall members of a group of resources).When\ncomputing ratios, the aggregations and\ndenominator_aggregations fields must use the\nsame alignment period and produce time\nseries that have the same periodicity and\nlabels.This field is similar to the one in\nthe MetricService.ListTimeSeries request. It\nis advisable to use the ListTimeSeries\nmethod when debugging this field.',
    )
    denominatorFilter: Optional[str] = Field(
        None,
        description='A filter that identifies a time series that\nshould be used as the denominator of a ratio\nthat will be compared with the threshold. If\na denominator_filter is specified, the time\nseries specified by the filter field will be\nused as the numerator.The filter is similar\nto the one that is specified in the\nMetricService.ListTimeSeries request (that\ncall is useful to verify the time series\nthat will be retrieved / processed) and must\nspecify the metric type and optionally may\ncontain restrictions on resource type,\nresource labels, and metric labels. This\nfield may not exceed 2048 Unicode characters\nin length.',
    )
    duration: str = Field(
        ...,
        description='The amount of time that a time series must\nviolate the threshold to be considered\nfailing. Currently, only values that are a\nmultiple of a minute--e.g., 0, 60, 120, or\n300 seconds--are supported. If an invalid\nvalue is given, an error will be returned.\nWhen choosing a duration, it is useful to\nkeep in mind the frequency of the underlying\ntime series data (which may also be affected\nby any alignments specified in the\naggregations field); a good duration is long\nenough so that a single outlier does not\ngenerate spurious alerts, but short enough\nthat unhealthy states are detected and\nalerted on quickly.',
    )
    evaluationMissingData: Optional[str] = Field(
        None,
        description='A condition control that determines how\nmetric-threshold conditions are evaluated when\ndata stops arriving. Possible values: ["EVALUATION_MISSING_DATA_INACTIVE", "EVALUATION_MISSING_DATA_ACTIVE", "EVALUATION_MISSING_DATA_NO_OP"].',
    )
    filter: Optional[str] = Field(
        None,
        description='A filter that identifies which time series\nshould be compared with the threshold.The\nfilter is similar to the one that is\nspecified in the\nMetricService.ListTimeSeries request (that\ncall is useful to verify the time series\nthat will be retrieved / processed) and must\nspecify the metric type and optionally may\ncontain restrictions on resource type,\nresource labels, and metric labels. This\nfield may not exceed 2048 Unicode characters\nin length.',
    )
    forecastOptions: Optional[ForecastOptions] = Field(
        None,
        description="When this field is present, the 'MetricThreshold'\ncondition forecasts whether the time series is\npredicted to violate the threshold within the\n'forecastHorizon'. When this field is not set, the\n'MetricThreshold' tests the current value of the\ntimeseries against the threshold.",
    )
    thresholdValue: Optional[float] = Field(
        None, description='A value against which to compare the time\nseries.'
    )
    trigger: Optional[Trigger] = Field(
        None,
        description='The number/percent of time series for which\nthe comparison must hold in order for the\ncondition to trigger. If unspecified, then\nthe condition will trigger if the comparison\nis true for any of the time series that have\nbeen identified by filter and aggregations,\nor by the ratio, if denominator_filter and\ndenominator_aggregations are specified.',
    )


class CreationRecordItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    mutateTime: Optional[str] = Field(None, description='When the change occurred.')
    mutatedBy: Optional[str] = Field(
        None, description='The email address of the user making the change.'
    )


class DenominatorAggregation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    alignmentPeriod: Optional[str] = Field(
        None,
        description='The alignment period for per-time\nseries alignment. If present,\nalignmentPeriod must be at least\n60 seconds. After per-time series\nalignment, each time series will\ncontain data points only on the\nperiod boundaries. If\nperSeriesAligner is not specified\nor equals ALIGN_NONE, then this\nfield is ignored. If\nperSeriesAligner is specified and\ndoes not equal ALIGN_NONE, then\nthis field must be defined;\notherwise an error is returned.',
    )
    crossSeriesReducer: Optional[str] = Field(
        None,
        description='The approach to be used to combine\ntime series. Not all reducer\nfunctions may be applied to all\ntime series, depending on the\nmetric type and the value type of\nthe original time series.\nReduction may change the metric\ntype of value type of the time\nseries.Time series data must be\naligned in order to perform cross-\ntime series reduction. If\ncrossSeriesReducer is specified,\nthen perSeriesAligner must be\nspecified and not equal ALIGN_NONE\nand alignmentPeriod must be\nspecified; otherwise, an error is\nreturned. Possible values: ["REDUCE_NONE", "REDUCE_MEAN", "REDUCE_MIN", "REDUCE_MAX", "REDUCE_SUM", "REDUCE_STDDEV", "REDUCE_COUNT", "REDUCE_COUNT_TRUE", "REDUCE_COUNT_FALSE", "REDUCE_FRACTION_TRUE", "REDUCE_PERCENTILE_99", "REDUCE_PERCENTILE_95", "REDUCE_PERCENTILE_50", "REDUCE_PERCENTILE_05"].',
    )
    groupByFields: Optional[List[str]] = Field(
        None,
        description='The set of fields to preserve when\ncrossSeriesReducer is specified.\nThe groupByFields determine how\nthe time series are partitioned\ninto subsets prior to applying the\naggregation function. Each subset\ncontains time series that have the\nsame value for each of the\ngrouping fields. Each individual\ntime series is a member of exactly\none subset. The crossSeriesReducer\nis applied to each subset of time\nseries. It is not possible to\nreduce across different resource\ntypes, so this field implicitly\ncontains resource.type. Fields not\nspecified in groupByFields are\naggregated away. If groupByFields\nis not specified and all the time\nseries have the same resource\ntype, then the time series are\naggregated into a single output\ntime series. If crossSeriesReducer\nis not defined, this field is\nignored.',
    )
    perSeriesAligner: Optional[str] = Field(
        None,
        description='The approach to be used to align\nindividual time series. Not all\nalignment functions may be applied\nto all time series, depending on\nthe metric type and value type of\nthe original time series.\nAlignment may change the metric\ntype or the value type of the time\nseries.Time series data must be\naligned in order to perform cross-\ntime series reduction. If\ncrossSeriesReducer is specified,\nthen perSeriesAligner must be\nspecified and not equal ALIGN_NONE\nand alignmentPeriod must be\nspecified; otherwise, an error is\nreturned. Possible values: ["ALIGN_NONE", "ALIGN_DELTA", "ALIGN_RATE", "ALIGN_INTERPOLATE", "ALIGN_NEXT_OLDER", "ALIGN_MIN", "ALIGN_MAX", "ALIGN_MEAN", "ALIGN_COUNT", "ALIGN_SUM", "ALIGN_STDDEV", "ALIGN_COUNT_TRUE", "ALIGN_COUNT_FALSE", "ALIGN_FRACTION_TRUE", "ALIGN_PERCENTILE_99", "ALIGN_PERCENTILE_95", "ALIGN_PERCENTILE_50", "ALIGN_PERCENTILE_05", "ALIGN_PERCENT_CHANGE"].',
    )


class Documentation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    content: Optional[str] = Field(
        None,
        description='The text of the documentation, interpreted according to mimeType.\nThe content may not exceed 8,192 Unicode characters and may not\nexceed more than 10,240 bytes when encoded in UTF-8 format,\nwhichever is smaller.',
    )
    mimeType: Optional[str] = Field(
        None,
        description='The format of the content field. Presently, only the value\n"text/markdown" is supported.',
    )


class ForecastOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    forecastHorizon: str = Field(
        ...,
        description="The length of time into the future to forecast\nwhether a timeseries will violate the threshold.\nIf the predicted value is found to violate the\nthreshold, and the violation is observed in all\nforecasts made for the Configured 'duration',\nthen the timeseries is considered to be failing.",
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class NotificationChannelStrategyItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    notificationChannelNames: Optional[List[str]] = Field(
        None,
        description="The notification channels that these settings apply to. Each of these\ncorrespond to the name field in one of the NotificationChannel objects\nreferenced in the notification_channels field of this AlertPolicy. The format is\n'projects/[PROJECT_ID_OR_NUMBER]/notificationChannels/[CHANNEL_ID]'.",
    )
    renotifyInterval: Optional[str] = Field(
        None,
        description='The frequency at which to send reminder notifications for open incidents.',
    )


class NotificationChannels(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `MonitoringNotificationChannel` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NotificationChannels1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `MonitoringNotificationChannel` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class NotificationRateLimit(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    period: Optional[str] = Field(
        None, description='Not more than one notification per period.'
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    alertStrategy: Optional[AlertStrategy] = Field(
        None,
        description="Control over how this alert policy's notification channels are notified.",
    )
    combiner: str = Field(
        ...,
        description='How to combine the results of multiple conditions to\ndetermine if an incident should be opened. Possible values: ["AND", "OR", "AND_WITH_MATCHING_RESOURCE"].',
    )
    conditions: List[Condition] = Field(
        ...,
        description='A list of conditions for the policy. The conditions are combined by\nAND or OR according to the combiner field. If the combined conditions\nevaluate to true, then an incident is created. A policy can have from\none to six conditions.',
    )
    displayName: str = Field(
        ...,
        description="A short name or phrase used to identify the policy in\ndashboards, notifications, and incidents. To avoid confusion, don't use\nthe same display name for multiple policies in the same project. The\nname is limited to 512 Unicode characters.",
    )
    documentation: Optional[Documentation] = Field(
        None,
        description='Documentation that is included with notifications and incidents related\nto this policy. Best practice is for the documentation to include information\nto help responders understand, mitigate, escalate, and correct the underlying\nproblems detected by the alerting policy. Notification channels that have\nlimited capacity might not show this documentation.',
    )
    enabled: Optional[bool] = Field(
        None, description='Whether or not the policy is enabled. The default is true.'
    )
    notificationChannels: Optional[
        List[Union[NotificationChannels, NotificationChannels1]]
    ] = None
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The service-generated name of the resource. Used for acquisition only. Leave unset to create a new resource.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition1]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    creationRecord: Optional[List[CreationRecordItem]] = Field(
        None,
        description='A read-only record of the creation of the alerting policy.\nIf provided in a call to create or update, this field will\nbe ignored.',
    )
    name: Optional[str] = Field(
        None,
        description='The unique resource name for this policy.\nIts syntax is: projects/[PROJECT_ID]/alertPolicies/[ALERT_POLICY_ID].',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )


class Trigger(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    count: Optional[int] = Field(
        None,
        description='The absolute number of time series\nthat must fail the predicate for the\ncondition to be triggered.',
    )
    percent: Optional[float] = Field(
        None,
        description='The percentage of time series that\nmust fail the predicate for the\ncondition to be triggered.',
    )
