# generated by datamodel-codegen:
#   filename:  networksecurityservertlspolicy_v1beta1.json
#   timestamp: 2024-03-15T04:53:08+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class CertificateProviderInstance(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    pluginInstance: str = Field(
        ...,
        description='Required. Plugin instance name, used to locate and load CertificateProvider instance configuration. Set to "google_cloud_private_spiffe" to use Certificate Authority Service certificate provider instance.',
    )


class ClientValidationCaItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certificateProviderInstance: Optional[CertificateProviderInstance] = Field(
        None,
        description='The certificate provider instance specification that will be passed to the data plane, which will be used to load necessary credential information.',
    )
    grpcEndpoint: Optional[GrpcEndpoint] = Field(
        None,
        description='gRPC specific configuration to access the gRPC server to obtain the CA certificate.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class GrpcEndpoint(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    targetUri: str = Field(
        ...,
        description='Required. The target URI of the gRPC endpoint. Only UDS path is supported, and should start with “unix:”.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class MtlsPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clientValidationCa: List[ClientValidationCaItem] = Field(
        ...,
        description='Required. Defines the mechanism to obtain the Certificate Authority certificate to validate the client certificate.',
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServerCertificate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certificateProviderInstance: Optional[CertificateProviderInstance] = Field(
        None,
        description='The certificate provider instance specification that will be passed to the data plane, which will be used to load necessary credential information.',
    )
    grpcEndpoint: Optional[GrpcEndpoint] = Field(
        None,
        description='gRPC specific configuration to access the gRPC server to obtain the cert and private key.',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowOpen: Optional[bool] = Field(
        None,
        description='Optional. Determines if server allows plaintext connections. If set to true, server allows plain text connections. By default, it is set to false. This setting is not exclusive of other encryption modes. For example, if allow_open and mtls_policy are set, server allows both plain text and mTLS connections. See documentation of other encryption modes to confirm compatibility.',
    )
    description: Optional[str] = Field(
        None, description='Optional. Free-text description of the resource.'
    )
    location: str = Field(..., description='Immutable. The location for the resource')
    mtlsPolicy: Optional[MtlsPolicy] = Field(
        None,
        description='Optional. Defines a mechanism to provision peer validation certificates for peer to peer authentication (Mutual TLS - mTLS). If not specified, client certificate will not be requested. The connection is treated as TLS and not mTLS. If allow_open and mtls_policy are set, server allows both plain text and mTLS connections.',
    )
    projectRef: Optional[Union[ProjectRef, ProjectRef1]] = Field(
        None, description='Immutable. The Project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    serverCertificate: Optional[ServerCertificate] = Field(
        None,
        description='Optional. Defines a mechanism to provision server identity (public and private keys). Cannot be combined with allow_open as a permissive mode that allows both plain text and TLS is not supported.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The timestamp when the resource was created.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    updateTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The timestamp when the resource was updated.'
    )
