# generated by datamodel-codegen:
#   filename:  networkserviceshttproute_v1beta1.json
#   timestamp: 2024-03-15T04:53:12+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class Abort(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    httpStatus: Optional[int] = Field(
        None,
        description='The HTTP status code used to abort the request. The value must be between 200 and 599 inclusive.',
    )
    percentage: Optional[int] = Field(
        None,
        description='The percentage of traffic which will be aborted. The value must be between [0, 100]',
    )


class Action(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    corsPolicy: Optional[CorsPolicy] = Field(
        None,
        description='The specification for allowing client side cross-origin requests.',
    )
    destinations: Optional[List[Destination]] = Field(
        None, description='The destination to which traffic should be forwarded.'
    )
    faultInjectionPolicy: Optional[FaultInjectionPolicy] = Field(
        None,
        description='The specification for fault injection introduced into traffic to test the resiliency of clients to backend service failure. As part of fault injection, when clients send requests to a backend service, delays can be introduced on a percentage of requests before sending those requests to the backend service. Similarly requests from clients can be aborted for a percentage of requests. timeout and retry_policy will be ignored by clients that are configured with a fault_injection_policy',
    )
    redirect: Optional[Redirect] = Field(
        None, description='If set, the request is directed as configured by this field.'
    )
    requestHeaderModifier: Optional[RequestHeaderModifier] = Field(
        None,
        description='The specification for modifying the headers of a matching request prior to delivery of the request to the destination.',
    )
    requestMirrorPolicy: Optional[RequestMirrorPolicy] = Field(
        None,
        description='Specifies the policy on how requests intended for the routes destination are shadowed to a separate mirrored destination. Proxy will not wait for the shadow destination to respond before returning the response. Prior to sending traffic to the shadow service, the host/authority header is suffixed with -shadow.',
    )
    responseHeaderModifier: Optional[ResponseHeaderModifier] = Field(
        None,
        description='The specification for modifying the headers of a response prior to sending the response back to the client.',
    )
    retryPolicy: Optional[RetryPolicy] = Field(
        None, description='Specifies the retry policy associated with this route.'
    )
    timeout: Optional[str] = Field(
        None,
        description='Specifies the timeout for selected route. Timeout is computed from the time the request has been fully processed (i.e. end of stream) up until the response has been completely processed. Timeout includes all retries.',
    )
    urlRewrite: Optional[UrlRewrite] = Field(
        None,
        description='The specification for rewrite URL before forwarding requests to the destination.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class CorsPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowCredentials: Optional[bool] = Field(
        None,
        description='In response to a preflight request, setting this to true indicates that the actual request can include user credentials. This translates to the Access-Control-Allow-Credentials header. Default value is false.',
    )
    allowHeaders: Optional[List[str]] = Field(
        None,
        description='Specifies the content for Access-Control-Allow-Headers header.',
    )
    allowMethods: Optional[List[str]] = Field(
        None,
        description='Specifies the content for Access-Control-Allow-Methods header.',
    )
    allowOriginRegexes: Optional[List[str]] = Field(
        None,
        description='Specifies the regular expression patterns that match allowed origins. For regular expression grammar, please see https://github.com/google/re2/wiki/Syntax.',
    )
    allowOrigins: Optional[List[str]] = Field(
        None,
        description='Specifies the list of origins that will be allowed to do CORS requests. An origin is allowed if it matches either an item in allow_origins or an item in allow_origin_regexes.',
    )
    disabled: Optional[bool] = Field(
        None,
        description='If true, the CORS policy is disabled. The default value is false, which indicates that the CORS policy is in effect.',
    )
    exposeHeaders: Optional[List[str]] = Field(
        None,
        description='Specifies the content for Access-Control-Expose-Headers header.',
    )
    maxAge: Optional[str] = Field(
        None,
        description='Specifies how long result of a preflight request can be cached in seconds. This translates to the Access-Control-Max-Age header.',
    )


class Delay(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    fixedDelay: Optional[str] = Field(
        None, description='Specify a fixed delay before forwarding the request.'
    )
    percentage: Optional[int] = Field(
        None,
        description='The percentage of traffic on which delay will be injected. The value must be between [0, 100]',
    )


class Destination(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    serviceRef: Optional[Union[ServiceRef, ServiceRef1]] = None
    weight: Optional[int] = Field(
        None,
        description='Specifies the proportion of requests forwarded to the backend referenced by the serviceName field. This is computed as: weight/Sum(weights in this destination list). For non-zero values, there may be some epsilon from the exact proportion defined here depending on the precision an implementation supports. If only one serviceName is specified and it has a weight greater than 0, 100% of the traffic is forwarded to that backend. If weights are specified for any one service name, they need to be specified for all of them. If weights are unspecified for all services, then, traffic is distributed in equal proportions to all of them.',
    )


class Destination1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    serviceRef: Optional[Union[ServiceRef2, ServiceRef3]] = None
    weight: Optional[int] = Field(
        None,
        description='Specifies the proportion of requests forwarded to the backend referenced by the serviceName field. This is computed as: weight/Sum(weights in this destination list). For non-zero values, there may be some epsilon from the exact proportion defined here depending on the precision an implementation supports. If only one serviceName is specified and it has a weight greater than 0, 100% of the traffic is forwarded to that backend. If weights are specified for any one service name, they need to be specified for all of them. If weights are unspecified for all services, then, traffic is distributed in equal proportions to all of them.',
    )


class FaultInjectionPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    abort: Optional[Abort] = Field(
        None, description='The specification for aborting to client requests.'
    )
    delay: Optional[Delay] = Field(
        None, description='The specification for injecting delay to client requests.'
    )


class Gateways(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `NetworkServicesGateway` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Gateways1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `NetworkServicesGateway` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Header(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    exactMatch: Optional[str] = Field(
        None,
        description='The value of the header should match exactly the content of exact_match.',
    )
    header: Optional[str] = Field(
        None, description='The name of the HTTP header to match against.'
    )
    invertMatch: Optional[bool] = Field(
        None,
        description='If specified, the match result will be inverted before checking. Default value is set to false.',
    )
    prefixMatch: Optional[str] = Field(
        None,
        description='The value of the header must start with the contents of prefix_match.',
    )
    presentMatch: Optional[bool] = Field(
        None,
        description='A header with header_name must exist. The match takes place whether or not the header has a value.',
    )
    rangeMatch: Optional[RangeMatch] = Field(
        None,
        description='If specified, the rule will match if the request header value is within the range.',
    )
    regexMatch: Optional[str] = Field(
        None,
        description='The value of the header must match the regular expression specified in regex_match. For regular expression grammar, please see: https://github.com/google/re2/wiki/Syntax',
    )
    suffixMatch: Optional[str] = Field(
        None,
        description='The value of the header must end with the contents of suffix_match.',
    )


class Match(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    fullPathMatch: Optional[str] = Field(
        None,
        description='The HTTP request path value should exactly match this value. Only one of full_path_match, prefix_match, or regex_match should be used.',
    )
    headers: Optional[List[Header]] = Field(
        None,
        description='Specifies a list of HTTP request headers to match against. ALL of the supplied headers must be matched.',
    )
    ignoreCase: Optional[bool] = Field(
        None,
        description='Specifies if prefix_match and full_path_match matches are case sensitive. The default value is false.',
    )
    prefixMatch: Optional[str] = Field(
        None,
        description='The HTTP request path value must begin with specified prefix_match. prefix_match must begin with a /. Only one of full_path_match, prefix_match, or regex_match should be used.',
    )
    queryParameters: Optional[List[QueryParameter]] = Field(
        None,
        description='Specifies a list of query parameters to match against. ALL of the query parameters must be matched.',
    )
    regexMatch: Optional[str] = Field(
        None,
        description='The HTTP request path value must satisfy the regular expression specified by regex_match after removing any query parameters and anchor supplied with the original URL. For regular expression grammar, please see https://github.com/google/re2/wiki/Syntax Only one of full_path_match, prefix_match, or regex_match should be used.',
    )


class Meshes(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `NetworkServicesMesh` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Meshes1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `NetworkServicesMesh` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class QueryParameter(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    exactMatch: Optional[str] = Field(
        None,
        description='The value of the query parameter must exactly match the contents of exact_match. Only one of exact_match, regex_match, or present_match must be set.',
    )
    presentMatch: Optional[bool] = Field(
        None,
        description='Specifies that the QueryParameterMatcher matches if request contains query parameter, irrespective of whether the parameter has a value or not. Only one of exact_match, regex_match, or present_match must be set.',
    )
    queryParameter: Optional[str] = Field(
        None, description='The name of the query parameter to match.'
    )
    regexMatch: Optional[str] = Field(
        None,
        description='The value of the query parameter must match the regular expression specified by regex_match. For regular expression grammar, please see https://github.com/google/re2/wiki/Syntax Only one of exact_match, regex_match, or present_match must be set.',
    )


class RangeMatch(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    end: Optional[int] = Field(None, description='End of the range (exclusive)')
    start: Optional[int] = Field(None, description='Start of the range (inclusive)')


class Redirect(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hostRedirect: Optional[str] = Field(
        None,
        description='The host that will be used in the redirect response instead of the one that was supplied in the request.',
    )
    httpsRedirect: Optional[bool] = Field(
        None,
        description='If set to true, the URL scheme in the redirected request is set to https. If set to false, the URL scheme of the redirected request will remain the same as that of the request. The default is set to false.',
    )
    pathRedirect: Optional[str] = Field(
        None,
        description='The path that will be used in the redirect response instead of the one that was supplied in the request. path_redirect can not be supplied together with prefix_redirect. Supply one alone or neither. If neither is supplied, the path of the original request will be used for the redirect.',
    )
    portRedirect: Optional[int] = Field(
        None,
        description='The port that will be used in the redirected request instead of the one that was supplied in the request.',
    )
    prefixRewrite: Optional[str] = Field(
        None,
        description='Indicates that during redirection, the matched prefix (or path) should be swapped with this value. This option allows URLs be dynamically created based on the request.',
    )
    responseCode: Optional[str] = Field(
        None,
        description='The HTTP Status code to use for the redirect. Possible values: MOVED_PERMANENTLY_DEFAULT, FOUND, SEE_OTHER, TEMPORARY_REDIRECT, PERMANENT_REDIRECT',
    )
    stripQuery: Optional[bool] = Field(
        None,
        description='if set to true, any accompanying query portion of the original URL is removed prior to redirecting the request. If set to false, the query portion of the original URL is retained. The default is set to false.',
    )


class RequestHeaderModifier(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    add: Optional[Dict[str, str]] = Field(
        None,
        description='Add the headers with given map where key is the name of the header, value is the value of the header.',
    )
    remove: Optional[List[str]] = Field(
        None,
        description='Remove headers (matching by header names) specified in the list.',
    )
    set: Optional[Dict[str, str]] = Field(
        None,
        description='Completely overwrite/replace the headers with given map where key is the name of the header, value is the value of the header.',
    )


class RequestMirrorPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    destination: Optional[Destination1] = Field(
        None,
        description='The destination the requests will be mirrored to. The weight of the destination will be ignored.',
    )


class ResponseHeaderModifier(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    add: Optional[Dict[str, str]] = Field(
        None,
        description='Add the headers with given map where key is the name of the header, value is the value of the header.',
    )
    remove: Optional[List[str]] = Field(
        None,
        description='Remove headers (matching by header names) specified in the list.',
    )
    set: Optional[Dict[str, str]] = Field(
        None,
        description='Completely overwrite/replace the headers with given map where key is the name of the header, value is the value of the header.',
    )


class RetryPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    numRetries: Optional[int] = Field(
        None,
        description='Specifies the allowed number of retries. This number must be > 0. If not specified, default to 1.',
    )
    perTryTimeout: Optional[str] = Field(
        None, description='Specifies a non-zero timeout per retry attempt.'
    )
    retryConditions: Optional[List[str]] = Field(
        None,
        description='Specifies one or more conditions when this retry policy applies. Valid values are: 5xx: Proxy will attempt a retry if the destination service responds with any 5xx response code, of if the destination service does not respond at all, example: disconnect, reset, read timeout, connection failure and refused streams. gateway-error: Similar to 5xx, but only applies to response codes 502, 503, 504. reset: Proxy will attempt a retry if the destination service does not respond at all (disconnect/reset/read timeout) connect-failure: Proxy will retry on failures connecting to destination for example due to connection timeouts. retriable-4xx: Proxy will retry fro retriable 4xx response codes. Currently the only retriable error supported is 409. refused-stream: Proxy will retry if the destination resets the stream with a REFUSED_STREAM error code. This reset type indicates that it is safe to retry.',
    )


class Rule(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    action: Optional[Action] = Field(
        None, description='The detailed rule defining how to route matched traffic.'
    )
    matches: Optional[List[Match]] = Field(
        None,
        description='A list of matches define conditions used for matching the rule against incoming HTTP requests. Each match is independent, i.e. this rule will be matched if ANY one of the matches is satisfied.',
    )


class ServiceRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The URL of a BackendService to route traffic to.\n\nAllowed value: The Google Cloud resource name of a `ComputeBackendService` resource (format: `projects/{{project}}/global/backendServices/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The URL of a BackendService to route traffic to.\n\nAllowed value: The Google Cloud resource name of a `ComputeBackendService` resource (format: `projects/{{project}}/global/backendServices/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The URL of a BackendService to route traffic to.\n\nAllowed value: The Google Cloud resource name of a `ComputeBackendService` resource (format: `projects/{{project}}/global/backendServices/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ServiceRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The URL of a BackendService to route traffic to.\n\nAllowed value: The Google Cloud resource name of a `ComputeBackendService` resource (format: `projects/{{project}}/global/backendServices/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None,
        description='Optional. A free-text description of the resource. Max length 1024 characters.',
    )
    gateways: Optional[List[Union[Gateways, Gateways1]]] = None
    hostnames: List[str] = Field(
        ...,
        description='Required. Hostnames define a set of hosts that should match against the HTTP host header to select a HttpRoute to process the request. Hostname is the fully qualified domain name of a network host, as defined by RFC 1123 with the exception that ip addresses are not allowed. Wildcard hosts are supported as "*" (no prefix or suffix allowed).',
    )
    location: str = Field(..., description='Immutable. The location for the resource')
    meshes: Optional[List[Union[Meshes, Meshes1]]] = None
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='Immutable. The Project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    rules: List[Rule] = Field(
        ...,
        description='Required. Rules that define how traffic is routed and handled.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The timestamp when the resource was created.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    selfLink: Optional[str] = Field(
        None, description='Output only. Server-defined URL of this resource'
    )
    updateTime: Optional[AwareDatetime] = Field(
        None, description='Output only. The timestamp when the resource was updated.'
    )


class UrlRewrite(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hostRewrite: Optional[str] = Field(
        None,
        description='Prior to forwarding the request to the selected destination, the requests host header is replaced by this value.',
    )
    pathPrefixRewrite: Optional[str] = Field(
        None,
        description='Prior to forwarding the request to the selected destination, the matching portion of the requests path is replaced by this value.',
    )
