# generated by datamodel-codegen:
#   filename:  osconfigpatchdeployment_v1alpha1.json
#   timestamp: 2024-03-15T04:53:16+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Apt(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    excludes: Optional[List[str]] = Field(
        None,
        description='Immutable. List of packages to exclude from update. These packages will be excluded.',
    )
    exclusivePackages: Optional[List[str]] = Field(
        None,
        description='Immutable. An exclusive list of packages to be updated. These are the only packages that will be updated.\nIf these packages are not installed, they will be ignored. This field cannot be specified with\nany other patch configuration fields.',
    )
    type: Optional[str] = Field(
        None,
        description='Immutable. By changing the type to DIST, the patching is performed using apt-get dist-upgrade instead. Possible values: ["DIST", "UPGRADE"].',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class DisruptionBudget(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    fixed: Optional[int] = Field(
        None, description='Immutable. Specifies a fixed value.'
    )
    percentage: Optional[int] = Field(
        None,
        description='Immutable. Specifies the relative value defined as a percentage, which will be multiplied by a reference value.',
    )


class GcsObject(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bucket: str = Field(
        ..., description='Immutable. Bucket of the Cloud Storage object.'
    )
    generationNumber: str = Field(
        ...,
        description='Immutable. Generation number of the Cloud Storage object. This is used to ensure that the ExecStep specified by this PatchJob does not change.',
    )
    object: str = Field(..., description='Immutable. Name of the Cloud Storage object.')


class Goo(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: bool = Field(
        ...,
        description='Immutable. goo update settings. Use this setting to override the default goo patch rules.',
    )


class GroupLabel(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    labels: Dict[str, str] = Field(
        ...,
        description='Immutable. Compute Engine instance labels that must be present for a VM instance to be targeted by this filter.',
    )


class InstanceFilter(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    all: Optional[bool] = Field(
        None,
        description='Immutable. Target all VM instances in the project. If true, no other criteria is permitted.',
    )
    groupLabels: Optional[List[GroupLabel]] = Field(
        None,
        description='Immutable. Targets VM instances matching ANY of these GroupLabels. This allows targeting of disparate groups of VM instances.',
    )
    instanceNamePrefixes: Optional[List[str]] = Field(
        None,
        description='Immutable. Targets VMs whose name starts with one of these prefixes. Similar to labels, this is another way to group\nVMs when targeting configs, for example prefix="prod-".',
    )
    instances: Optional[List[str]] = Field(
        None,
        description="Immutable. Targets any of the VM instances specified. Instances are specified by their URI in the 'form zones/{{zone}}/instances/{{instance_name}}',\n'projects/{{project_id}}/zones/{{zone}}/instances/{{instance_name}}', or\n'https://www.googleapis.com/compute/v1/projects/{{project_id}}/zones/{{zone}}/instances/{{instance_name}}'.",
    )
    zones: Optional[List[str]] = Field(
        None,
        description='Immutable. Targets VM instances in ANY of these zones. Leave empty to target VM instances in any zone.',
    )


class LinuxExecStepConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowedSuccessCodes: Optional[List[int]] = Field(
        None,
        description='Immutable. Defaults to [0]. A list of possible return values that the execution can return to indicate a success.',
    )
    gcsObject: Optional[GcsObject] = Field(
        None, description='Immutable. A Cloud Storage object containing the executable.'
    )
    interpreter: Optional[str] = Field(
        None,
        description='Immutable. The script interpreter to use to run the script. If no interpreter is specified the script will\nbe executed directly, which will likely only succeed for scripts with shebang lines. Possible values: ["SHELL", "POWERSHELL"].',
    )
    localPath: Optional[str] = Field(
        None, description='Immutable. An absolute path to the executable on the VM.'
    )


class LinuxExecStepConfig1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowedSuccessCodes: Optional[List[int]] = Field(
        None,
        description='Immutable. Defaults to [0]. A list of possible return values that the execution can return to indicate a success.',
    )
    gcsObject: Optional[GcsObject] = Field(
        None, description='Immutable. A Cloud Storage object containing the executable.'
    )
    interpreter: Optional[str] = Field(
        None,
        description='Immutable. The script interpreter to use to run the script. If no interpreter is specified the script will\nbe executed directly, which will likely only succeed for scripts with shebang lines. Possible values: ["SHELL", "POWERSHELL"].',
    )
    localPath: Optional[str] = Field(
        None, description='Immutable. An absolute path to the executable on the VM.'
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Monthly(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    monthDay: Optional[int] = Field(
        None,
        description='Immutable. One day of the month. 1-31 indicates the 1st to the 31st day. -1 indicates the last day of the month.\nMonths without the target day will be skipped. For example, a schedule to run "every month on the 31st"\nwill not run in February, April, June, etc.',
    )
    weekDayOfMonth: Optional[WeekDayOfMonth] = Field(
        None, description='Immutable. Week day in a month.'
    )


class OneTimeSchedule(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    executeTime: str = Field(
        ...,
        description='Immutable. The desired patch job execution time. A timestamp in RFC3339 UTC "Zulu" format,\naccurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )


class PatchConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    apt: Optional[Apt] = Field(
        None,
        description='Immutable. Apt update settings. Use this setting to override the default apt patch rules.',
    )
    goo: Optional[Goo] = Field(
        None,
        description='Immutable. goo update settings. Use this setting to override the default goo patch rules.',
    )
    migInstancesAllowed: Optional[bool] = Field(
        None,
        description='Immutable. Allows the patch job to run on Managed instance groups (MIGs).',
    )
    postStep: Optional[PostStep] = Field(
        None, description='Immutable. The ExecStep to run after the patch update.'
    )
    preStep: Optional[PreStep] = Field(
        None, description='Immutable. The ExecStep to run before the patch update.'
    )
    rebootConfig: Optional[str] = Field(
        None,
        description='Immutable. Post-patch reboot settings. Possible values: ["DEFAULT", "ALWAYS", "NEVER"].',
    )
    windowsUpdate: Optional[WindowsUpdate] = Field(
        None,
        description='Immutable. Windows update settings. Use this setting to override the default Windows patch rules.',
    )
    yum: Optional[Yum] = Field(
        None,
        description='Immutable. Yum update settings. Use this setting to override the default yum patch rules.',
    )
    zypper: Optional[Zypper] = Field(
        None,
        description='Immutable. zypper update settings. Use this setting to override the default zypper patch rules.',
    )


class PostStep(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    linuxExecStepConfig: Optional[LinuxExecStepConfig] = Field(
        None,
        description='Immutable. The ExecStepConfig for all Linux VMs targeted by the PatchJob.',
    )
    windowsExecStepConfig: Optional[WindowsExecStepConfig] = Field(
        None,
        description='Immutable. The ExecStepConfig for all Windows VMs targeted by the PatchJob.',
    )


class PreStep(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    linuxExecStepConfig: Optional[LinuxExecStepConfig1] = Field(
        None,
        description='Immutable. The ExecStepConfig for all Linux VMs targeted by the PatchJob.',
    )
    windowsExecStepConfig: Optional[WindowsExecStepConfig1] = Field(
        None,
        description='Immutable. The ExecStepConfig for all Windows VMs targeted by the PatchJob.',
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RecurringSchedule(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    endTime: Optional[str] = Field(
        None,
        description='Immutable. The end time at which a recurring patch deployment schedule is no longer active.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    lastExecuteTime: Optional[str] = Field(
        None,
        description='The time the last patch job ran successfully.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    monthly: Optional[Monthly] = Field(
        None, description='Immutable. Schedule with monthly executions.'
    )
    nextExecuteTime: Optional[str] = Field(
        None,
        description='The time the next patch job is scheduled to run.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    startTime: Optional[str] = Field(
        None,
        description='Immutable. The time that the recurring schedule becomes effective. Defaults to createTime of the patch deployment.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    timeOfDay: TimeOfDay = Field(
        ..., description='Immutable. Time of the day to run a recurring deployment.'
    )
    timeZone: TimeZone = Field(
        ...,
        description='Immutable. Defines the time zone that timeOfDay is relative to. The rules for daylight saving time are\ndetermined by the chosen time zone.',
    )
    weekly: Optional[Weekly] = Field(
        None, description='Immutable. Schedule with weekly executions.'
    )


class Rollout(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    disruptionBudget: DisruptionBudget = Field(
        ...,
        description='Immutable. The maximum number (or percentage) of VMs per zone to disrupt at any given moment. The number of VMs calculated from multiplying the percentage by the total number of VMs in a zone is rounded up.\nDuring patching, a VM is considered disrupted from the time the agent is notified to begin until patching has completed. This disruption time includes the time to complete reboot and any post-patch steps.\nA VM contributes to the disruption budget if its patching operation fails either when applying the patches, running pre or post patch steps, or if it fails to respond with a success notification before timing out. VMs that are not running or do not have an active agent do not count toward this disruption budget.\nFor zone-by-zone rollouts, if the disruption budget in a zone is exceeded, the patch job stops, because continuing to the next zone requires completion of the patch process in the previous zone.\nFor example, if the disruption budget has a fixed value of 10, and 8 VMs fail to patch in the current zone, the patch job continues to patch 2 VMs at a time until the zone is completed. When that zone is completed successfully, patching begins with 10 VMs at a time in the next zone. If 10 VMs in the next zone fail to patch, the patch job stops.',
    )
    mode: str = Field(
        ...,
        description='Immutable. Mode of the patch rollout. Possible values: ["ZONE_BY_ZONE", "CONCURRENT_ZONES"].',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None,
        description='Immutable. Description of the patch deployment. Length of the description is limited to 1024 characters.',
    )
    duration: Optional[str] = Field(
        None,
        description='Immutable. Duration of the patch. After the duration ends, the patch times out.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    instanceFilter: InstanceFilter = Field(
        ..., description='Immutable. VM instances to patch.'
    )
    oneTimeSchedule: Optional[OneTimeSchedule] = Field(
        None, description='Immutable. Schedule a one-time execution.'
    )
    patchConfig: Optional[PatchConfig] = Field(
        None, description='Immutable. Patch configuration that is applied.'
    )
    patchDeploymentId: str = Field(
        ...,
        description='Immutable. A name for the patch deployment in the project. When creating a name the following rules apply:\n* Must contain only lowercase letters, numbers, and hyphens.\n* Must start with a letter.\n* Must be between 1-63 characters.\n* Must end with a number or a letter.\n* Must be unique within the project.',
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    recurringSchedule: Optional[RecurringSchedule] = Field(
        None, description='Immutable. Schedule recurring executions.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The service-generated name of the resource. Used for acquisition only. Leave unset to create a new resource.',
    )
    rollout: Optional[Rollout] = Field(
        None, description='Immutable. Rollout strategy of the patch job.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None,
        description='Time the patch deployment was created. Timestamp is in RFC3339 text format.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    lastExecuteTime: Optional[str] = Field(
        None,
        description='The last time a patch job was started by this deployment. Timestamp is in RFC3339 text format.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )
    name: Optional[str] = Field(
        None,
        description='Unique name for the patch deployment resource in a project.\nThe patch deployment name is in the form: projects/{project_id}/patchDeployments/{patchDeploymentId}.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    updateTime: Optional[str] = Field(
        None,
        description='Time the patch deployment was last updated. Timestamp is in RFC3339 text format.\nA timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds. Example: "2014-10-02T15:01:23.045123456Z".',
    )


class TimeOfDay(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hours: Optional[int] = Field(
        None,
        description='Immutable. Hours of day in 24 hour format. Should be from 0 to 23.\nAn API may choose to allow the value "24:00:00" for scenarios like business closing time.',
    )
    minutes: Optional[int] = Field(
        None, description='Immutable. Minutes of hour of day. Must be from 0 to 59.'
    )
    nanos: Optional[int] = Field(
        None,
        description='Immutable. Fractions of seconds in nanoseconds. Must be from 0 to 999,999,999.',
    )
    seconds: Optional[int] = Field(
        None,
        description='Immutable. Seconds of minutes of the time. Must normally be from 0 to 59. An API may allow the value 60 if it allows leap-seconds.',
    )


class TimeZone(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: str = Field(
        ...,
        description='Immutable. IANA Time Zone Database time zone, e.g. "America/New_York".',
    )
    version: Optional[str] = Field(
        None,
        description='Immutable. IANA Time Zone Database version number, e.g. "2019a".',
    )


class WeekDayOfMonth(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    dayOfWeek: str = Field(
        ...,
        description='Immutable. A day of the week. Possible values: ["MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY", "SUNDAY"].',
    )
    weekOrdinal: int = Field(
        ...,
        description='Immutable. Week number in a month. 1-4 indicates the 1st to 4th week of the month. -1 indicates the last week of the month.',
    )


class Weekly(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    dayOfWeek: str = Field(
        ...,
        description='Immutable. IANA Time Zone Database time zone, e.g. "America/New_York". Possible values: ["MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY", "SUNDAY"].',
    )


class WindowsExecStepConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowedSuccessCodes: Optional[List[int]] = Field(
        None,
        description='Immutable. Defaults to [0]. A list of possible return values that the execution can return to indicate a success.',
    )
    gcsObject: Optional[GcsObject] = Field(
        None, description='Immutable. A Cloud Storage object containing the executable.'
    )
    interpreter: Optional[str] = Field(
        None,
        description='Immutable. The script interpreter to use to run the script. If no interpreter is specified the script will\nbe executed directly, which will likely only succeed for scripts with shebang lines. Possible values: ["SHELL", "POWERSHELL"].',
    )
    localPath: Optional[str] = Field(
        None, description='Immutable. An absolute path to the executable on the VM.'
    )


class WindowsExecStepConfig1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowedSuccessCodes: Optional[List[int]] = Field(
        None,
        description='Immutable. Defaults to [0]. A list of possible return values that the execution can return to indicate a success.',
    )
    gcsObject: Optional[GcsObject] = Field(
        None, description='Immutable. A Cloud Storage object containing the executable.'
    )
    interpreter: Optional[str] = Field(
        None,
        description='Immutable. The script interpreter to use to run the script. If no interpreter is specified the script will\nbe executed directly, which will likely only succeed for scripts with shebang lines. Possible values: ["SHELL", "POWERSHELL"].',
    )
    localPath: Optional[str] = Field(
        None, description='Immutable. An absolute path to the executable on the VM.'
    )


class WindowsUpdate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    classifications: Optional[List[str]] = Field(
        None,
        description='Immutable. Only apply updates of these windows update classifications. If empty, all updates are applied. Possible values: ["CRITICAL", "SECURITY", "DEFINITION", "DRIVER", "FEATURE_PACK", "SERVICE_PACK", "TOOL", "UPDATE_ROLLUP", "UPDATE"].',
    )
    excludes: Optional[List[str]] = Field(
        None, description='Immutable. List of KBs to exclude from update.'
    )
    exclusivePatches: Optional[List[str]] = Field(
        None,
        description='Immutable. An exclusive list of kbs to be updated. These are the only patches that will be updated.\nThis field must not be used with other patch configurations.',
    )


class Yum(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    excludes: Optional[List[str]] = Field(
        None,
        description='Immutable. List of packages to exclude from update. These packages will be excluded.',
    )
    exclusivePackages: Optional[List[str]] = Field(
        None,
        description='Immutable. An exclusive list of packages to be updated. These are the only packages that will be updated.\nIf these packages are not installed, they will be ignored. This field cannot be specified with\nany other patch configuration fields.',
    )
    minimal: Optional[bool] = Field(
        None,
        description='Immutable. Will cause patch to run yum update-minimal instead.',
    )
    security: Optional[bool] = Field(
        None,
        description='Immutable. Adds the --security flag to yum update. Not supported on all platforms.',
    )


class Zypper(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    categories: Optional[List[str]] = Field(
        None,
        description='Immutable. Install only patches with these categories. Common categories include security, recommended, and feature.',
    )
    excludes: Optional[List[str]] = Field(
        None, description='Immutable. List of packages to exclude from update.'
    )
    exclusivePatches: Optional[List[str]] = Field(
        None,
        description="Immutable. An exclusive list of patches to be updated. These are the only patches that will be installed using 'zypper patch patch:' command.\nThis field must not be used with any other patch configuration fields.",
    )
    severities: Optional[List[str]] = Field(
        None,
        description='Immutable. Install only patches with these severities. Common severities include critical, important, moderate, and low.',
    )
    withOptional: Optional[bool] = Field(
        None, description='Immutable. Adds the --with-optional flag to zypper patch.'
    )
    withUpdate: Optional[bool] = Field(
        None, description='Immutable. Adds the --with-update flag, to zypper patch.'
    )
