# generated by datamodel-codegen:
#   filename:  privatecacertificateauthority_v1beta1.json
#   timestamp: 2024-03-15T04:53:18+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class AccessUrls(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    caCertificateAccessUrl: Optional[str] = Field(
        None,
        description="The URL where this CertificateAuthority's CA certificate is published. This will only be set for CAs that have been activated.",
    )
    crlAccessUrls: Optional[List[str]] = Field(
        None,
        description="The URLs where this CertificateAuthority's CRLs are published. This will only be set for CAs that have been activated.",
    )


class AdditionalExtension(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    critical: Optional[bool] = Field(
        None,
        description='Immutable. Optional. Indicates whether or not this extension is critical (i.e., if the client does not know how to handle this extension, the client should consider this to be an error).',
    )
    objectId: ObjectId = Field(
        ..., description='Immutable. Required. The OID for this X.509 extension.'
    )
    value: str = Field(
        ..., description='Immutable. Required. The value of this X.509 extension.'
    )


class AdditionalExtension1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    critical: Optional[bool] = Field(
        None,
        description='Optional. Indicates whether or not this extension is critical (i.e., if the client does not know how to handle this extension, the client should consider this to be an error).',
    )
    objectId: Optional[ObjectId2] = Field(
        None, description='Required. The OID for this X.509 extension.'
    )
    value: Optional[str] = Field(
        None, description='Required. The value of this X.509 extension.'
    )


class AuthorityKeyId(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    keyId: Optional[str] = Field(
        None,
        description='Optional. The value of this KeyId encoded in lowercase hexadecimal. This is most likely the 160 bit SHA-1 hash of the public key.',
    )


class BaseKeyUsage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certSign: Optional[bool] = Field(
        None, description='Immutable. The key may be used to sign certificates.'
    )
    contentCommitment: Optional[bool] = Field(
        None,
        description='Immutable. The key may be used for cryptographic commitments. Note that this may also be referred to as "non-repudiation".',
    )
    crlSign: Optional[bool] = Field(
        None,
        description='Immutable. The key may be used sign certificate revocation lists.',
    )
    dataEncipherment: Optional[bool] = Field(
        None, description='Immutable. The key may be used to encipher data.'
    )
    decipherOnly: Optional[bool] = Field(
        None, description='Immutable. The key may be used to decipher only.'
    )
    digitalSignature: Optional[bool] = Field(
        None, description='Immutable. The key may be used for digital signatures.'
    )
    encipherOnly: Optional[bool] = Field(
        None, description='Immutable. The key may be used to encipher only.'
    )
    keyAgreement: Optional[bool] = Field(
        None, description='Immutable. The key may be used in a key agreement protocol.'
    )
    keyEncipherment: Optional[bool] = Field(
        None, description='Immutable. The key may be used to encipher other keys.'
    )


class BaseKeyUsage1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certSign: Optional[bool] = Field(
        None, description='The key may be used to sign certificates.'
    )
    contentCommitment: Optional[bool] = Field(
        None,
        description='The key may be used for cryptographic commitments. Note that this may also be referred to as "non-repudiation".',
    )
    crlSign: Optional[bool] = Field(
        None, description='The key may be used sign certificate revocation lists.'
    )
    dataEncipherment: Optional[bool] = Field(
        None, description='The key may be used to encipher data.'
    )
    decipherOnly: Optional[bool] = Field(
        None, description='The key may be used to decipher only.'
    )
    digitalSignature: Optional[bool] = Field(
        None, description='The key may be used for digital signatures.'
    )
    encipherOnly: Optional[bool] = Field(
        None, description='The key may be used to encipher only.'
    )
    keyAgreement: Optional[bool] = Field(
        None, description='The key may be used in a key agreement protocol.'
    )
    keyEncipherment: Optional[bool] = Field(
        None, description='The key may be used to encipher other keys.'
    )


class CaCertificateDescription(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    aiaIssuingCertificateUrls: Optional[List[str]] = Field(
        None,
        description='Describes lists of issuer CA certificate URLs that appear in the "Authority Information Access" extension in the certificate.',
    )
    authorityKeyId: Optional[AuthorityKeyId] = Field(
        None,
        description='Identifies the subject_key_id of the parent certificate, per https://tools.ietf.org/html/rfc5280#section-4.2.1.1',
    )
    certFingerprint: Optional[CertFingerprint] = Field(
        None, description='The hash of the x.509 certificate.'
    )
    crlDistributionPoints: Optional[List[str]] = Field(
        None,
        description='Describes a list of locations to obtain CRL information, i.e. the DistributionPoint.fullName described by https://tools.ietf.org/html/rfc5280#section-4.2.1.13',
    )
    publicKey: Optional[PublicKey] = Field(
        None, description='The public key that corresponds to an issued certificate.'
    )
    subjectDescription: Optional[SubjectDescription] = Field(
        None,
        description='Describes some of the values in a certificate that are related to the subject and lifetime.',
    )
    subjectKeyId: Optional[SubjectKeyId] = Field(
        None,
        description='Provides a means of identifiying certificates that contain a particular public key, per https://tools.ietf.org/html/rfc5280#section-4.2.1.2.',
    )
    x509Description: Optional[X509Description] = Field(
        None,
        description='Describes some of the technical X.509 fields in a certificate.',
    )


class CaOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    isCa: Optional[bool] = Field(
        None,
        description='Immutable. Optional. Refers to the "CA" X.509 extension, which is a boolean value. When this value is missing, the extension will be omitted from the CA certificate.',
    )
    maxIssuerPathLength: Optional[int] = Field(
        None,
        description='Immutable. Optional. Refers to the path length restriction X.509 extension. For a CA certificate, this value describes the depth of subordinate CA certificates that are allowed. If this value is less than 0, the request will fail. If this value is missing, the max path length will be omitted from the CA certificate.',
    )
    zeroMaxIssuerPathLength: Optional[bool] = Field(
        None,
        description='Immutable. Optional. When true, the "path length constraint" in Basic Constraints extension will be set to 0. if both max_issuer_path_length and zero_max_issuer_path_length are unset, the max path length will be omitted from the CA certificate.',
    )


class CaOptions1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    isCa: Optional[bool] = Field(
        None,
        description='Optional. Refers to the "CA" X.509 extension, which is a boolean value. When this value is missing, the extension will be omitted from the CA certificate.',
    )
    maxIssuerPathLength: Optional[int] = Field(
        None,
        description='Optional. Refers to the path length restriction X.509 extension. For a CA certificate, this value describes the depth of subordinate CA certificates that are allowed. If this value is less than 0, the request will fail. If this value is missing, the max path length will be omitted from the CA certificate.',
    )


class CaPoolRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The caPool for the resource\n\nAllowed value: The Google Cloud resource name of a `PrivateCACAPool` resource (format: `projects/{{project}}/locations/{{location}}/caPools/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class CaPoolRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The caPool for the resource\n\nAllowed value: The Google Cloud resource name of a `PrivateCACAPool` resource (format: `projects/{{project}}/locations/{{location}}/caPools/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class CertFingerprint(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    sha256Hash: Optional[str] = Field(
        None,
        description='The SHA 256 hash, encoded in hexadecimal, of the DER x509 certificate.',
    )


class CloudKmsKeyVersionRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description="The resource name for an existing Cloud KMS CryptoKeyVersion in the format `projects/*/locations/*/keyRings/*/cryptoKeys/*/cryptoKeyVersions/*`. This option enables full flexibility in the key's capabilities and properties.",
    )
    name: str = Field(
        ...,
        description="[WARNING] KMSCryptoKeyVersion not yet supported in Config Connector, use 'external' field to reference existing resources.\nName of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names",
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class CloudKmsKeyVersionRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description="The resource name for an existing Cloud KMS CryptoKeyVersion in the format `projects/*/locations/*/keyRings/*/cryptoKeys/*/cryptoKeyVersions/*`. This option enables full flexibility in the key's capabilities and properties.",
    )
    name: Optional[str] = Field(
        None,
        description="[WARNING] KMSCryptoKeyVersion not yet supported in Config Connector, use 'external' field to reference existing resources.\nName of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names",
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Config(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    subjectConfig: SubjectConfig = Field(
        ...,
        description='Immutable. Required. Specifies some of the values in a certificate that are related to the subject.',
    )
    x509Config: X509Config = Field(
        ...,
        description='Immutable. Required. Describes how some of the technical X.509 fields in a certificate should be populated.',
    )


class Config1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publicKey: Optional[PublicKey] = Field(
        None,
        description='Optional. The public key that corresponds to this config. This is, for example, used when issuing Certificates, but not when creating a self-signed CertificateAuthority or CertificateAuthority CSR.',
    )
    x509Config: Optional[X509Config1] = None


class CustomSan(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    critical: Optional[bool] = Field(
        None,
        description='Immutable. Optional. Indicates whether or not this extension is critical (i.e., if the client does not know how to handle this extension, the client should consider this to be an error).',
    )
    objectId: ObjectId = Field(
        ..., description='Immutable. Required. The OID for this X.509 extension.'
    )
    value: str = Field(
        ..., description='Immutable. Required. The value of this X.509 extension.'
    )


class CustomSan1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    critical: Optional[bool] = Field(
        None,
        description='Optional. Indicates whether or not this extension is critical (i.e., if the client does not know how to handle this extension, the client should consider this to be an error).',
    )
    objectId: Optional[ObjectId2] = Field(
        None, description='Required. The OID for this X.509 extension.'
    )
    value: Optional[str] = Field(
        None, description='Required. The value of this X.509 extension.'
    )


class ExtendedKeyUsage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clientAuth: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.2. Officially described as "TLS WWW client authentication", though regularly used for non-WWW TLS.',
    )
    codeSigning: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.3. Officially described as "Signing of downloadable executable code client authentication".',
    )
    emailProtection: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.4. Officially described as "Email protection".',
    )
    ocspSigning: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.9. Officially described as "Signing OCSP responses".',
    )
    serverAuth: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.1. Officially described as "TLS WWW server authentication", though regularly used for non-WWW TLS.',
    )
    timeStamping: Optional[bool] = Field(
        None,
        description='Immutable. Corresponds to OID 1.3.6.1.5.5.7.3.8. Officially described as "Binding the hash of an object to a time".',
    )


class ExtendedKeyUsage1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    clientAuth: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.2. Officially described as "TLS WWW client authentication", though regularly used for non-WWW TLS.',
    )
    codeSigning: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.3. Officially described as "Signing of downloadable executable code client authentication".',
    )
    emailProtection: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.4. Officially described as "Email protection".',
    )
    ocspSigning: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.9. Officially described as "Signing OCSP responses".',
    )
    serverAuth: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.1. Officially described as "TLS WWW server authentication", though regularly used for non-WWW TLS.',
    )
    timeStamping: Optional[bool] = Field(
        None,
        description='Corresponds to OID 1.3.6.1.5.5.7.3.8. Officially described as "Binding the hash of an object to a time".',
    )


class GcsBucketRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Immutable. The name of a Cloud Storage bucket where this CertificateAuthority will publish content, such as the CA certificate and CRLs. This must be a bucket name, without any prefixes (such as `gs://`) or suffixes (such as `.googleapis.com`). For example, to use a bucket named `my-bucket`, you would simply specify `my-bucket`. If not specified, a managed bucket will be created.\n\nAllowed value: The Google Cloud resource name of a `StorageBucket` resource (format: `{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class GcsBucketRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Immutable. The name of a Cloud Storage bucket where this CertificateAuthority will publish content, such as the CA certificate and CRLs. This must be a bucket name, without any prefixes (such as `gs://`) or suffixes (such as `.googleapis.com`). For example, to use a bucket named `my-bucket`, you would simply specify `my-bucket`. If not specified, a managed bucket will be created.\n\nAllowed value: The Google Cloud resource name of a `StorageBucket` resource (format: `{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KeySpec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    algorithm: Optional[str] = Field(
        None,
        description='Immutable. The algorithm to use for creating a managed Cloud KMS key for a for a simplified experience. All managed keys will be have their ProtectionLevel as `HSM`. Possible values: RSA_PSS_2048_SHA256, RSA_PSS_3072_SHA256, RSA_PSS_4096_SHA256, RSA_PKCS1_2048_SHA256, RSA_PKCS1_3072_SHA256, RSA_PKCS1_4096_SHA256, EC_P256_SHA256, EC_P384_SHA384',
    )
    cloudKmsKeyVersionRef: Optional[
        Union[CloudKmsKeyVersionRef, CloudKmsKeyVersionRef1]
    ] = Field(None, description='Immutable.')


class KeyUsage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    baseKeyUsage: Optional[BaseKeyUsage] = Field(
        None,
        description='Immutable. Describes high-level ways in which a key may be used.',
    )
    extendedKeyUsage: Optional[ExtendedKeyUsage] = Field(
        None, description='Immutable. Detailed scenarios in which a key may be used.'
    )
    unknownExtendedKeyUsages: Optional[List[UnknownExtendedKeyUsage]] = Field(
        None,
        description='Immutable. Used to describe extended key usages that are not listed in the KeyUsage.ExtendedKeyUsageOptions message.',
    )


class KeyUsage1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    baseKeyUsage: Optional[BaseKeyUsage1] = Field(
        None, description='Describes high-level ways in which a key may be used.'
    )
    extendedKeyUsage: Optional[ExtendedKeyUsage1] = Field(
        None, description='Detailed scenarios in which a key may be used.'
    )
    unknownExtendedKeyUsages: Optional[List[UnknownExtendedKeyUsage1]] = Field(
        None,
        description='Used to describe extended key usages that are not listed in the KeyUsage.ExtendedKeyUsageOptions message.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ObjectId(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: List[int] = Field(
        ...,
        description='Immutable. Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class ObjectId2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: Optional[List[int]] = Field(
        None,
        description='Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class PemIssuerChain(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    pemCertificates: Optional[List[str]] = Field(
        None,
        description='Required. Expected to be in leaf-to-root order according to RFC 5246.',
    )


class PolicyId(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: List[int] = Field(
        ...,
        description='Immutable. Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class PolicyId1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: Optional[List[int]] = Field(
        None,
        description='Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class PublicKey(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    format: Optional[str] = Field(
        None, description='Required. The format of the public key. Possible values: PEM'
    )
    key: Optional[str] = Field(
        None,
        description='Required. A public key. The padding and encoding must match with the `KeyFormat` value specified for the `format` field.',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    caPoolRef: Union[CaPoolRef, CaPoolRef1] = Field(..., description='Immutable.')
    config: Config = Field(
        ...,
        description='Immutable. Required. Immutable. The config used to create a self-signed X.509 certificate or CSR.',
    )
    gcsBucketRef: Optional[Union[GcsBucketRef, GcsBucketRef1]] = Field(
        None, description='Immutable.'
    )
    keySpec: KeySpec = Field(
        ...,
        description='Immutable. Required. Immutable. Used when issuing certificates for this CertificateAuthority. If this CertificateAuthority is a self-signed CertificateAuthority, this key is also used to sign the self-signed CA certificate. Otherwise, it is used to sign a CSR.',
    )
    lifetime: str = Field(
        ...,
        description='Immutable. Required. The desired lifetime of the CA certificate. Used to create the "not_before_time" and "not_after_time" fields inside an X.509 certificate.',
    )
    location: str = Field(..., description='Immutable. The location for the resource')
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='Immutable. The Project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    type: str = Field(
        ...,
        description='Immutable. Required. Immutable. The Type of this CertificateAuthority. Possible values: SELF_SIGNED, SUBORDINATE',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    accessUrls: Optional[AccessUrls] = Field(
        None,
        description='Output only. URLs for accessing content published by this CA, such as the CA certificate and CRLs.',
    )
    caCertificateDescriptions: Optional[List[CaCertificateDescription]] = Field(
        None,
        description="Output only. A structured description of this CertificateAuthority's CA certificate and its issuers. Ordered as self-to-root.",
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    config: Optional[Config1] = None
    createTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. The time at which this CertificateAuthority was created.',
    )
    deleteTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. The time at which this CertificateAuthority was soft deleted, if it is in the DELETED state.',
    )
    expireTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. The time at which this CertificateAuthority will be permanently purged, if it is in the DELETED state.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    pemCaCertificates: Optional[List[str]] = Field(
        None,
        description="Output only. This CertificateAuthority's certificate chain, including the current CertificateAuthority's certificate. Ordered such that the root issuer is the final element (consistent with RFC 5246). For a self-signed CA, this will only list the current CertificateAuthority's certificate.",
    )
    state: Optional[str] = Field(
        None,
        description='Output only. The State for this CertificateAuthority. Possible values: ENABLED, DISABLED, STAGED, AWAITING_USER_ACTIVATION, DELETED',
    )
    subordinateConfig: Optional[SubordinateConfig] = Field(
        None,
        description='Optional. If this is a subordinate CertificateAuthority, this field will be set with the subordinate configuration, which describes its issuers. This may be updated, but this CertificateAuthority must continue to validate.',
    )
    tier: Optional[str] = Field(
        None,
        description='Output only. The CaPool.Tier of the CaPool that includes this CertificateAuthority. Possible values: ENTERPRISE, DEVOPS',
    )
    updateTime: Optional[AwareDatetime] = Field(
        None,
        description='Output only. The time at which this CertificateAuthority was last updated.',
    )


class Subject(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    commonName: Optional[str] = Field(
        None, description='Immutable. The "common name" of the subject.'
    )
    countryCode: Optional[str] = Field(
        None, description='Immutable. The country code of the subject.'
    )
    locality: Optional[str] = Field(
        None, description='Immutable. The locality or city of the subject.'
    )
    organization: Optional[str] = Field(
        None, description='Immutable. The organization of the subject.'
    )
    organizationalUnit: Optional[str] = Field(
        None, description='Immutable. The organizational_unit of the subject.'
    )
    postalCode: Optional[str] = Field(
        None, description='Immutable. The postal code of the subject.'
    )
    province: Optional[str] = Field(
        None,
        description='Immutable. The province, territory, or regional state of the subject.',
    )
    streetAddress: Optional[str] = Field(
        None, description='Immutable. The street address of the subject.'
    )


class Subject1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    commonName: Optional[str] = Field(
        None, description='The "common name" of the subject.'
    )
    countryCode: Optional[str] = Field(
        None, description='The country code of the subject.'
    )
    locality: Optional[str] = Field(
        None, description='The locality or city of the subject.'
    )
    organization: Optional[str] = Field(
        None, description='The organization of the subject.'
    )
    organizationalUnit: Optional[str] = Field(
        None, description='The organizational_unit of the subject.'
    )
    postalCode: Optional[str] = Field(
        None, description='The postal code of the subject.'
    )
    province: Optional[str] = Field(
        None, description='The province, territory, or regional state of the subject.'
    )
    streetAddress: Optional[str] = Field(
        None, description='The street address of the subject.'
    )


class SubjectAltName(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    customSans: Optional[List[CustomSan]] = Field(
        None,
        description='Immutable. Contains additional subject alternative name values.',
    )
    dnsNames: Optional[List[str]] = Field(
        None, description='Immutable. Contains only valid, fully-qualified host names.'
    )
    emailAddresses: Optional[List[str]] = Field(
        None, description='Immutable. Contains only valid RFC 2822 E-mail addresses.'
    )
    ipAddresses: Optional[List[str]] = Field(
        None,
        description='Immutable. Contains only valid 32-bit IPv4 addresses or RFC 4291 IPv6 addresses.',
    )
    uris: Optional[List[str]] = Field(
        None, description='Immutable. Contains only valid RFC 3986 URIs.'
    )


class SubjectAltName1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    customSans: Optional[List[CustomSan1]] = Field(
        None, description='Contains additional subject alternative name values.'
    )
    dnsNames: Optional[List[str]] = Field(
        None, description='Contains only valid, fully-qualified host names.'
    )
    emailAddresses: Optional[List[str]] = Field(
        None, description='Contains only valid RFC 2822 E-mail addresses.'
    )
    ipAddresses: Optional[List[str]] = Field(
        None,
        description='Contains only valid 32-bit IPv4 addresses or RFC 4291 IPv6 addresses.',
    )
    uris: Optional[List[str]] = Field(
        None, description='Contains only valid RFC 3986 URIs.'
    )


class SubjectConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    subject: Subject = Field(
        ...,
        description='Immutable. Required. Contains distinguished name fields such as the common name, location and organization.',
    )
    subjectAltName: Optional[SubjectAltName] = Field(
        None, description='Immutable. Optional. The subject alternative name fields.'
    )


class SubjectDescription(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hexSerialNumber: Optional[str] = Field(
        None, description='The serial number encoded in lowercase hexadecimal.'
    )
    lifetime: Optional[str] = Field(
        None,
        description='For convenience, the actual lifetime of an issued certificate.',
    )
    notAfterTime: Optional[AwareDatetime] = Field(
        None,
        description="The time after which the certificate is expired. Per RFC 5280, the validity period for a certificate is the period of time from not_before_time through not_after_time, inclusive. Corresponds to 'not_before_time' + 'lifetime' - 1 second.",
    )
    notBeforeTime: Optional[AwareDatetime] = Field(
        None, description='The time at which the certificate becomes valid.'
    )
    subject: Optional[Subject1] = Field(
        None,
        description='Contains distinguished name fields such as the common name, location and organization.',
    )
    subjectAltName: Optional[SubjectAltName1] = Field(
        None, description='The subject alternative name fields.'
    )


class SubjectKeyId(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    keyId: Optional[str] = Field(
        None,
        description='Optional. The value of this KeyId encoded in lowercase hexadecimal. This is most likely the 160 bit SHA-1 hash of the public key.',
    )


class SubordinateConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    certificateAuthority: Optional[str] = Field(
        None,
        description='Required. This can refer to a CertificateAuthority in the same project that was used to create a subordinate CertificateAuthority. This field is used for information and usability purposes only. The resource name is in the format `projects/*/locations/*/caPools/*/certificateAuthorities/*`.',
    )
    pemIssuerChain: Optional[PemIssuerChain] = Field(
        None,
        description='Required. Contains the PEM certificate chain for the issuers of this CertificateAuthority, but not pem certificate for this CA itself.',
    )


class UnknownExtendedKeyUsage(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: List[int] = Field(
        ...,
        description='Immutable. Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class UnknownExtendedKeyUsage1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    objectIdPath: Optional[List[int]] = Field(
        None,
        description='Required. The parts of an OID path. The most significant parts of the path come first.',
    )


class X509Config(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    additionalExtensions: Optional[List[AdditionalExtension]] = Field(
        None, description='Immutable. Optional. Describes custom X.509 extensions.'
    )
    caOptions: Optional[CaOptions] = Field(
        None,
        description='Immutable. Optional. Describes options in this X509Parameters that are relevant in a CA certificate.',
    )
    keyUsage: Optional[KeyUsage] = Field(
        None,
        description='Immutable. Optional. Indicates the intended use for keys that correspond to a certificate.',
    )
    policyIds: Optional[List[PolicyId]] = Field(
        None,
        description='Immutable. Optional. Describes the X.509 certificate policy object identifiers, per https://tools.ietf.org/html/rfc5280#section-4.2.1.4.',
    )


class X509Config1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    aiaOcspServers: Optional[List[str]] = Field(
        None,
        description='Optional. Describes Online Certificate Status Protocol (OCSP) endpoint addresses that appear in the "Authority Information Access" extension in the certificate.',
    )


class X509Description(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    additionalExtensions: Optional[List[AdditionalExtension1]] = Field(
        None, description='Optional. Describes custom X.509 extensions.'
    )
    aiaOcspServers: Optional[List[str]] = Field(
        None,
        description='Optional. Describes Online Certificate Status Protocol (OCSP) endpoint addresses that appear in the "Authority Information Access" extension in the certificate.',
    )
    caOptions: Optional[CaOptions1] = Field(
        None,
        description='Optional. Describes options in this X509Parameters that are relevant in a CA certificate.',
    )
    keyUsage: Optional[KeyUsage1] = Field(
        None,
        description='Optional. Indicates the intended use for keys that correspond to a certificate.',
    )
    policyIds: Optional[List[PolicyId1]] = Field(
        None,
        description='Optional. Describes the X.509 certificate policy object identifiers, per https://tools.ietf.org/html/rfc5280#section-4.2.1.4.',
    )
