# generated by datamodel-codegen:
#   filename:  pubsublitetopic_v1alpha1.json
#   timestamp: 2024-03-15T04:53:21+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Capacity(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    publishMibPerSec: int = Field(
        ...,
        description='Subscribe throughput capacity per partition in MiB/s. Must be >= 4 and <= 16.',
    )
    subscribeMibPerSec: int = Field(
        ...,
        description='Publish throughput capacity per partition in MiB/s. Must be >= 4 and <= 16.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class PartitionConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    capacity: Optional[Capacity] = Field(
        None, description='The capacity configuration.'
    )
    count: int = Field(
        ..., description='The number of partitions in the topic. Must be at least 1.'
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ReservationConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    throughputReservation: Optional[str] = Field(
        None, description="The Reservation to use for this topic's throughput capacity."
    )


class RetentionConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    perPartitionBytes: str = Field(
        ...,
        description="The provisioned storage, in bytes, per partition. If the number of bytes stored\nin any of the topic's partitions grows beyond this value, older messages will be\ndropped to make room for newer ones, regardless of the value of period.",
    )
    period: Optional[str] = Field(
        None,
        description='How long a published message is retained. If unset, messages will be retained as\nlong as the bytes retained for each partition is below perPartitionBytes. A\nduration in seconds with up to nine fractional digits, terminated by \'s\'.\nExample: "3.5s".',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    partitionConfig: Optional[PartitionConfig] = Field(
        None, description="The settings for this topic's partitions."
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    region: Optional[str] = Field(
        None, description='The region of the pubsub lite topic.'
    )
    reservationConfig: Optional[ReservationConfig] = Field(
        None, description="The settings for this topic's Reservation usage."
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    retentionConfig: Optional[RetentionConfig] = Field(
        None, description="The settings for a topic's message retention."
    )
    zone: str = Field(..., description='The zone of the pubsub lite topic.')


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
