# generated by datamodel-codegen:
#   filename:  recaptchaenterprisekey_v1beta1.json
#   timestamp: 2024-03-15T04:53:22+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import AwareDatetime, BaseModel, ConfigDict, Field


class AndroidSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowAllPackageNames: Optional[bool] = Field(
        None,
        description='If set to true, it means allowed_package_names will not be enforced.',
    )
    allowedPackageNames: Optional[List[str]] = Field(
        None,
        description="Android package names of apps allowed to use the key. Example: 'com.companyname.appname'",
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class IosSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowAllBundleIds: Optional[bool] = Field(
        None,
        description='If set to true, it means allowed_bundle_ids will not be enforced.',
    )
    allowedBundleIds: Optional[List[str]] = Field(
        None,
        description="iOS bundle ids of apps allowed to use the key. Example: 'com.companyname.productname.appname'",
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='The project for the resource\n\nAllowed value: The Google Cloud resource name of a `Project` resource (format: `projects/{{name}}`).',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    androidSettings: Optional[AndroidSettings] = Field(
        None, description='Settings for keys that can be used by Android apps.'
    )
    displayName: str = Field(
        ..., description='Human-readable display name of this key. Modifiable by user.'
    )
    iosSettings: Optional[IosSettings] = Field(
        None, description='Settings for keys that can be used by iOS apps.'
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='Immutable. The Project that this resource belongs to.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The service-generated name of the resource. Used for acquisition only. Leave unset to create a new resource.',
    )
    testingOptions: Optional[TestingOptions] = Field(
        None, description='Immutable. Options for user acceptance testing.'
    )
    webSettings: Optional[WebSettings] = Field(
        None, description='Settings for keys that can be used by websites.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[AwareDatetime] = Field(
        None, description='The timestamp corresponding to the creation of this Key.'
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )


class TestingOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    testingChallenge: Optional[str] = Field(
        None,
        description='Immutable. For challenge-based keys only (CHECKBOX, INVISIBLE), all challenge requests for this site will return nocaptcha if NOCAPTCHA, or an unsolvable challenge if UNSOLVABLE_CHALLENGE. Possible values: TESTING_CHALLENGE_UNSPECIFIED, NOCAPTCHA, UNSOLVABLE_CHALLENGE',
    )
    testingScore: Optional[float] = Field(
        None,
        description='Immutable. All assessments for this Key will return this score. Must be between 0 (likely not legitimate) and 1 (likely legitimate) inclusive.',
    )


class WebSettings(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allowAllDomains: Optional[bool] = Field(
        None,
        description='If set to true, it means allowed_domains will not be enforced.',
    )
    allowAmpTraffic: Optional[bool] = Field(
        None,
        description='If set to true, the key can be used on AMP (Accelerated Mobile Pages) websites. This is supported only for the SCORE integration type.',
    )
    allowedDomains: Optional[List[str]] = Field(
        None,
        description="Domains or subdomains of websites allowed to use the key. All subdomains of an allowed domain are automatically allowed. A valid domain requires a host and must not include any path, port, query or fragment. Examples: 'example.com' or 'subdomain.example.com'",
    )
    challengeSecurityPreference: Optional[str] = Field(
        None,
        description='Settings for the frequency and difficulty at which this key triggers captcha challenges. This should only be specified for IntegrationTypes CHECKBOX and INVISIBLE. Possible values: CHALLENGE_SECURITY_PREFERENCE_UNSPECIFIED, USABILITY, BALANCE, SECURITY',
    )
    integrationType: str = Field(
        ...,
        description='Immutable. Required. Describes how this key is integrated with the website. Possible values: SCORE, CHECKBOX, INVISIBLE',
    )
