# generated by datamodel-codegen:
#   filename:  redisinstance_v1beta1.json
#   timestamp: 2024-03-15T04:53:23+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AuthorizedNetworkRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class AuthorizedNetworkRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `ComputeNetwork` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class CustomerManagedKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class CustomerManagedKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class MaintenancePolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    createTime: Optional[str] = Field(
        None,
        description='Output only. The time when the policy was created.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond\nresolution and up to nine fractional digits.',
    )
    description: Optional[str] = Field(
        None,
        description='Optional. Description of what this policy is for.\nCreate/Update methods return INVALID_ARGUMENT if the\nlength is greater than 512.',
    )
    updateTime: Optional[str] = Field(
        None,
        description='Output only. The time when the policy was last updated.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond\nresolution and up to nine fractional digits.',
    )
    weeklyMaintenanceWindow: Optional[List[WeeklyMaintenanceWindowItem]] = Field(
        None,
        description='Optional. Maintenance window that is applied to resources covered by this policy.\nMinimum 1. For the current version, the maximum number\nof weekly_window is expected to be one.',
    )


class MaintenanceScheduleItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    endTime: Optional[str] = Field(
        None,
        description='Output only. The end time of any upcoming scheduled maintenance for this instance.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond\nresolution and up to nine fractional digits.',
    )
    scheduleDeadlineTime: Optional[str] = Field(
        None,
        description='Output only. The deadline that the maintenance schedule start time\ncan not go beyond, including reschedule.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond\nresolution and up to nine fractional digits.',
    )
    startTime: Optional[str] = Field(
        None,
        description='Output only. The start time of any upcoming scheduled maintenance for this instance.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond\nresolution and up to nine fractional digits.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Node(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Optional[str] = Field(
        None, description="Node identifying string. e.g. 'node-0', 'node-1'."
    )
    zone: Optional[str] = Field(None, description='Location of the node.')


class PersistenceConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    persistenceMode: Optional[str] = Field(
        None,
        description='Optional. Controls whether Persistence features are enabled. If not provided, the existing value will be used.\n\n- DISABLED: \tPersistence is disabled for the instance, and any existing snapshots are deleted.\n- RDB: RDB based Persistence is enabled. Possible values: ["DISABLED", "RDB"].',
    )
    rdbNextSnapshotTime: Optional[str] = Field(
        None,
        description='Output only. The next time that a snapshot attempt is scheduled to occur.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up\nto nine fractional digits.\nExamples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    rdbSnapshotPeriod: Optional[str] = Field(
        None,
        description='Optional. Available snapshot periods for scheduling.\n\n- ONE_HOUR:\tSnapshot every 1 hour.\n- SIX_HOURS:\tSnapshot every 6 hours.\n- TWELVE_HOURS:\tSnapshot every 12 hours.\n- TWENTY_FOUR_HOURS:\tSnapshot every 24 hours. Possible values: ["ONE_HOUR", "SIX_HOURS", "TWELVE_HOURS", "TWENTY_FOUR_HOURS"].',
    )
    rdbSnapshotStartTime: Optional[str] = Field(
        None,
        description='Optional. Date and time that the first snapshot was/will be attempted,\nand to which future snapshots will be aligned. If not provided,\nthe current time will be used.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution\nand up to nine fractional digits.\nExamples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )


class ServerCaCert(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    cert: Optional[str] = Field(None, description='The certificate data in PEM format.')
    createTime: Optional[str] = Field(
        None, description='The time when the certificate was created.'
    )
    expireTime: Optional[str] = Field(
        None, description='The time when the certificate expires.'
    )
    serialNumber: Optional[str] = Field(
        None, description='Serial number, as extracted from the certificate.'
    )
    sha1Fingerprint: Optional[str] = Field(
        None, description='Sha1 Fingerprint of the certificate.'
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    alternativeLocationId: Optional[str] = Field(
        None,
        description='Immutable. Only applicable to STANDARD_HA tier which protects the instance\nagainst zonal failures by provisioning it across two zones.\nIf provided, it must be a different zone from the one provided in\n[locationId].',
    )
    authEnabled: Optional[bool] = Field(
        None,
        description='Optional. Indicates whether OSS Redis AUTH is enabled for the\ninstance. If set to "true" AUTH is enabled on the instance.\nDefault value is "false" meaning AUTH is disabled.',
    )
    authString: Optional[str] = Field(
        None,
        description='Output only. AUTH String set on the instance. This field will only be populated if auth_enabled is true.',
    )
    authorizedNetworkRef: Optional[
        Union[AuthorizedNetworkRef, AuthorizedNetworkRef1]
    ] = Field(
        None,
        description='The network to which the instance is connected. If left\nunspecified, the default network will be used.',
    )
    connectMode: Optional[str] = Field(
        None,
        description='Immutable. The connection mode of the Redis instance. Default value: "DIRECT_PEERING" Possible values: ["DIRECT_PEERING", "PRIVATE_SERVICE_ACCESS"].',
    )
    customerManagedKeyRef: Optional[
        Union[CustomerManagedKeyRef, CustomerManagedKeyRef1]
    ] = Field(
        None,
        description='Immutable. Optional. The KMS key reference that you want to use to\nencrypt the data at rest for this Redis instance. If this is\nprovided, CMEK is enabled.',
    )
    displayName: Optional[str] = Field(
        None,
        description='An arbitrary and optional user-provided name for the instance.',
    )
    locationId: Optional[str] = Field(
        None,
        description='Immutable. The zone where the instance will be provisioned. If not provided,\nthe service will choose a zone for the instance. For STANDARD_HA tier,\ninstances will be created across two zones for protection against\nzonal failures. If [alternativeLocationId] is also provided, it must\nbe different from [locationId].',
    )
    maintenancePolicy: Optional[MaintenancePolicy] = Field(
        None, description='Maintenance policy for an instance.'
    )
    maintenanceSchedule: Optional[List[MaintenanceScheduleItem]] = Field(
        None, description='Upcoming maintenance schedule.'
    )
    memorySizeGb: int = Field(..., description='Redis memory size in GiB.')
    persistenceConfig: Optional[PersistenceConfig] = Field(
        None, description='Persistence configuration for an instance.'
    )
    readReplicasMode: Optional[str] = Field(
        None,
        description='Optional. Read replica mode. Can only be specified when trying to create the instance.\nIf not set, Memorystore Redis backend will default to READ_REPLICAS_DISABLED.\n- READ_REPLICAS_DISABLED: If disabled, read endpoint will not be provided and the\ninstance cannot scale up or down the number of replicas.\n- READ_REPLICAS_ENABLED: If enabled, read endpoint will be provided and the instance\ncan scale up and down the number of replicas. Possible values: ["READ_REPLICAS_DISABLED", "READ_REPLICAS_ENABLED"].',
    )
    redisConfigs: Optional[Dict[str, str]] = Field(
        None,
        description='Redis configuration parameters, according to http://redis.io/topics/config.\nPlease check Memorystore documentation for the list of supported parameters:\nhttps://cloud.google.com/memorystore/docs/redis/reference/rest/v1/projects.locations.instances#Instance.FIELDS.redis_configs.',
    )
    redisVersion: Optional[str] = Field(
        None,
        description='The version of Redis software. If not provided, latest supported\nversion will be used. Please check the API documentation linked\nat the top for the latest valid values.',
    )
    region: str = Field(
        ..., description='Immutable. The name of the Redis region of the instance.'
    )
    replicaCount: Optional[int] = Field(
        None,
        description='Optional. The number of replica nodes. The valid range for the Standard Tier with\nread replicas enabled is [1-5] and defaults to 2. If read replicas are not enabled\nfor a Standard Tier instance, the only valid value is 1 and the default is 1.\nThe valid value for basic tier is 0 and the default is also 0.',
    )
    reservedIpRange: Optional[str] = Field(
        None,
        description='Immutable. The CIDR range of internal addresses that are reserved for this\ninstance. If not provided, the service will choose an unused /29\nblock, for example, 10.0.0.0/29 or 192.168.0.0/29. Ranges must be\nunique and non-overlapping with existing subnets in an authorized\nnetwork.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The name of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    secondaryIpRange: Optional[str] = Field(
        None,
        description='Optional. Additional IP range for node placement. Required when enabling read replicas on\nan existing instance. For DIRECT_PEERING mode value must be a CIDR range of size /28, or\n"auto". For PRIVATE_SERVICE_ACCESS mode value must be the name of an allocated address\nrange associated with the private service access connection, or "auto".',
    )
    tier: Optional[str] = Field(
        None,
        description='Immutable. The service tier of the instance. Must be one of these values:\n\n- BASIC: standalone instance\n- STANDARD_HA: highly available primary/replica instances Default value: "BASIC" Possible values: ["BASIC", "STANDARD_HA"].',
    )
    transitEncryptionMode: Optional[str] = Field(
        None,
        description='Immutable. The TLS mode of the Redis instance, If not provided, TLS is disabled for the instance.\n\n- SERVER_AUTHENTICATION: Client to Server traffic encryption enabled with server authentication Default value: "DISABLED" Possible values: ["SERVER_AUTHENTICATION", "DISABLED"].',
    )


class StartTime(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hours: Optional[int] = Field(
        None,
        description='Hours of day in 24 hour format. Should be from 0 to 23.\nAn API may choose to allow the value "24:00:00" for scenarios like business closing time.',
    )
    minutes: Optional[int] = Field(
        None, description='Minutes of hour of day. Must be from 0 to 59.'
    )
    nanos: Optional[int] = Field(
        None,
        description='Fractions of seconds in nanoseconds. Must be from 0 to 999,999,999.',
    )
    seconds: Optional[int] = Field(
        None,
        description='Seconds of minutes of the time. Must normally be from 0 to 59.\nAn API may allow the value 60 if it allows leap-seconds.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None,
        description='The time the instance was created in RFC3339 UTC "Zulu" format,\naccurate to nanoseconds.',
    )
    currentLocationId: Optional[str] = Field(
        None,
        description='The current zone where the Redis endpoint is placed.\nFor Basic Tier instances, this will always be the same as the\n[locationId] provided by the user at creation time. For Standard Tier\ninstances, this can be either [locationId] or [alternativeLocationId]\nand can change after a failover event.',
    )
    host: Optional[str] = Field(
        None,
        description='Hostname or IP address of the exposed Redis endpoint used by clients\nto connect to the service.',
    )
    maintenanceSchedule: Optional[List[MaintenanceScheduleItem]] = Field(
        None, description='Upcoming maintenance schedule.'
    )
    nodes: Optional[List[Node]] = Field(None, description='Output only. Info per node.')
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    persistenceIamIdentity: Optional[str] = Field(
        None,
        description='Output only. Cloud IAM identity used by import / export operations\nto transfer data to/from Cloud Storage. Format is "serviceAccount:".\nThe value may change over time for a given instance so should be\nchecked before each import/export operation.',
    )
    port: Optional[int] = Field(
        None, description='The port number of the exposed Redis endpoint.'
    )
    readEndpoint: Optional[str] = Field(
        None,
        description="Output only. Hostname or IP address of the exposed readonly Redis endpoint. Standard tier only.\nTargets all healthy replica nodes in instance. Replication is asynchronous and replica nodes\nwill exhibit some lag behind the primary. Write requests must target 'host'.",
    )
    readEndpointPort: Optional[int] = Field(
        None,
        description="Output only. The port number of the exposed readonly redis endpoint. Standard tier only.\nWrite requests should target 'port'.",
    )
    serverCaCerts: Optional[List[ServerCaCert]] = Field(
        None, description='List of server CA certificates for the instance.'
    )


class WeeklyMaintenanceWindowItem(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    day: str = Field(
        ...,
        description='Required. The day of week that maintenance updates occur.\n\n- DAY_OF_WEEK_UNSPECIFIED: The day of the week is unspecified.\n- MONDAY: Monday\n- TUESDAY: Tuesday\n- WEDNESDAY: Wednesday\n- THURSDAY: Thursday\n- FRIDAY: Friday\n- SATURDAY: Saturday\n- SUNDAY: Sunday Possible values: ["DAY_OF_WEEK_UNSPECIFIED", "MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY", "SUNDAY"].',
    )
    duration: Optional[str] = Field(
        None,
        description='Output only. Duration of the maintenance window.\nThe current window is fixed at 1 hour.\nA duration in seconds with up to nine fractional digits,\nterminated by \'s\'. Example: "3.5s".',
    )
    startTime: StartTime = Field(
        ..., description='Required. Start time of the window in UTC time.'
    )
