# generated by datamodel-codegen:
#   filename:  resourcemanagerpolicy_v1beta1.json
#   timestamp: 2024-03-15T04:53:24+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Allow(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    all: Optional[bool] = Field(
        None, description='The policy allows or denies all values.'
    )
    values: Optional[List[str]] = Field(
        None,
        description='The policy can define specific values that are allowed or denied.',
    )


class BooleanPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enforced: bool = Field(
        ...,
        description='If true, then the Policy is enforced. If false, then any configuration is acceptable.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Deny(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    all: Optional[bool] = Field(
        None, description='The policy allows or denies all values.'
    )
    values: Optional[List[str]] = Field(
        None,
        description='The policy can define specific values that are allowed or denied.',
    )


class FolderRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Folder` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class FolderRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Folder` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ListPolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    allow: Optional[Allow] = Field(None, description='One or the other must be set.')
    deny: Optional[Deny] = Field(None, description='One or the other must be set.')
    inheritFromParent: Optional[bool] = Field(
        None,
        description='If set to true, the values from the effective Policy of the parent resource are inherited, meaning the values set in this Policy are added to the values inherited up the hierarchy.',
    )
    suggestedValue: Optional[str] = Field(
        None,
        description='The Google Cloud Console will try to default to a configuration that matches the value specified in this field.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class OrganizationRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of an `Organization` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class OrganizationRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of an `Organization` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class RestorePolicy(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    default: bool = Field(
        ...,
        description='May only be set to true. If set, then the default Policy is restored.',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    booleanPolicy: Optional[BooleanPolicy] = Field(
        None,
        description='A boolean policy is a constraint that is either enforced or not.',
    )
    constraint: str = Field(
        ...,
        description='Immutable. The name of the Constraint the Policy is configuring, for example, serviceuser.services.',
    )
    folderRef: Optional[Union[FolderRef, FolderRef1]] = Field(
        None,
        description='The folder on which to configure the constraint. Only one of\nprojectRef, folderRef, or organizationRef may be specified.',
    )
    listPolicy: Optional[ListPolicy] = Field(
        None,
        description='A policy that can define specific values that are allowed or denied for the given constraint. It can also be used to allow or deny all values. .',
    )
    organizationRef: Optional[Union[OrganizationRef, OrganizationRef1]] = Field(
        None,
        description='The organization on which to configure the constraint. Only one of\nprojectRef, folderRef, or organizationRef may be specified.',
    )
    projectRef: Optional[Union[ProjectRef, ProjectRef1]] = Field(
        None,
        description='The project on which to configure the constraint. Only one of\nprojectRef, folderRef, or organizationRef may be specified.',
    )
    restorePolicy: Optional[RestorePolicy] = Field(
        None,
        description='A restore policy is a constraint to restore the default policy.',
    )
    version: Optional[int] = Field(
        None, description='Version of the Policy. Default version is 0.'
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    etag: Optional[str] = Field(
        None,
        description='The etag of the organization policy. etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other.',
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    updateTime: Optional[str] = Field(
        None,
        description='The timestamp in RFC3339 UTC "Zulu" format, accurate to nanoseconds, representing when the variable was last updated. Example: "2016-10-09T12:33:37.578138407Z".',
    )
