# generated by datamodel-codegen:
#   filename:  secretmanagersecret_v1beta1.json
#   timestamp: 2024-03-15T04:53:25+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class Auto(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    customerManagedEncryption: Optional[CustomerManagedEncryption] = Field(
        None,
        description='The customer-managed encryption configuration of the Secret.\nIf no configuration is provided, Google-managed default\nencryption is used.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class CustomerManagedEncryption(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef, KmsKeyRef1] = Field(
        ...,
        description='The customer-managed encryption configuration of the Secret.\nIf no configuration is provided, Google-managed default\nencryption is used.',
    )


class CustomerManagedEncryption1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kmsKeyRef: Union[KmsKeyRef2, KmsKeyRef3] = Field(
        ..., description='Customer Managed Encryption for the secret.'
    )


class KmsKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class KmsKeyRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `selfLink` field of a `KMSCryptoKey` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class Replica(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    customerManagedEncryption: Optional[CustomerManagedEncryption1] = Field(
        None, description='Customer Managed Encryption for the secret.'
    )
    location: str = Field(
        ...,
        description='Immutable. The canonical IDs of the location to replicate data. For example: "us-east1".',
    )


class Replication(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    auto: Optional[Auto] = Field(
        None,
        description='The Secret will automatically be replicated without any restrictions.',
    )
    automatic: Optional[bool] = Field(
        None,
        description='DEPRECATED. `automatic` is deprecated. Use `auto` instead. The Secret will automatically be replicated without any restrictions.',
    )
    userManaged: Optional[UserManaged] = Field(
        None,
        description='Immutable. The Secret will be replicated to the regions specified by the user.',
    )


class Rotation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    nextRotationTime: Optional[str] = Field(
        None,
        description='Timestamp in UTC at which the Secret is scheduled to rotate.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    rotationPeriod: Optional[str] = Field(
        None,
        description="Immutable. The Duration between rotation notifications. Must be in seconds and at least 3600s (1h) and at most 3153600000s (100 years).\nIf rotationPeriod is set, 'next_rotation_time' must be set. 'next_rotation_time' will be advanced by this period when the service automatically sends rotation notifications.",
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    annotations: Optional[Dict[str, str]] = Field(
        None,
        description='Custom metadata about the secret.\n\nAnnotations are distinct from various forms of labels. Annotations exist to allow\nclient tools to store their own state information without requiring a database.\n\nAnnotation keys must be between 1 and 63 characters long, have a UTF-8 encoding of\nmaximum 128 bytes, begin and end with an alphanumeric character ([a-z0-9A-Z]), and\nmay have dashes (-), underscores (_), dots (.), and alphanumerics in between these\nsymbols.\n\nThe total size of annotation keys and values must be less than 16KiB.\n\nAn object containing a list of "key": value pairs. Example:\n{ "name": "wrench", "mass": "1.3kg", "count": "3" }.',
    )
    expireTime: Optional[str] = Field(
        None,
        description='Timestamp in UTC when the Secret is scheduled to expire. This is always provided on output, regardless of what was sent on input.\nA timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    replication: Replication = Field(
        ...,
        description='Immutable. The replication policy of the secret data attached to the Secret. It cannot be changed\nafter the Secret has been created.',
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The secretId of the resource. Used for creation and acquisition. When unset, the value of `metadata.name` is used as the default.',
    )
    rotation: Optional[Rotation] = Field(
        None,
        description="The rotation time and period for a Secret. At 'next_rotation_time', Secret Manager will send a Pub/Sub notification to the topics configured on the Secret. 'topics' must be set to configure rotation.",
    )
    topics: Optional[List[Topic]] = Field(
        None,
        description='A list of up to 10 Pub/Sub topics to which messages are published when control plane operations are called on the secret or its versions.',
    )
    ttl: Optional[str] = Field(
        None,
        description='Immutable. The TTL for the Secret.\nA duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    versionAliases: Optional[Dict[str, str]] = Field(
        None,
        description='Mapping from version alias to version name.\n\nA version alias is a string with a maximum length of 63 characters and can contain\nuppercase and lowercase letters, numerals, and the hyphen (-) and underscore (\'_\')\ncharacters. An alias string must start with a letter and cannot be the string\n\'latest\' or \'NEW\'. No more than 50 aliases can be assigned to a given secret.\n\nAn object containing a list of "key": value pairs. Example:\n{ "name": "wrench", "mass": "1.3kg", "count": "3" }.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None, description='The time at which the Secret was created.'
    )
    name: Optional[str] = Field(
        None,
        description="The resource name of the Secret. Format:\n'projects/{{project}}/secrets/{{secret_id}}'.",
    )
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )


class Topic(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    topicRef: Union[TopicRef, TopicRef1] = Field(
        ...,
        description='A list of up to 10 Pub/Sub topics to which messages are\npublished when control plane operations are called on the secret\nor its versions.',
    )


class TopicRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TopicRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class UserManaged(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    replicas: List[Replica] = Field(
        ...,
        description='Immutable. The list of Replicas for this Secret. Cannot be empty.',
    )
