# generated by datamodel-codegen:
#   filename:  storagetransferjob_v1beta1.json
#   timestamp: 2024-03-15T04:53:36+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AccessKeyId(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: str = Field(
        ...,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: Optional[ValueFrom] = Field(
        None,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class AccessKeyId1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: Optional[str] = Field(
        None,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: ValueFrom1 = Field(
        ...,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class AwsAccessKey(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    accessKeyId: Union[AccessKeyId, AccessKeyId1] = Field(
        ..., description='AWS Key ID.'
    )
    secretAccessKey: Union[SecretAccessKey, SecretAccessKey1] = Field(
        ..., description='AWS Secret Access Key.'
    )


class AwsS3DataSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    awsAccessKey: Optional[AwsAccessKey] = Field(
        None, description='AWS credentials block.'
    )
    bucketName: str = Field(..., description='S3 Bucket name.')
    path: Optional[str] = Field(
        None, description='S3 Bucket path in bucket to transfer.'
    )
    roleArn: Optional[str] = Field(
        None,
        description="The Amazon Resource Name (ARN) of the role to support temporary credentials via 'AssumeRoleWithWebIdentity'. For more information about ARNs, see [IAM ARNs](https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_identifiers.html#identifiers-arns). When a role ARN is provided, Transfer Service fetches temporary credentials for the session using a 'AssumeRoleWithWebIdentity' call for the provided role using the [GoogleServiceAccount][] for this project.",
    )


class AzureBlobStorageDataSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    azureCredentials: AzureCredentials = Field(
        ..., description=' Credentials used to authenticate API requests to Azure.'
    )
    container: str = Field(
        ..., description='The container to transfer from the Azure Storage account.'
    )
    path: Optional[str] = Field(
        None,
        description="Root path to transfer objects. Must be an empty string or full path name that ends with a '/'. This field is treated as an object prefix. As such, it should generally not begin with a '/'.",
    )
    storageAccount: str = Field(
        ..., description='The name of the Azure Storage account.'
    )


class AzureCredentials(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    sasToken: Union[SasToken, SasToken1] = Field(
        ..., description='Azure shared access signature.'
    )


class BucketRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BucketRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BucketRef2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class BucketRef3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: The `name` field of a `StorageBucket` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class GcsDataSink(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bucketRef: Union[BucketRef, BucketRef1]
    path: Optional[str] = Field(
        None, description='Google Cloud Storage path in bucket to transfer.'
    )


class GcsDataSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bucketRef: Union[BucketRef2, BucketRef3]
    path: Optional[str] = Field(
        None, description='Google Cloud Storage path in bucket to transfer.'
    )


class HttpDataSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    listUrl: str = Field(
        ...,
        description='The URL that points to the file that stores the object list entries. This file must allow public access. Currently, only URLs with HTTP and HTTPS schemes are supported.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class NotificationConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    eventTypes: Optional[List[str]] = Field(
        None,
        description='Event types for which a notification is desired. If empty, send notifications for all event types. The valid types are "TRANSFER_OPERATION_SUCCESS", "TRANSFER_OPERATION_FAILED", "TRANSFER_OPERATION_ABORTED".',
    )
    payloadFormat: str = Field(
        ...,
        description='The desired format of the notification message payloads. One of "NONE" or "JSON".',
    )
    topicRef: Union[TopicRef, TopicRef1] = Field(
        ..., description='The PubSubTopic to which to publish notifications.'
    )


class ObjectConditions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    excludePrefixes: Optional[List[str]] = Field(
        None,
        description='exclude_prefixes must follow the requirements described for include_prefixes.',
    )
    includePrefixes: Optional[List[str]] = Field(
        None,
        description='If include_refixes is specified, objects that satisfy the object conditions must have names that start with one of the include_prefixes and that do not start with any of the exclude_prefixes. If include_prefixes is not specified, all objects except those that have names starting with one of the exclude_prefixes must satisfy the object conditions.',
    )
    lastModifiedBefore: Optional[str] = Field(
        None,
        description='If specified, only objects with a "last modification time" before this timestamp and objects that don\'t have a "last modification time" are transferred. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    lastModifiedSince: Optional[str] = Field(
        None,
        description='If specified, only objects with a "last modification time" on or after this timestamp and objects that don\'t have a "last modification time" are transferred. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z".',
    )
    maxTimeElapsedSinceLastModification: Optional[str] = Field(
        None,
        description='A duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    minTimeElapsedSinceLastModification: Optional[str] = Field(
        None,
        description='A duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )


class PosixDataSink(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    rootDirectory: str = Field(
        ..., description='Root directory path to the filesystem.'
    )


class PosixDataSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    rootDirectory: str = Field(
        ..., description='Root directory path to the filesystem.'
    )


class SasToken(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: str = Field(
        ...,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: Optional[ValueFrom4] = Field(
        None,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class SasToken1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: Optional[str] = Field(
        None,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: ValueFrom5 = Field(
        ...,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class Schedule(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    repeatInterval: Optional[str] = Field(
        None,
        description='Interval between the start of each scheduled transfer. If unspecified, the default value is 24 hours. This value may not be less than 1 hour. A duration in seconds with up to nine fractional digits, terminated by \'s\'. Example: "3.5s".',
    )
    scheduleEndDate: Optional[ScheduleEndDate] = Field(
        None,
        description='The last day the recurring transfer will be run. If schedule_end_date is the same as schedule_start_date, the transfer will be executed only once.',
    )
    scheduleStartDate: ScheduleStartDate = Field(
        ...,
        description='The first day the recurring transfer is scheduled to run. If schedule_start_date is in the past, the transfer will run for the first time on the following day.',
    )
    startTimeOfDay: Optional[StartTimeOfDay] = Field(
        None,
        description="The time in UTC at which the transfer will be scheduled to start in a day. Transfers may start later than this time. If not specified, recurring and one-time transfers that are scheduled to run today will run immediately; recurring transfers that are scheduled to run on a future date will start at approximately midnight UTC on that date. Note that when configuring a transfer with the Cloud Platform Console, the transfer's start time in a day is specified in your local timezone.",
    )


class ScheduleEndDate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    day: int = Field(
        ...,
        description='Day of month. Must be from 1 to 31 and valid for the year and month.',
    )
    month: int = Field(..., description='Month of year. Must be from 1 to 12.')
    year: int = Field(..., description='Year of date. Must be from 1 to 9999.')


class ScheduleStartDate(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    day: int = Field(
        ...,
        description='Day of month. Must be from 1 to 31 and valid for the year and month.',
    )
    month: int = Field(..., description='Month of year. Must be from 1 to 12.')
    year: int = Field(..., description='Year of date. Must be from 1 to 9999.')


class SecretAccessKey(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: str = Field(
        ...,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: Optional[ValueFrom2] = Field(
        None,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class SecretAccessKey1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    value: Optional[str] = Field(
        None,
        description="Value of the field. Cannot be used if 'valueFrom' is specified.",
    )
    valueFrom: ValueFrom3 = Field(
        ...,
        description="Source for the field's value. Cannot be used if 'value' is specified.",
    )


class SecretKeyRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    key: str = Field(..., description='Key that identifies the value to be extracted.')
    name: str = Field(..., description='Name of the Secret to extract a value from.')


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: str = Field(
        ..., description='Unique description to identify the Transfer Job.'
    )
    notificationConfig: Optional[NotificationConfig] = Field(
        None, description='Notification configuration.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The service-generated name of the resource. Used for acquisition only. Leave unset to create a new resource.',
    )
    schedule: Optional[Schedule] = Field(
        None,
        description='Schedule specification defining when the Transfer Job should be scheduled to start, end and what time to run.',
    )
    status: Optional[str] = Field(
        None,
        description='Status of the job. Default: ENABLED. NOTE: The effect of the new job status takes place during a subsequent job run. For example, if you change the job status from ENABLED to DISABLED, and an operation spawned by the transfer is running, the status change would not affect the current operation.',
    )
    transferSpec: TransferSpec = Field(..., description='Transfer specification.')


class StartTimeOfDay(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    hours: int = Field(
        ..., description='Hours of day in 24 hour format. Should be from 0 to 23.'
    )
    minutes: int = Field(
        ..., description='Minutes of hour of day. Must be from 0 to 59.'
    )
    nanos: int = Field(
        ...,
        description='Fractions of seconds in nanoseconds. Must be from 0 to 999,999,999.',
    )
    seconds: int = Field(
        ...,
        description='Seconds of minutes of the time. Must normally be from 0 to 59.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    creationTime: Optional[str] = Field(
        None, description='When the Transfer Job was created.'
    )
    deletionTime: Optional[str] = Field(
        None, description='When the Transfer Job was deleted.'
    )
    lastModificationTime: Optional[str] = Field(
        None, description='When the Transfer Job was last modified.'
    )
    name: Optional[str] = Field(None, description='The name of the Transfer Job.')
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )


class TopicRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TopicRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ...,
        description='Allowed value: string of the format `projects/{{project}}/topics/{{value}}`, where {{value}} is the `name` field of a `PubSubTopic` resource.',
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class TransferOptions(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deleteObjectsFromSourceAfterTransfer: Optional[bool] = Field(
        None,
        description='Whether objects should be deleted from the source after they are transferred to the sink. Note that this option and delete_objects_unique_in_sink are mutually exclusive.',
    )
    deleteObjectsUniqueInSink: Optional[bool] = Field(
        None,
        description='Whether objects that exist only in the sink should be deleted. Note that this option and delete_objects_from_source_after_transfer are mutually exclusive.',
    )
    overwriteObjectsAlreadyExistingInSink: Optional[bool] = Field(
        None,
        description='Whether overwriting objects that already exist in the sink is allowed.',
    )
    overwriteWhen: Optional[str] = Field(
        None,
        description='When to overwrite objects that already exist in the sink. If not set, overwrite behavior is determined by overwriteObjectsAlreadyExistingInSink.',
    )


class TransferSpec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    awsS3DataSource: Optional[AwsS3DataSource] = Field(
        None, description='An AWS S3 data source.'
    )
    azureBlobStorageDataSource: Optional[AzureBlobStorageDataSource] = Field(
        None, description='An Azure Blob Storage data source.'
    )
    gcsDataSink: Optional[GcsDataSink] = Field(
        None, description='A Google Cloud Storage data sink.'
    )
    gcsDataSource: Optional[GcsDataSource] = Field(
        None, description='A Google Cloud Storage data source.'
    )
    httpDataSource: Optional[HttpDataSource] = Field(
        None, description='A HTTP URL data source.'
    )
    objectConditions: Optional[ObjectConditions] = Field(
        None,
        description="Only objects that satisfy these object conditions are included in the set of data source and data sink objects. Object conditions based on objects' last_modification_time do not exclude objects in a data sink.",
    )
    posixDataSink: Optional[PosixDataSink] = Field(
        None, description='A POSIX filesystem data sink.'
    )
    posixDataSource: Optional[PosixDataSource] = Field(
        None, description='A POSIX filesystem data source.'
    )
    sinkAgentPoolName: Optional[str] = Field(
        None,
        description='Immutable. Specifies the agent pool name associated with the posix data source. When unspecified, the default name is used.',
    )
    sourceAgentPoolName: Optional[str] = Field(
        None,
        description='Immutable. Specifies the agent pool name associated with the posix data source. When unspecified, the default name is used.',
    )
    transferOptions: Optional[TransferOptions] = Field(
        None,
        description="Characteristics of how to treat files from datasource and sink during job. If the option delete_objects_unique_in_sink is true, object conditions based on objects' last_modification_time are ignored and do not exclude objects in a data source or a data sink.",
    )


class ValueFrom(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )


class ValueFrom5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    secretKeyRef: Optional[SecretKeyRef] = Field(
        None,
        description="Reference to a value with the given key in the given Secret in the resource's namespace.",
    )
