# generated by datamodel-codegen:
#   filename:  vertexaiindex_v1alpha1.json
#   timestamp: 2024-03-15T04:53:40+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict, Field


class AlgorithmConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    bruteForceConfig: Optional[Dict[str, Any]] = Field(
        None,
        description='Configuration options for using brute force search, which simply implements the\nstandard linear search in the database for each query.',
    )
    treeAhConfig: Optional[TreeAhConfig] = Field(
        None,
        description='Configuration options for using the tree-AH algorithm (Shallow tree + Asymmetric Hashing).\nPlease refer to this paper for more details: https://arxiv.org/abs/1908.10396.',
    )


class Condition(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    lastTransitionTime: Optional[str] = Field(
        None,
        description='Last time the condition transitioned from one status to another.',
    )
    message: Optional[str] = Field(
        None,
        description='Human-readable message indicating details about last transition.',
    )
    reason: Optional[str] = Field(
        None,
        description="Unique, one-word, CamelCase reason for the condition's last transition.",
    )
    status: Optional[str] = Field(
        None,
        description='Status is the status of the condition. Can be True, False, Unknown.',
    )
    type: Optional[str] = Field(None, description='Type is the type of the condition.')


class Config(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    algorithmConfig: Optional[AlgorithmConfig] = Field(
        None,
        description='The configuration with regard to the algorithms used for efficient search.',
    )
    approximateNeighborsCount: Optional[int] = Field(
        None,
        description='The default number of neighbors to find via approximate search before exact reordering is\nperformed. Exact reordering is a procedure where results returned by an\napproximate search algorithm are reordered via a more expensive distance computation.\nRequired if tree-AH algorithm is used.',
    )
    dimensions: int = Field(
        ..., description='The number of dimensions of the input vectors.'
    )
    distanceMeasureType: Optional[str] = Field(
        None,
        description='The distance measure used in nearest neighbor search. The value must be one of the followings:\n* SQUARED_L2_DISTANCE: Euclidean (L_2) Distance\n* L1_DISTANCE: Manhattan (L_1) Distance\n* COSINE_DISTANCE: Cosine Distance. Defined as 1 - cosine similarity.\n* DOT_PRODUCT_DISTANCE: Dot Product Distance. Defined as a negative of the dot product.',
    )
    featureNormType: Optional[str] = Field(
        None,
        description='Type of normalization to be carried out on each vector. The value must be one of the followings:\n* UNIT_L2_NORM: Unit L2 normalization type\n* NONE: No normalization type is specified.',
    )
    shardSize: Optional[str] = Field(
        None,
        description='Immutable. Index data is split into equal parts to be processed. These are called "shards".\nThe shard size must be specified when creating an index. The value must be one of the followings:\n* SHARD_SIZE_SMALL: Small (2GB)\n* SHARD_SIZE_MEDIUM: Medium (20GB)\n* SHARD_SIZE_LARGE: Large (50GB).',
    )


class DeployedIndex(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deployedIndexId: Optional[str] = Field(
        None, description='The ID of the DeployedIndex in the above IndexEndpoint.'
    )
    indexEndpoint: Optional[str] = Field(
        None, description='A resource name of the IndexEndpoint.'
    )


class IndexStat(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    shardsCount: Optional[int] = Field(
        None, description='The number of shards in the Index.'
    )
    vectorsCount: Optional[str] = Field(
        None, description='The number of vectors in the Index.'
    )


class Metadata(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    config: Optional[Config] = Field(
        None, description='Immutable. The configuration of the Matching Engine Index.'
    )
    contentsDeltaUri: Optional[str] = Field(
        None,
        description='Allows inserting, updating  or deleting the contents of the Matching Engine Index.\nThe string must be a valid Cloud Storage directory path. If this\nfield is set when calling IndexService.UpdateIndex, then no other\nIndex field can be also updated as part of the same call.\nThe expected structure and format of the files this URI points to is\ndescribed at https://cloud.google.com/vertex-ai/docs/matching-engine/using-matching-engine#input-data-format.',
    )
    isCompleteOverwrite: Optional[bool] = Field(
        None,
        description='If this field is set together with contentsDeltaUri when calling IndexService.UpdateIndex,\nthen existing content of the Index will be replaced by the data from the contentsDeltaUri.',
    )


class Model(BaseModel):
    apiVersion: Optional[str] = Field(
        None,
        description='apiVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        None,
        description='kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Spec
    status: Optional[Status] = None


class ProjectRef(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: Optional[str] = Field(
        None, description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: str = Field(
        ...,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class ProjectRef1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    external: str = Field(
        ..., description='Allowed value: The `name` field of a `Project` resource.'
    )
    name: Optional[str] = Field(
        None,
        description='Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names',
    )
    namespace: Optional[str] = Field(
        None,
        description='Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/',
    )


class Spec(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[str] = Field(
        None, description='The description of the Index.'
    )
    displayName: str = Field(
        ...,
        description='The display name of the Index. The name can be up to 128 characters long and can consist of any UTF-8 characters.',
    )
    indexUpdateMethod: Optional[str] = Field(
        None,
        description='Immutable. The update method to use with this Index. The value must be the followings. If not set, BATCH_UPDATE will be used by default.\n* BATCH_UPDATE: user can call indexes.patch with files on Cloud Storage of datapoints to update.\n* STREAM_UPDATE: user can call indexes.upsertDatapoints/DeleteDatapoints to update the Index and the updates will be applied in corresponding DeployedIndexes in nearly real-time.',
    )
    metadata: Optional[Metadata] = Field(
        None, description='An additional information about the Index.'
    )
    projectRef: Union[ProjectRef, ProjectRef1] = Field(
        ..., description='The project that this resource belongs to.'
    )
    region: str = Field(
        ..., description='Immutable. The region of the index. eg us-central1.'
    )
    resourceID: Optional[str] = Field(
        None,
        description='Immutable. Optional. The service-generated name of the resource. Used for acquisition only. Leave unset to create a new resource.',
    )


class Status(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description="Conditions represent the latest available observation of the resource's current state.",
    )
    createTime: Optional[str] = Field(
        None,
        description='The timestamp of when the Index was created in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits.',
    )
    deployedIndexes: Optional[List[DeployedIndex]] = Field(
        None,
        description='The pointers to DeployedIndexes created from this Index. An Index can be only deleted if all its DeployedIndexes had been undeployed first.',
    )
    etag: Optional[str] = Field(
        None, description='Used to perform consistent read-modify-write updates.'
    )
    indexStats: Optional[List[IndexStat]] = Field(
        None, description='Stats of the index resource.'
    )
    metadataSchemaUri: Optional[str] = Field(
        None,
        description='Points to a YAML file stored on Google Cloud Storage describing additional information about the Index, that is specific to it. Unset if the Index does not have any additional information.',
    )
    name: Optional[str] = Field(None, description='The resource name of the Index.')
    observedGeneration: Optional[int] = Field(
        None,
        description='ObservedGeneration is the generation of the resource that was most recently observed by the Config Connector controller. If this is equal to metadata.generation, then that means that the current reported status reflects the most recent desired state of the resource.',
    )
    updateTime: Optional[str] = Field(
        None,
        description='The timestamp of when the Index was last updated in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits.',
    )


class TreeAhConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    leafNodeEmbeddingCount: Optional[int] = Field(
        None,
        description='Number of embeddings on each leaf node. The default value is 1000 if not set.',
    )
    leafNodesToSearchPercent: Optional[int] = Field(
        None,
        description='The default percentage of leaf nodes that any query may be searched. Must be in\nrange 1-100, inclusive. The default value is 10 (means 10%) if not set.',
    )
